#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <cmath>
#include <limits>
#include "lcgamm.h"
using namespace std;

float gcf(const float a, const float x);
float gammln2(const float xx);

int main() {
  float a, x;
  a = 4489216; x = 4500000;
  printf("gcf(%f, %f) = %f\n", a, x, gcf(a, x));
  printf("lcgf(%f, %f) = %f\n", a, x, lcgf((double)a, (double)x));
} 

float gammln2(const float a) 
{
	double x,y,tmp,ser;
	static double cof[6]={76.18009172947146,-86.50532032941677,
                        24.01409824083091,-1.231739572450155,
                        0.1208650973866179e-2,-0.5395239384953e-5};

	int j;
	y=x=a;
	tmp=x+5.5;
	tmp -= (x+0.5)*log(tmp);
        ser=1.000000000190015;
	for (j=0;j<=5;j++) ser += cof[j]/++y;
        return (float)(-tmp+log(2.5066282746310005*ser/x));
}

float gcf(const float a, const float x) 
{
	int i;
	float an, b, c, d, del, h, gln=gammln2(a);
	const int ITMAX = 1000;
	const float EPS = 1.0e-35;
	const float FPMIN = 1.0e-35;
	// const float EPS=numeric_limits<float>::epsilon();
	// const float FPMIN=numeric_limits<float>::min()/EPS;
	printf("%f\n", log(numeric_limits<float>::epsilon()) / log(10));

	b=x+1.0f-a;
	c=1.0f/FPMIN;
	d=1.0f/b;
	h=d;
	for(i=1; i<=ITMAX;i++) {
	  an = -i*(i-a);
	  b += 2.0f;
	  d = an*d+b;
	  if(fabs(d) < FPMIN) d = FPMIN;
	  c = b+an/c;
	  if(fabs(c) < FPMIN) c=FPMIN;
	  d=1.0/d;
	  del=d*c;
	  h *= del;
	  if (fabs(del-1.0) <= EPS) break;
	}
	if(i > ITMAX) printf("a too large, ITMAX too small in gcf\n");
	double logh = log(h);
        double logx = log(x);
	double result = (logh-x+a*logx-gln);
	return (float) (logh-x+a*logx-gln);
}
