/*
 *	include file for AO messages
 *	aoMsg's are message queues that also contain some monitoring info.
 *	
 *	note: this file is still being created. eventually these should
 *	replace aoQ`s for sending messages between vxWorks programs.
 *
 * history:
 * 7/23/92 - removed stdioLib.h from .h file . it's in the source.
 * 4/20/92 - add chkstop routine to routines that waited on semaphore
 * 4/8/92  - added more monitorying info
 * 3/25/92 - added monitor info to queue
*/
#ifndef INCaoq
#define INCaoq
#include	<semLib.h>
#include 	<lstLib.h>
#include	<stdioLib.h>
#include	"aoErrNum.h"	
/*
 *	ao error messages
*/
/*
#define S_aoqLib_NOMEM_Q                       (aoM_aoqLib | 1)
#define S_aoqLib_NOMEM_SEM                     (aoM_aoqLib | 2)
#define S_aoqLib_BAD_MSGQPTR_REMOVE               (aoM_aoqLib | 3)
#define S_aoqLib_MSGQNEMPTY_REMOVE                (aoM_aoqLib | 5)
#define S_aoqLib_BAD_SEMID_REMOVE              (aoM_aoqLib | 6)
#define S_aoqLib_MXSEM_TIMEOUT                 (aoM_aoqLib | 7)
#define S_aoqLib_EMPSEM_TIMEOUT                (aoM_aoqLib | 8)
*/

typedef	struct {
	MSG_Q_ID  msgQID;	/* msgQ id for vxWorks*/
/*
 * 	the following is for monitoring of message queues
*/
	int	maxBytesMsg;	/* max bytes message*/
	int	maxNumMsgs;	/* max message we can have in queue*/
        char    msgQName[8];       /* upto 8 characters...*/
	int     m_numputs;	/* total number successfu puts to queue*/	
	int	m_numgets;	/* total number successful gets from queue*/
	int	m_numgetsempty; /* number gets but timed out waiting*/
	int	m_maxnum;	/* max number msg queue has held*/
	int	m_curnum;	/* current number msgs in queue*/
	}  AOMSGQ;

typedef struct {
	int	    cmd;		/* cmd for message*/
	int	    msgNumber;		/* message number*/
	int	    rspToNumber;	/* if > 0  response for this msgNumber*/
	AOMSGQ_PTR  paoMsgQSnder;       /* sender of message*/
	int	    bytesData;		/* data starts next location*/
	} AOMSG_HDR;
	                                /* usually next location*/
	

typedef	AOMSGQ   *AOMSGQ_PTR;
/*
 * 	prototypes for functions
*/
STATUS  	aoMsgQGlInit(void);
AOMSGQ_PTR 	aoMsgQInit(char *msgQName,int maxNumMsg,int maxLenMsg,
			   int fifoOrder);
VOID		aoMsgQInfo(FILE *fp,AOMSG_PTR paoMsg);
STATUS   	aoMsgQSndMsg(AOMSG_PTR paoMsg,int bytesToSnd,char *msg,
			char *FUNCPTR chkstop,int chktimeout);
int     	aoMsgQRcvMsg(AOMSG_PTR paoMsg,int maxLenbuf,char *buf,
			    FUNCPTR chkstop,
                           int chktimeout);
STATUS  	aoMsgQRemove(AOQMSGQ_PTR paoMsgQ);
#endif	/*INCaoq*/  
