#ifndef INCagcMonh
#define INCagcMonh
/*
* include file for agcMon. declares shared memory format
*history..
*/
#include	"vtxLib.h"

#define		AGCSHMON_SHMKEY		0x100
#define		AGCSHMON_SEMKEY		0x100

/*
 * status set by master
*/
#define	   AGCSHMON_STAT_EXIT        0 
#define	   AGCSHMON_STAT_OK          1 
#define	   AGCSHMON_STAT_STARTUP     2 
#define	   AGCSHMON_STAT_CONNECTING  3
#define	   AGCSHMON_STAT_LBLOOP      4
#define	   AGCSHMON_STAT_READTIMEOUT 5
#define	   AGCSHMON_STAT_LAST        5

#define    AGCSHMON_MAX_NUM_SEMS    10

/*	typedefs		*/

typedef struct {
	VTX_CBLK	cblk;
	VTX_FBLK	fblk;
	} AGC_SHM_CBFB_BLK;

/*
 * free list for semaphores
*/
typedef struct {
	int		semNum;  			/* semaphore number*/
	int		pid;				/* processin use or -1*/
	} AGC_SHM_SEM_FL;


typedef struct	{
	int				status;			/* of master*/
	int			    lastBootLooping;/* != 0 --> loop count*/
	int				maxNumSems;
	AGC_SHM_SEM_FL  semFl[AGCSHMON_MAX_NUM_SEMS];
	int				curCbFbBlkOff;  /* bytes offset, start of shared mem*/
#if FALSE
	AGC_SHM_CBFB_BLK	*pcurCbFbBlk;	/* pnt to current data*/
#endif
	} AGC_SHM_DATA;

/*
 * structure filled in when attaching to shared memory and semaphore
*/
typedef struct {
	AGC_SHM_DATA	*pshm;			/* ptr to shared memory*/
	int			    shmId;			/* shared memory id*/
	int			    semId;			/* semaphore id*/
	int				semNum;			/* 0 thru max -1*/
	} AGC_MON_ACCESS;

/*
 * 	prototypes that should be in vtxLib.h but cause a circular definition
*/
STATUS  agcMonCon(AGC_MON_ACCESS *paccess);
STATUS  agcMonWait(AGC_MON_ACCESS *paccess,AGC_SHM_CBFB_BLK **pdata);
#endif
