#ifndef INCaoMsgh
#define INCaoMsgh
/*aoMsg.h - include file for aoMsg definition		*/
/*
* history:
* xx.x  20apr95  - created
*/
/*
* DESCRIPTION
* definition of ao messages. they are passed via sockets and 
* vxWorks messages queues.
*/
#ifdef	VXWORKS
#include	<vxWorks.h>
#include        <msgQLib.h>
#include        <semLib.h>
#else
#include	<vxWorksEm.h>
typedef void * AOMSG_Q_ID;
#endif
#include	<stdio.h>

/*	defines		*/
 
/*	portnumber for aoMsgGWIn program on vxWorks	*/

#define	AOM_GWIN_PORTNUM	6543

/*	max args in aoMsg		*/

#define  AOM_MAX_ARGS		5

/*	load in to or from in_addr, aomsgqid	*/

#define AOM_NO_IP_ADR           0
#define AOM_NO_MSGQ_ADR         NULL

/*	load into dataType
 * values are:
 *    DATA_NONE		no extra data to send
 *    DATA_STACK   	data is from the stack, we must malloc some more
 *    DATA_MALLOC       we've malloced the data
 *    DATA_STATIC       buffer is permanent don't delete.
 *    DATA_BUFPOOL      pdata points to a bufPool node.
*/


#define AOM_DATA_NONE            0
#define AOM_DATA_STACK           1
#define AOM_DATA_MALLOC          2
#define AOM_DATA_STATIC          3
#define AOM_DATA_BUFPOOL         4

/*	sync values for header			*/

#define AOMSG_SYN1       123456789
#define AOMSG_SYN2       987654321
 
/*
 * handy macros
*/
#define	AOM_COPY_ADR(to,from) memcpy((char*)(to),(char*)(from),sizeof(AOM_ADR))
#define	AOM_COPY_ARGS(to,from,numargs) memcpy((char*)(to),(char*)(from),(numargs)*sizeof(int))

/*	typedefs		 	*/

#ifdef	VXWORKS
/*
 *	aoMsg_Q's hold messages on vxWorks. We need to define it
 *	here first since the aoMsg address holds a Q. For sun
 *	the Q's are commented out
*/
 
typedef struct { 
        MSG_Q_ID msgQId;        /* id for message Queue*/
        SEM_ID  mxSemId;        /* to use when updating numbers for msg Q*/
/*
 *      the following is for monitoring of queue
*/
        char    qname[8];       /* upto 8 characters...*/
        int     m_totPutsQ;     /* total number successfu sends to queue*/
        int     m_maxQHasHeld;  /* max number msg's queue has had*/
        int     m_maxQCanHold;  /* max number msg's queue can have*/
        int     m_curNumInQ;    /* current numberin queue*/
        int     m_timeouts;     /* timeouts waiting on this queue*/
        }  AOMSG_Q;
 
typedef AOMSG_Q    *AOMSG_Q_ID;

#endif
/*
 *	hold an addres for aoMsg's 
 *	 
 *  for addressing:
 *     in_addr   - holds the ip address for the destination
 *     portNum   - holds the portNumber. If portNum -- 6543 then we know that
 *	           this is coming or going to a vxWorks copy of the gateway
 *		   program,
 *     aoMsgQId  - when moving messages between programs within one cpu
 *	           this tells the msgQ that should receive the message.
 *     prgId     - When sending messages between cpus, this is used instead
 *	           of the message q id. The gateWay program will map the
 *		   prgId's into local msgQids.
 *
 *      For the gateway program, if the portNum is not 6543 then just
 *	send the command directly to the in_addr and port.
*/
typedef struct {
        int       in_addr;              /* or AOM_NO_IP_ADDR*/
        int        portNum;		/* 6543 --> vxWorks gw or 0 or sun*/
        AOMSG_Q_ID aoMsgQId;            /* or AOM_NO_MSGQ_ADR	*/ 
	    int	  progNum;		/* to identify program*/
        } AOM_ADR;

/*	definition of aoMsg		*/
 
typedef struct {
        int     syn1;                   /* AOMSG_SYN1*/
        AOM_ADR toAdr;                  /* send to address*/
        AOM_ADR fromAdr;                /* sent from address*/
        int     msgNum;                 /* created by sender*/
        int     cmd;
        int     arg[AOM_MAX_ARGS];                 /* hold up to 5 args*/
        char    *pdata;                 /* ptr to extra data*/
	/*
	 * dataLen is the number of bytes in pdata.. unless it is a ptr
	 * to a buf node, then it is the number of bytes in the bufNode
	 * buffer to use...
	*/
        int     dataLen;                /* in bytes*/
        int     dataType;               /* AOM_MEM_...values*/
        int     syn2;                   /* AOMSG_SYN2 */
        } AOMSG;
 
/* 	prototypes		*/
/* for sun and vxWorks */	

int     aomConToGw(char *hostName);
void    aomDmpAdr(AOM_ADR *paoAdr,FILE *fp,char *label);
void    aomDmpHdr(AOMSG *paomH,FILE *fp,char* label);
STATUS  aomGetMsgSk(int fd,AOMSG *paom);


#endif	/*INCaoMsgh*/
