/*
 *      include file listing command codes for datatakine
 *
 * history:
 * 24jul93  - created
*/
#ifndef INCaoMsgCodesh
#define INCaoMsgCodesh

/*      typedefs        */

/*      to use in aoCmdTbl.h    */

/*
typedef struct  {
        char*   pname;
        int     cmdCode;
        } AOCMD_ENTRY;
*/

/*
 *      commands used in ao Msg queues
*/
#define aoMSG_GLCMD_RSP         -1
#define aoMSG_GLCMD_STARTDATA    1 
#define aoMSG_GLCMD_EXIT         2
#define aoMSG_GLCMD_NOP          3
#define aoMSG_GLCMD_SETUP        4
#define aoMSG_GLCMD_DATA         5
#define aoMSG_GLCMD_INT          6
#define aoMSG_GLCMD_OUTQ         7
#define aoMSG_GLCMD_STOPDATA     8
#define aoMSG_GLCMD_SETUP_Q      9
#define aoMSG_GLCMD_SETUPALL_Q  10
#define aoMSG_GLCMD_BUFSIZE_Q   11 
#define aoMSG_GLCMD_USE_BUFPOOL 12 
#define aoMSG_GLCMD_FLUSH       13 
#define aoMSG_GLCMD_GENERIC     14 
/*
 *      switch prog commands
*/
#define aoMSG_SWCMD_TAPEOUT     100
#define aoMSG_SWCMD_DISCOUT     101
#define aoMSG_SWCMD_SOCKOUT     102
#define aoMSG_SWCMD_DISPOUT     103
#define aoMSG_SWCMD_AGBUFSREQ   105
#define aoMSG_SWCMD_AGREMOVE    106
#define aoMSG_SWCMD_AGGRPSREQ   107

/*
 *      apProg commands
*/
#define aoMSG_APCMD_OUTBUFRDY   125
/*
 *      prgMgr commands
*/
#define aoMSG_PRGMGR_STARTPROG  150
#define aoMSG_PRGMGR_ADDLOCPROG 151 
#define aoMSG_PRGMGR_SIGNAL     152 
/*
 *      tape   prog commands
*/
#define aoMSG_TPCMD_WEOF        200
#define aoMSG_TPCMD_REW         201
#define aoMSG_TPCMD_OFFL        202 
#define aoMSG_TPCMD_FSF         203
#define aoMSG_TPCMD_FSR         204
#define aoMSG_TPCMD_STAT        205
#define aoMSG_TPCMD_LSTAT       206
#define aoMSG_TPCMD_BSF         207
#define aoMSG_TPCMD_BSR         208
#define aoMSG_TPCMD_XBDSENSE    209
#define aoMSG_TPCMD_XBGLDSENSE  210 
/*
 *      disc   prog commands
*/
#define aoMSG_DSCMD_REQPOS      225
#define aoMSG_DSCMD_SETPOS      226
#define aoMSG_DSCMD_BYTESLEFT   227
/*
 *      socket prog commands
*/
#define aoMSG_SKCMD_NEWSOCK     250
/*
 *      agents (see also swProg)
*/
#define aoMSG_AGCMD_NOPAGENT    275
#define aoMSG_AGCMD_NOPPROG     276
#define aoMSG_AGCMD_SETUP_Q     277

/*
 *      terProg
*/
#define aoMSG_TER_FIRST         300 
#define aoMSG_TER_POSREQ        300
#define aoMSG_TER_MONREQ        301
#define aoMSG_TER_AXIS          302
#define aoMSG_TER_MODE          303
#define aoMSG_TER_CLRDRV        304
#define aoMSG_TER_INDEX         305
#define aoMSG_TER_POSFROMPOT    306

#define aoMSG_TER_LAST          324
/*
 *      spsProg 
*/
#define aoMSG_SPSCMD_ADDBUF     325
#define aoMSG_SPSCMD_PRLIST     326
#define aoMSG_SPSCMD_FREEBUF    327
#define aoMSG_SPSCMD_STARTBUF   328
#define aoMSG_SPSCMD_MODBUF     329
#define aoMSG_SPSCMD_FILEINP    330
#define aoMSG_SPSCMD_FREEALL    331

/*
 *      autoLd  
*/
#define aoMSG_AUTOLD_LOAD       350
#define aoMSG_AUTOLD_PRINT      351
#define aoMSG_AUTOLD_REBUILD    352
/*
 *      mcpProg
*/
#define aoMSG_MCPCMD_STARTPROG      375 
#define aoMSG_MCPCMD_STOPPROG       376 
#define aoMSG_MCPCMD_SET_MSGOUT_Q   377
#define aoMSG_MCPCMD_CREATE_BUFPOOL 378
#define aoMSG_MCPCMD_USE_BUFPOOL    379
#define aoMSG_MCPCMD_DT_MSGQ_NUM    380
#define aoMSG_MCPCMD_CREATE_BP_MEMPART 381
/*
 *      mcpProg
*/
#define aoMSG_TMINGCMD_SETUP        400
/*
 *      dcd 
*/
#define aoMSG_DCDCMD_LOCPROGSETUP  425
/*
 *      ttProg, tieProg . ttt is for both, tt for ttProg
*/
#define aoMSG_TTT_FIRST     450 
#define aoMSG_TTT_NOP       450
#define aoMSG_TTT_RESET     451
#define aoMSG_TTT_SETPARAM  452
#define aoMSG_TTT_GETPARAM  453
#define aoMSG_TTT_CLRPTQ    454
#define aoMSG_TTT_POWER     455
#define aoMSG_TTT_SETTIME   456
#define aoMSG_TTT_GETTIME   457
#define aoMSG_TTT_SETCLOCK  458 
#define aoMSG_TTT_GETCLOCK  459
#define aoMSG_TTT_GETSTATUS 460
#define aoMSG_TTT_GETLOG    461 
#define aoMSG_TTT_PURGELOG  462 
#define aoMSG_TTT_GETFREEPOS 463 

        /* program specific*/

#define aoMSG_TT_BRAKES     464
#define aoMSG_TT_POSREQ     465
#define aoMSG_TIE_POSREQ    466
#define aoMSG_TT_MODE       467
#define aoMSG_TIE_MODE      468
#define aoMSG_TIE_SETFEEDBACK 469 
#define aoMSG_TTT_LAST      469
#define aoMSG_TT_MONREQ     470
#define aoMSG_TIE_MONREQ    471
#define aoMSG_TIE_MONPOS    472

/*
 *      agcProg
*/
#define aoMSG_AGCPROG_MODE       475
#define aoMSG_AGCPROG_XFERCTRL   476
#define aoMSG_AGCPROG_OPARM      477
#define aoMSG_AGCPROG_RST_FAULTS 478
#define aoMSG_AGCPROG_MONREQ     479
#define aoMSG_AGCPROG_PROGTRACK  480
#define aoMSG_AGCPROG_MASTER     481
#define aoMSG_AGCPROG_STATE      482
#define aoMSG_AGCPROG_PWRON      483
#define aoMSG_AGCPROG_SIREN      484
#define aoMSG_AGCPROG_PREPROC    485
/*
 *      pntProg 
*/
#define aoMSG_PNTPROG_TUR_PAT    500
#define aoMSG_PNTPROG_TR_PNT     501
#define aoMSG_PNTPROG_DOPCOR     502
#define aoMSG_PNTPROG_TIE_PAT    503
#define aoMSG_PNTPROG_TIE_USE    504
#define aoMSG_PNTPROG_TER_PAT    505
/*
 *      if1Prog 
*/
#define aoMSG_IF1_RDBACK_3488    600
#define aoMSG_IF1_87130_ERRS     601
#define aoMSG_IF1_87130_WAIT     602 
#define aoMSG_IF1_RCVM           603 
/*
 *      if2Prog 
*/
#define aoMSG_IF2_RDBACK         625
/*
 *      ccalProg 
*/
#define aoMSG_CCAL_DIGIO         650
#define aoMSG_CCAL_CMD           651
#define aoMSG_CCAL_DELAY         652
#define  aoMSG_CCAL_CFG          653
#define  aoMSG_CCAL_SINCSETUP    654
/*
 *      lrMon program
*/
#define aoMSG_LRMON_TEMP         675
/*
 *      gioProg program
*/
#define aoMSG_GIO_DATA           700

#endif  /*INCaoMsgCodesh*/
