#ifndef INCaoMsgLibh
#define INCaoMsgLibh
/*aoMsgLib.h - include file for aoMsgLib routines		*/
/*
* history:
* xx.x  20apr95  - created
* xx.x  14oct00 <pjp001> aoMTTPos removed devices arg.. no longer does
*			     i/o with tertiary..
*/
/*
* DESCRIPTION
* definition of ao messages. they are passed via sockets and 
* vxWorks messages queues.
*/
#ifdef	VXWORKS
#include	<vxWorks.h>
#include        "msgQLib.h"
#include        <semLib.h>
#include	"bufPoolLib.h"
#include	"splAppVxLib.h"
#else
#include	"vxWorksEm.h"
typedef void * AOMSG_Q_ID;
typedef void * BUFNODE_PTR;
#endif
#include	"aoMsg.h"
#include	"tpProgLib.h"
#include	"xbLib.h"
#include	"pntMsg.h"
#include	"spsLib.h"
#include	"agcProgState.h"
#include	"pntProgState.h"
#include	"terProgState.h"
#include	"if1Con.h"
#include	<stdio.h>
/*	defines		*/
#define AOMLIB_TIMEOUT_DEF	120
/*	typedefs		 	*/

/*	prototypes 	*/

STATUS   aoMsgBuild(AOM_ADR *pto,AOM_ADR *pfrom,int cmd,int numArgs,
                    int *args,char *pdata,int dataLen,int dataType,
         	    AOMSG *paoMsg);
STATUS   aoMsgFreeData(AOMSG *paoMsg,int timeout);
void     aoMsgLdAdr(int ipNum,AOMSG_Q_ID msgQId,int progNum,AOM_ADR *paomAdr);
int	 aoMsgNextNum(void);
STATUS	 aoMsgReply(AOMSG *paoMsgRcvd,AOMSG *paoMsgReply,int replyStat,
		    int replyArg1,int replyArg2,int replyArg3,int replyArg4,
		    int timeout);
STATUS	 aoMsgSend(AOMSG *paoMsg,int *pmsgNum,int timeout);
STATUS   aoMsgSendRcv(AOMSG *psndMsg,AOMSG *prcvMsg, int *psendErr,int timeout);
STATUS   aoMsgSRNoArgs(AOM_ADR *pto,AOM_ADR *pfrom,int cmd,int timeout);

/*
 *	standard messages
*/
STATUS   aoMsgExit(AOM_ADR *pto,AOM_ADR *pfrom, int timeout);
STATUS   aoMsgFlush(    AOM_ADR *pto,AOM_ADR *pfrom, int timeout);
STATUS   aoMsgGeneric(AOM_ADR *pto,AOM_ADR *pfrom,char *genMsg,char **ppreply,
					  int timeout);
int      aoMsgNeedReply(AOMSG *psoMsg);
STATUS   aoMsgNop(      AOM_ADR *pto,AOM_ADR *pfrom,int timeout);
STATUS   aoMsgOutQ(     AOM_ADR *pto,AOM_ADR *pfrom,AOM_ADR *poutAdr,
		        int timeout);
char     *aoMsgQSetup(  AOM_ADR *pto,AOM_ADR *pfrom,int retAll,int timeout);
STATUS   aoMsgQBufSize( AOM_ADR *pto,AOM_ADR *pfrom,int *pbufSize,int timeout);
STATUS   aoMsgSetup(    AOM_ADR *pto,AOM_ADR *pfrom,char *psetupInfo,
		        int timeout);
STATUS   aoMsgSendData( AOM_ADR *pto,BUFNODE_PTR pbufNode,int  numBytes,
			int batchId,int timeout);
STATUS   aoMsgStartData(AOM_ADR *pto,AOM_ADR *pfrom,int numBufs,char *hdrToUse,
		        int timeout);
STATUS   aoMsgStopData( AOM_ADR *pto,AOM_ADR *pfrom,int *pbufsDone,int timeout);
STATUS   aoMsgUseBp(    AOM_ADR *pto,AOM_ADR *pfrom,BUFPOOL_PTR pbufPool,
                        int timeout);
/*
 *	program specific commands
*/
/*
 *      apProg
*/
#ifdef VXWORKS 
STATUS    aoMsgApOBufRdy( AOM_ADR *pto, AP_SPLINFO_H *psplI,int indexx,
			  int numWords,int timeout);
#endif
/*
 *      dsProg
*/
STATUS    aoMsgDsBytesLeft( AOM_ADR *pto, AOM_ADR *pfrom, int *pbytesLeft,
			    int timeout);
STATUS    aoMsgDsReqPos( AOM_ADR *pto, AOM_ADR *pfrom, int *pbytePos,
			 int timeout);
STATUS    aoMsgDsSetPos( AOM_ADR *pto, AOM_ADR *pfrom, int byteOffset,
			 int timeout);
/*
 *      prgMgr
*/
STATUS    aoMsgPMAddLocProg(AOM_ADR *pto, AOM_ADR *pfrom, char *prgName,
			    AOMSG_Q_ID inpQId,AOMSG_Q_ID replyQId,int timeout);
STATUS    aoMsgPMStartProg( AOM_ADR *pto, AOM_ADR *pfrom, char *prgName,
			    int timeout);
/*
 *	sockProg
*/
STATUS   aoMsgSkNewSock( AOM_ADR *pto, AOM_ADR *pfrom, int fdsock, 
			 int numBufs,int timeout);
/*
 *	spsProg
*/
STATUS    aoMsgSpsAddBuf( AOM_ADR *pto,AOM_ADR *pfrom,SPSBUF_INFO *pspsBufI,
			  int *pstate,int *pduration, int startNow,int timeout);
STATUS    aoMsgSpsFileInp( AOM_ADR *pto,AOM_ADR *pfrom,int startIt,char *bufId,
			   char *fileName,int timeout);
STATUS    aoMsgSpsFreeAll( AOM_ADR *pto,AOM_ADR *pfrom,int timeout);
STATUS    aoMsgSpsFreeBuf( AOM_ADR *pto,AOM_ADR *pfrom,char *bufId,int timeout);
STATUS    aoMsgSpsModBuf ( AOM_ADR *pto,AOM_ADR *pfrom,SPSBUF_INFO *pspsBufI,
			   int startNow,int timeout);
char     *aoMsgSpsQBuf   ( AOM_ADR *pto,AOM_ADR *pfrom,int code,int timeout);
STATUS    aoMsgSpsStartBuf( AOM_ADR *pto,AOM_ADR *pfrom,char *bufId,
			    int timeout);
STATUS   aoMsgTmSetup(  AOM_ADR *pto,AOM_ADR *pfrom,char *psetupInfo,
		        int timeout);
/*
 *	swProg
*/
STATUS	aoMsgSwAgBufs( AOM_ADR *pto,AOM_ADR *pfrom,AOM_ADR *pbufRet,
		       int numBufs,int maxLenBuf,int *pmsgNum,int timeout); 
STATUS	aoMsgSwAgGrps( AOM_ADR *pto,AOM_ADR *pfrom,AOM_ADR *pbufRet,
		       int numGrps,int maxLenBuf,int *pmsgNum,int timeout); 
STATUS	aoMsgSwAgRem(  AOM_ADR *pto,AOM_ADR *pfrom,AOM_ADR *agAdr,int timeout);
#if FALSE
STATUS	aoMsgSwODisp(  AOM_ADR *pto,AOM_ADR *pfrom,int on,int timeout);
STATUS	aoMsgSwODs  (  AOM_ADR *pto,AOM_ADR *pfrom,int on,int timeout);
STATUS	aoMsgSwOSk  (  AOM_ADR *pto,AOM_ADR *pfrom,int on,int timeout);
STATUS	aoMsgSwOTp  (  AOM_ADR *pto,AOM_ADR *pfrom,int on,int timeout);
#endif
/*
 *	tape program
*/
STATUS   aoMsgTpCmd  (  AOM_ADR *pto,AOM_ADR *pfrom,int cmd, int arg1,
			int timeout);
XB_SENSE_DATA *aoMsgTpSense(  AOM_ADR *pto,AOM_ADR *pfrom,int globalStat,	
			int timeout);
TP_STAT  *aoMsgTpStat (  AOM_ADR *pto,AOM_ADR *pfrom,int longStat,	
			int timeout);
/*
 *	ttProg program (turret/tertiary)
*/
STATUS   aoMTieMode(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int mode,
					int feedBack,float *posRdAr,int timeout);
STATUS   aoMTieSFdBack(  AOM_ADR *pto,AOM_ADR *pfrom,int devices,
				int *fdBackAr,int timeout);
STATUS   aoMTiePos  (  AOM_ADR *pto,AOM_ADR *pfrom,int devices,
				PNT_TIE_POSREQ *pposReq,int timeout);
STATUS   aoMTTMode(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int mode,
					float *posRdAr,int timeout);
STATUS   aoMTieMonPos(AOM_ADR *pto,AOM_ADR *pfrom,int tickProcFlag,
			           int *ptime,float *posAr,int timeout);
char	 *aoMTieMonReq(AOM_ADR *pto,AOM_ADR *pfrom,int tickProcFlag,
			int timeout);
char	 *aoMTTMonReq(AOM_ADR *pto,AOM_ADR *pfrom,int type,int tickProcFlag,
			int timeout);
STATUS   aoMTTPos  (  AOM_ADR *pto,AOM_ADR *pfrom,
				PNT_TT_POSREQ *pposReq,int timeout);
STATUS   aoMTTBrakes(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int on,
					 int timeout);
STATUS   aoMTTTClrLog(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int timeout);
STATUS   aoMTTTClrPTQ(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int timeout);
STATUS   aoMTTTGParm(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int paramNum,
					   int timeout);
STATUS   aoMTTTGClock(AOM_ADR *pto,AOM_ADR *pfrom,int devices,
					  int timeout);
STATUS   aoMTTTGFreePos(AOM_ADR *pto,AOM_ADR *pfrom,int devices,
					  int timeout);
STATUS   aoMTTTGLog(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int timeout);
STATUS   aoMTTTGStatus(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int timeout);
STATUS   aoMTTTGTime(AOM_ADR *pto,AOM_ADR *pfrom,int devices,
					 int timeout);
STATUS   aoMTTTNop(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int timeout);
STATUS   aoMTTTPower(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int on,
					 int timeout);
STATUS   aoMTTTRst(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int timeout);
STATUS   aoMTTTSTime(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int time,
					 int timeout);
STATUS   aoMTTTSClock(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int time,
						int timeout);
STATUS   aoMTTTSParm(AOM_ADR *pto,AOM_ADR *pfrom,int devices,int paramNum,
			float paramVal,int timeout);
/*
 *	terProg program (tertiary)
*/
STATUS   aoMTerAxis(AOM_ADR *pto,AOM_ADR *pfrom,int axis,int timeout);  
STATUS   aoMTerClrDrv(AOM_ADR *pto,AOM_ADR *pfrom,int timeout);  
STATUS   aoMTerIndex(AOM_ADR *pto,AOM_ADR *pfrom,int on,int indexx,int timeout);  
STATUS   aoMTerMode(AOM_ADR *pto,AOM_ADR *pfrom,int mode,int coordSys,
					float *ppos,int timeout);  
char     *aoMTerMonReq(AOM_ADR *pto,AOM_ADR *pfrom,int timeout);
STATUS   aoMTerPosPot(AOM_ADR *pto,AOM_ADR *pfrom,int usePot,int timeout);


STATUS 	 aoMTerPos(AOM_ADR *pto,AOM_ADR *pfrom,PNT_TER_POSREQ  *pposReq,
     			   int timeout); 

/*************************************************************
 *	agcProg program (az,greg,ch control via vertex cpu)
*/
/*	
 *	set mode messages	
*/
STATUS   aoMAgcAuxMode(AOM_ADR *pto,AOM_ADR *pfrom,int axis,
		int azMot,int grMot,int chMot,int timeout);
STATUS   aoMAgcPosMode(AOM_ADR *pto,AOM_ADR *pfrom,int axis,
		 double posAz,double posGr,double posCh,int timeout);
STATUS   aoMAgcRateMode(AOM_ADR *pto,AOM_ADR *pfrom,int axis,
		 double rateAz,double rateGr,double rateCh,int timeout);
STATUS   aoMAgcState(AOM_ADR *pto,AOM_ADR *pfrom,int secMidnite,
					AGC_STATE *pstate,int timeout);
STATUS   aoMAgcStopMode(AOM_ADR *pto,AOM_ADR *pfrom,int axis,int timeout);
STATUS   aoMAgcStowMode(AOM_ADR *pto,AOM_ADR *pfrom,int axis,int timeout);
STATUS   aoMAgcPTMode(AOM_ADR *pto,AOM_ADR *pfrom,int axis,int timeout);

STATUS	 aoMAgcXfrCtrl(AOM_ADR *pto,AOM_ADR *pfrom,int destination,int axis,
		  int timeout);
STATUS   aoMAgcOparam(AOM_ADR *pto,AOM_ADR *pfrom,int flag,double *pencCorRd,
		double timeOffsetPT,int timeout);
STATUS	 aoMAgcPwrOn(AOM_ADR *pto,AOM_ADR *pfrom,int timeout);
STATUS	 aoMAgcReset(AOM_ADR *pto,AOM_ADR *pfrom,int axis,int timeout);
STATUS	 aoMAgcMaster(AOM_ADR *pto,AOM_ADR *pfrom,int masterMode,int timeout);
char	 *aoMAgcMonReq(AOM_ADR *pto,AOM_ADR *pfrom,int type,int tickProcFlag,
			int timeout);
STATUS	 aoMAgcPTData(AOM_ADR *pto,AOM_ADR *pfrom,int flag,
		              int axis,int numPnts,PNTAGC_PT_DATA *pdata,int timeout);
STATUS	 aoMAgcSiren(AOM_ADR *pto,AOM_ADR *pfrom,int timeout);
STATUS	 aoMAgcPreProc(AOM_ADR *pto,AOM_ADR *pfrom,int value,int timeout);

STATUS	 aoMIf1RcvMon(AOM_ADR *pto,AOM_ADR *pfrom,int dewar,int muxAdr, int timeout); 
STATUS	 aoMIf1Rd3488(AOM_ADR *pto,AOM_ADR *pfrom,int *p3488Dat,int timeout);
STATUS   aoMIf1Errs87130(AOM_ADR *pto,AOM_ADR *pfrom,int *pnumErrs,
     					 void **ppsw87130Err,int  timeout);
STATUS   aoMIf1Wait(AOM_ADR *pto,AOM_ADR *pfrom,int timeout);  
STATUS  aoMIf2RdBack(AOM_ADR *pto,AOM_ADR *pfrom,int *ppolANum,
     			     int *ppolADat,int *ppolBNum,int *ppolBDat,
     				 int *pcenNum,int *pcenDat,int timeout);
STATUS  aoMCCalDio(AOM_ADR *pto,AOM_ADR *pfrom,int cal,int dio1,int dio2,
     				 int timeout);
STATUS  aoMCCalCfg(AOM_ADR *pto,AOM_ADR *pfrom,int extTrig,int timeout);
STATUS  aoMCCalDelay(AOM_ADR *pto,AOM_ADR *pfrom,int delayUsecs,int timeout);
STATUS  aoMCCalCmd(AOM_ADR *pto,AOM_ADR *pfrom,int cmd,int timeout);
STATUS  aoMCCalSincSu(AOM_ADR *pto,AOM_ADR *pfrom,int bitsToUse,
			int samplesToAdd,int mclkDiv,int wdBand,int timeout);

STATUS  aoMLrMonTemp(AOM_ADR *pto,AOM_ADR *pfrom,int *ptimeStamp,float *ptemp,
					 float *phght,int *pstat,int timeout);
STATUS  aoMGioData(AOM_ADR *pto,AOM_ADR *pfrom,char *vmeAdr,int numbytes,
				   int seqNum,int timeout);
/*************************************************************
 *	pntProg program 
*/
STATUS   aoMPntTr(AOM_ADR *pto,AOM_ADR *pfrom,int icode,PNT_COORD *ppnt,							 int timeout);  
STATUS   aoMPntTurPat(AOM_ADR *pto,AOM_ADR *pfrom,PNTMSG_TUR_PAT *ppat,
					  int timeout);  
STATUS   aoMPntDopcor(AOM_ADR *pto,AOM_ADR *pfrom,int velSys,double velOff,
     				  int *ptm,double *pdopcor,double *pvelObsProj,int timeout);
STATUS   aoMPntTerPat(AOM_ADR *pto,AOM_ADR *pfrom,PNTMSG_TER_PAT *ppat,
					  int timeout);  
STATUS   aoMPntTiePat(AOM_ADR *pto,AOM_ADR *pfrom,PNTMSG_TIE_PAT *ppat,
					  int timeout);  
STATUS   aoMPntTieUse(AOM_ADR *pto,AOM_ADR *pfrom,int tdToUse,int timeout);  

#endif	/*INCaoMsgLibh*/
