/*
 *	include file for aoParse
 *
 * history:
 * 23jan94  - created
 * 14dec99  - added parGetStrd, parGetStrAr
*/
#ifndef INCaoParseh
#define INCaoParseh
/*      include	        */
#include	<stdio.h>	 

/*      defines         */

#define PARSE_EOF        	-1
#define PARSE_ERR_NO_MATCH_KEY  -2
#define PARSE_ERR_DATA_CONVERT  -3
#define PARSE_ERR_BAD_DATA	-4
 
/*	type codes for key table entries	*/

#define PARSE_T_INT		1
#define PARSE_T_LOG		2
#define PARSE_T_FLOAT	3
#define PARSE_T_DOUBLE	4
#define PARSE_T_STRING	5
#define PARSE_T_ARINT 	6
#define PARSE_T_ARDBL 	7
#define PARSE_T_ARFLT 	8
#define PARSE_T_ADR   	9
#define PARSE_T_NONE   10
#define PARSE_T_ARLOG  11
#define PARSE_T_ARSTR  12

/*      typedefs        */

typedef struct {
        char*   key;    /* keyword */
	int	minLen; /* for match*/
	int	type; 	/* data type. see codes above */
        char*   doc;    /* info about the keyword */
        } KEY_DEF;

typedef struct {
        char*   pbuf;           /* to parse */
        char*   pbufCur;        /* current position */
        char*   ptok;           /* ptr to current tok*/
        char*   delims;         /* hold delimiters */
        char*   keyPrefix;      /* for the key */
        int     isKey;          /* this has the key prefix*/
        char*   lastKey;        /* last key we found */
        int     lastStat;       /* store status returns from functions */
        KEY_DEF* pkeys;         /* pnt to array of keys */ 
	int     needTok;        /* need a new tok ??*/ 
	} PARSE_INFO;

/*      prototypes    */

STATUS  parsAppStr(char* pdata,char* pbuf,int* pbytesLeft);
void	parsBadData(PARSE_INFO* pinfo);
STATUS  parsCatAdr(KEY_DEF* ktbl,int keyIndex,void *value,char* outBuf,
			int* pbytesLeft);
STATUS  parsCatArFloat(KEY_DEF* ktbl,int keyIndex,float* ivals,int numvals,
				char* outBuf, int* pbytesLeft);
STATUS  parsCatArInt(KEY_DEF* ktbl,int keyIndex,int* ivals,int numvals,
				char* outBuf, int* pbytesLeft);
STATUS  parsCatArLog(KEY_DEF* ktbl,int keyIndex,int* ivals,int numvals,
				char* outBuf, int* pbytesLeft);
STATUS  parsCatDouble(KEY_DEF* ktbl,int keyIndex,double value,char* outBuf,
			int* pbytesLeft);
STATUS  parsCatFloat(KEY_DEF* ktbl,int keyIndex,float value,char* outBuf,
			int* pbytesLeft);
STATUS  parsCatInt(KEY_DEF* ktbl,int keyIndex,int value,char* outBuf,
			int* pbytesLeft);
STATUS  parsCatLog(KEY_DEF* ktbl,int keyIndex,int value,char* outBuf,
			int* pbytesLeft);
STATUS  parsCatString(KEY_DEF* ktbl,int keyIndex,char* value,char* outBuf,
			int* pbytesLeft);
int     parsIsKey(char* ptok,char* keyPre); 
STATUS  parsFmtInp(char *filename,char* termChar,char* pbuf,int maxBytes);
STATUS  parsFmtLine(char *pline,char* pbuf,int* pbytesLeft);
STATUS  parsFmtOut(FILE* fp,char* keyPrefix,char* inbuf,KEY_DEF* pkeyDef,
          	   int outputDoc);
void parsGetArDbl(PARSE_INFO *ppinfo,int maxToReturn,double *pdblAr,
					int *pnumRet,int *pnumFound);
void parsGetArInt(PARSE_INFO *ppinfo,int maxToReturn,int *pintAr,int *pnumRet,
     			  int *pnumFound);
void parsGetArLog(PARSE_INFO *ppinfo,int maxToReturn,int *pintAr,int *pnumRet,
     			  int *pnumFound);
void parsGetArStr(PARSE_INFO *ppinfo,int maxToReturn,char **pstrAr,int *pnumRet,
     			  int *pnumFound);
int     parsGetDouble(PARSE_INFO* pinfo,double* pdata);
int     parsGetFloat(PARSE_INFO* pinfo,float* pdata);
int     parsGetInt(PARSE_INFO* pPInfo,int* pdata);
int     parsGetLog(PARSE_INFO* pPInfo,int* pdata);
int     parsGetStr(PARSE_INFO* pPInfo,char** ppstr);
int     parsGetStrd(PARSE_INFO* pPInfo,char** ppstr);
int     parsInit(char* pbuf,KEY_DEF* pkeys,char* keyPrefix,PARSE_INFO* pPInfo);
int     parsIsKey(char* ptok,char* keyPre); 
int     parsKeyMatch(PARSE_INFO* pPInfo);
int     parsProcErr(char* prgname,PARSE_INFO* pPInfo);
void    parsReuseTok(PARSE_INFO*        pPInfo);
STATUS  parsTrueFalse(PARSE_INFO* pPInfo,int* pTvalue); 

STATUS  parsWasKey(PARSE_INFO* pPInfo,char* pkeyPrefix);

#endif	/*INCaoParseh*/
