#ifndef 	AO_TCLINCH
#define	    AO_TCLINCH
#include	"vxWorks.h"
#include	<signal.h>
#include	"aoMsg.h"

/*	defines		*/

#define	AO_TCL_MAX_CMDS 	10

/* 	map our signal numbers to real signals...	
 *  1      sigint   ctrl-c (2)
 *  2      sigquit  ctrl-\ (3)
 *  3      sighup          (1)
 *  4      sigterm         (15)
*/

#define	AOTCL_SIG1	SIGINT
#define	AOTCL_SIG2	SIGQUIT
#define	AOTCL_SIG3	SIGHUP 
#define	AOTCL_SIG4	SIGTERM
#define	AOTCL_SIG5	SIGKILL 

/*	clientdata passed between all ao tcl cmds will have a ptr to
 *  a tclhdr as the first entry of client data.
*/
typedef	struct {
	int		numAoCmds; 
	char	*names[AO_TCL_MAX_CMDS];	
	} AO_TCL_CMDS;

typedef struct	{
	AOM_ADR		replyA;		/* where interpreter receives aoMsg replies*/
	AOM_ADR		prgMA;	 	/* address for program manager our cpu*/
	int			cmdTimeOut;	/* default timeout for aoMsgCmds in clockTicks*/
	int			sigOccured;	/* from signal handler*/
	int			sigCnt;	    /* cum cnt of signals*/
	int			sigLast;	/* last signal num we received*/
	char		sigMsg[80]; /* to return on signal*/
	char		prgName[20];/* for error msgs etc*/
	AO_TCL_CMDS cmds;		/* list of commands added*/
	} AO_TCL_INFO;

#if FALSE

/* 
 *  aog cmd .. general ao cmds
*/
typedef struct {
	AO_TCL_INFO  *paoI;
	double		 timerLog[AO_TCL_MAX_TIMERS];
	} AO_TCL_AOGCMD;

/* 
 * 	pnt cmd 
*/
typedef struct {
	AO_TCL_INFO  *paoI;
	AOM_ADR		pntPrgA;
	} AO_TCL_PNTCMD;

/* 
 * 	mcp cmd 
*/
typedef struct {
	AO_TCL_INFO   *paoI;
	MCP_SU_FILES suFiles;
	char		 hdrGl[HDR_MAX_LEN];	/* datataking headers*/
	HDRAO_STD	 *phdrStdGl;			/* just points to hdrGl*/
	} AO_TCL_MCPCMD;
#endif

/*
 * prototypes
*/
int	 aoTcl(void);
int  aoTcl_AppDelete(Tcl_Interp *interp,AO_TCL_INFO *paoI);
int  aoTcl_AppInit(Tcl_Interp* interp,AO_TCL_INFO **ppaoI_tv);

void aoTcl_Delete(Tcl_Interp *interp,AO_TCL_INFO *paoI);
int  aoTcl_Init(Tcl_Interp* interp,char *prgName,char *replyQName,
     		    int cmdTimeOut,AO_TCL_INFO **ppaoI_tv);
void aoTcl_Kill(char *prgName,int aoSigNum);
int  aoTcl_Sig1Chk(Tcl_Interp *interp,AO_TCL_INFO *paoI);

int	Aog_Init(Tcl_Interp *interp,AO_TCL_INFO *paoI);
int	Mcp_Init(Tcl_Interp *interp,AO_TCL_INFO *paoI);
int	Pnt_Init(Tcl_Interp *interp,AO_TCL_INFO *paoI);

void   hexErr(int errNo,char* cerr);
STATUS prgNamToAdr(Tcl_Interp* interp,char* prgName,AOM_ADR *paoM);
AOMSG_Q_ID prgNamToQId(Tcl_Interp *interp,char* prgName);
#endif
