/*
 *	include file for queues
 *	queues are linked lists with mutual exclusion semaphores and 
 *	a binary semaphore to use to wait on when the queue is empty 
 *
 * history:
 * 7/23/92 - removed stdioLib.h from .h file . it's in the source.
 * 4/20/92 - add chkstop routine to routines that waited on semaphore
 * 4/8/92  - added more monitorying info
 * 3/25/92 - added monitor info to queue
*/
#ifndef INCaoq
#define INCaoq
#include	<semLib.h>
#include 	<lstLib.h>
#include	<stdioLib.h>
#include	"aoErrNum.h"	

typedef	struct aoqLib {
	LIST	qList;		/* 3 wd. linked list holding the queue*/
	SEM_ID	mxSemId;	/* 1 wd. mutual exclusion semaphore*/
	SEM_ID	nEmptySemId;	/* 1 wd. not empty semaphore*/
/*
 *	the following is for monitoring of queue
*/
        char    qname[8];       /* upto 8 characters...*/
	int     m_numputs;	/* total number successfu puts to queue*/	
	int	m_numgets;	/* total number successful gets from queue*/
	int	m_numgetsempty; /* number gets but queue empty*/
	int	m_maxnum;	/* max number in queue*/
	int	m_minnum;	/* minimum number in queue*/
	int	m_curnum;	/* current numberin queue*/
	}  AOQ;

typedef	AOQ	*AOQ_PTR;
typedef NODE	*NODE_PTR;
/*
 * 	prototypes for functions and macros
*/
#define         aoqCurCount(paoq)  (lstCount(&((paoq)->qList)))
STATUS  	aoqGlInit(void);
AOQ_PTR 	aoqInit(char *qname);
VOID		aoqInfo(FILE *fp,AOQ_PTR paoq);
NODE_PTR 	aoqGetNode(AOQ_PTR paoq,FUNCPTR chkstop,int chktimeout);
STATUS  	aoqPutNode(AOQ_PTR paoq, NODE_PTR pnode,FUNCPTR chkstop,
                           int chktimeout);
STATUS  	aoqPutNodeC(AOQ_PTR paoq,NODE_PTR pnode,int *pcount,
        		    FUNCPTR chkstop,int chktimeout);
STATUS  	aoqRemove(AOQ_PTR paoq);
#endif	/*INCaoq*/  
