/* 
 *	include file for bfc correlator (Bill's final Correlator).
*/
#ifndef INCbfch
#define INCbfch 
#include	<stdio.h>
#include	"ipic.h"

/*	start duplicating some defs for correlator */

#define BFC_MAX_BOARDS    4
#define BFC_CLKS_PER_USEC 50

#define BFC1DEVNAME	"/bfc1"
#define BFCRDEVNAME	"/bfcR"
#define BFC_MAX_SBC       8
#define BFC_MAX_LAGS_SBC  16384
#define BFC_MAX_LAGS      16384
#define BFC_MAX_BOARDS    4
#define BFC_MIN_CPU       6
#define BFC_MAX_CPU       9
#define BFC_ADJPWR_TOLOOP_DEF 4
#define BFC_ADJPWR_INTEGLEN_DEF 1000000
/* 31 bits 2**31 - 1 */
#define BFC_MAX_INTEG_LEN_CLKS 2147483647
/*
 *	interrupts 0- data ready, 1- 1sec tick
*/
#define	BFC_INT0_NUM	0xff
#define	BFC_INT1_NUM	0xfe
#define BFC_INT_DATA_READY  0
#define BFC_INT_TICK        1
/* 
 *	bfc particular ioctl's
*/
#define BFCIOCWAITINT	        0x5
#define BFCIOCSTATUS            0x6 
#define BFCIOCDEBUG             0xa 
#define BFCIOCENAINT            0xb 
#define BFCIOCDISINT            0xc 
#define BFCIOCRESET             0xf 

#define BFCIOCLDBW              0x10 
#define BFCIOCLDCODELEN         0x11 
#define BFCIOCLDCODESTADR       0x13
#define BFCIOCLDRAM             0x14
#define BFCIOCLDINTEGLEN        0x15
#define BFCIOCLDCORRPROD        0x16
#define BFCIOCLDCONFIGWRD       0x17
#define BFCIOCSNDCMD            0x18
#define BFCIOCLAGSPERCHIP       0x19
#define BFCIOCDBGIO             0x1a

#define BFCIOCRDSNG             0x20
#define BFCIOCSETUP             0x22
#define BFCIOCGETSETUP          0x23

#define BFCIOCDFSETUP           0x26 
#define BFCIOCDIGWRITE          0x27 
#define BFCIOCDBGTOGGLE         0x28 

#define BFCIOCRDSETUP           0x29 
#define BFCIOCRDDMA             0x2a 
#define BFCIOCSETATTN           0x2b 
#define BFCIOCGETATTN           0x2c 
#define BFCIOCLAST              0x2c
/*
 * IOCTLS for dcdRDrv must be > that BFCIOCLAST but less than 
 * GCSR cmds (0x100 gcsrLib.h). These are additional ioctls that are only
 * used in communicating info between the main cpu and the mv162fx computers.
*/
#define BFCRIOCTAKEDATA		0x50
#define BFCRIOCSETUPREAD 	0x51 
#define BFCRIOCSTOPTAKEDATA 	0x52
#define BFCRIOCREADDATA         0x53
#define BFCRIOCFLUSH            0x54
#define BFCRIOCSTAT             0x55
#define BFCRIOCRESET            0x56
#define BFCRIOCSETUPPROC        0x57
#define BFCRIOCADJPWR           0x58
#define BFCRIOCGETPWR           0x59
#define BFCRIOCSETUP            0x5a
#define BFCRIOCDFSETUP          0x5b
/*
 * iosel addresses useds:
 * the dcd uses ioSelAB, (or CD)  to address registers.
 * There is a mask for each register that masks the allowable data bits.
*/
#define BFC_ADR_W_RESET_CONFIG_FIFO 0x00
#define BFC_ADR_W_DATA 				0x01
#define BFC_ADR_R_STATUS			0x00
#define BFC_ADR_R_DATA  	 		0x01
/*
 * CADR .. these are configuration addresses inside the correl
 *         pal they are the 1st of thee 3 data bytes sent to the correl.
*/
#define	BFC_CADR_INTTEG_LEN_MSB 0X00
#define	BFC_CADR_INTTEG_LEN_LSB 0X01
#define	BFC_CADR_LD_CONFIG      0X02
#define	BFC_CADR_CODE_LEN       0X03
#define	BFC_CADR_CODE_START_ADR 0X04
#define	BFC_CADR_LD_CODE_DATA   0X05
#define	BFC_CADR_LD_NUM_LAGS    0X06
#define	BFC_CADR_LD_CMD_WRD     0X07

/*
 *	data masks for each address
*/
#define BFC_MSK_INTEG_LEN_MSB  0X00007fff
#define BFC_MSK_INTEG_LEN_LSB  0X0000ffff
#define	BFC_MSK_CONFIG         0X00000fff
#define	BFC_MSK_CODE_LEN       0X000003ff
#define	BFC_MSK_CODE_START_ADR 0X000003ff
#define	BFC_MSK_CODE_DATA      0X000000ff
#define	BFC_MSK_NUM_LAGS       0X0000efff
#define	BFC_MSK_CMD_WRD        0X0000002f
#define	BFC_MSK_STATUS         0X0000000f

#define BFC_MSK_CFG_BLANK	   0x00000001 
#define BFC_MSK_CFG_DNYQUIST   0x00000002
#define BFC_MSK_CFG_BW         0x0000003c
#define BFC_MSK_CFG_TESTPAT    0x00000040
#define BFC_MSK_CFG_FIRSTPOL   0x00000080
#define BFC_MSK_CFG_CORRPROD   0x00000700
#define BFC_MSK_CFG_CHIPTEST   0x00000800

/*
 *  correlation product configurations
 *  note that CODE is the bottom 2 bits of the ram
 *  note that _POL sends same config as complex to correlator. 
 *       but processing programs hanle it differently.
*/

/*
 * 	configuration word bits
*/
#define BFC_CFG_ENA_BLANKING     0x00000001
#define BFC_CFG_DBLE_NYQUIST     0x00000002
#define BFC_CFG_TESTPAT    	     0x00000040
#define BFC_CFG_FIRSTPOL   		 0x00000080

#define BFC_CFG_PROD_1CHN_3      0x00000000
#define BFC_CFG_PROD_2CHN_3      0x00000100
#define BFC_CFG_PROD_1CHN_9      0x00000200
#define BFC_CFG_PROD_2CHN_9      0x00000300
#define BFC_CFG_PROD_POL_3       0x00000400 
#define BFC_CFG_PROD_POL_9       0x00000500
#define BFC_CFG_CHIPTEST   		 0x00000800
/*
 * 	command word bits
 *	note that SE is shift enable, INT is integration
*/
#define BFC_CMD_SE_STOP            0x1 
#define BFC_CMD_SE_START_TRIG      0x2 
#define BFC_CMD_SE_START_IMD       0x3 
#define BFC_CMD_INT_STOP           0x4 
#define BFC_CMD_INT_START_TRIG     0x8 
#define BFC_CMD_INT_START_IMD      0xc 
/*
 * status bits
*/
#define BFC_STAT_INT_ENA          0x0001
#define BFC_STAT_SHIFT_ENA        0x0002
#define BFC_STAT_CFG_FIFO_EMPTY   0x0004
#define BFC_STAT_CFG_FIFO_FULL    0x0008

#define  BFC_BWNUM_MAXBW		10
#define  BFC_BWNUM_MINBW		0
#define  BFC_ATTN_MIN_VAL_DB    0
#define  BFC_ATTN_MAX_VAL_DB   15
/*
 * digital filter bit mask is relative to 8 bits. 24BIT_MASK is used
 * to determine where the 8 bits sit in the 24bit digital i/o.
*/
#define	 DF_MSK_INTERPOLATE 	0x100000
#define	 DF_MSK_INTERLEAVE  	0x200000
#define	 DF_MSK_TESTPAT     	0x800000
#define	 DF_MSK_24BIT_DIO   	0xff0000
/*
 * masks for power counters via digital i/o board
*/
#define PC_MSK_BLANKING		0x004000
#define PC_BLANK_ON         0x004000
#define PC_BLANK_OFF        0x000000
#define PC_MSK_CHANGE_ATTN  0x0080ff
#define PC_NO_CHANGE_ATTN   0x008000
#define PC_RD_PC            0x008000
#define PC_CHANGE_ATTN      0x000000
#define PC_MSK_SELREAD  	0x00b000
#define PC_SELREAD_ILO     	0x000000
#define PC_SELREAD_IHI     	0x001000
#define PC_SELREAD_QLO     	0x002000
#define PC_SELREAD_QHI     	0x003000
#define PC_MSK_READ     	0x000fff

#define PC_READ_I		0x01
#define PC_READ_Q		0x02
#define PC_READ_IQ		0x03
#define PC_READ_NONE 	 	0x00

/*	in sum arrays, i always returned before Q */

#define	PC_INDEX_I		0
#define	PC_INDEX_Q		1
/*
 * sinc filter board bits
*/
#define SF_CLOCK_DIV_MAX	6
#define SF_CLOCK_FREQ(DIV)  ( 40. / (1 << div))
#define SF_CLOCK_DIV(A)	    ( (A<<1) & 0xe )
#define SF_STROBE_ON(A)	    ( A |  0x080000)
#define SF_STROBE_OFF(A)    ( A &  0xf7ffff)
#define SF_SAMPLES_TO_ACCUM(A) (( A & 0xfff) << 4)
#define SF_BITS(A)	     (( A & 0x7) << 16)
#define SF_BANDWIDTH(A)	     ( (A)?1:0)
/*	
 *	dbgio structure .. write, readback
*/
typedef struct {
		int     numBytes;	/* to write/readback*/
		int		notReadyCnt;/* for read after send*/
		int		mismatchCnt;/* times we had a mismatch*/
		char	*psndData;	/* buffer to send*/
		char	*prcvData;	/* buffer to put data read back*/
        }  BFC_DBGIO;
/*	
 *	wait interrupt structure
*/
typedef struct {
		int     intToUse;	/* 0 1sec tic, 1 data available*/
        int     late;           /* for interupt*/
        int     timeout;        /* for wait in ticks*/
        int     intcount;       /* interrupt*/
        int     statAtInt;      /* status at last interrupt*/
        }  BFC_INTINFO;
/*	
 *	load/read ram structure
*/
typedef struct {
	int     numWrds;	/* number of wrds to. 1 to 64k*/
	int     startAdr;	/* starting mem address. 0 to 64k-1*/
	int	 	revOrder;	/* load data in reverse order*/
    char    *buf;        /* data is or goes here (lowermost 4 bits)*/
    }  BFC_RAMINFO;
/*
 *	setup the decoder registers
*/
typedef struct {
	    int	    bwNum;		    /* 0..10*/
        int     codeLen;        /* code length*/
        int     codeStartAdr;   /* code start address (start at 0)*/
        int     dumpIntegLen;   /* in master clock cycles*/
        int     lagConfig;      /* 0 thru 5 */
        int     doubleNyquist;  /* true/false*/
        int     chipTestMode;   /* true/false*/
        int     testPattern;    /* true/false to use pattern*/
	    int	    enableBlanking; /* enable blanking*/
		int		firstPol;		/* 0 -a, 1-B*/
        } BFC_SETUP; 
/*
 *	lag config structure. tell what each lag config can do
 *      In,Out difference is:
 *	 for 9 level you may have 4*2048 to work with but
 *	                          1*2048 after combination
*/
typedef	struct	{
	int	numSbcIn;	/* available this config	*/
	int	numSbcOut;	/* after processing	*/
	int	lagSbcInMax;	/* max lags/sbc input*/
	int	lagSbcOutMax;	/* max lags/sbc out after processing*/
	int	level;		/* 3,9*/
	int	pol;		/* polarazation config*/
	int	ram;		/* uses ram both inputs*/
	int	intlv;		/* interleaved data*/
	} BFC_CFINFO;
/*
 *  struct for read setup. The totCnts variable must match the sum
 *	of the data in the arrays.
 *	When doing reads, this setup remains in effect until the next
 *	read setup request.
*/
typedef struct {
	int	numChipsTot;	/* in total to read*/
	int	numLagsTot;	    /* all chips*/
	int	numTotCntsTot;  /* all chips*/
    int lagsToRead[16]; /* lags to read each chip*/
    int chipToRead[16]; /* chip number to read. 1..8*/
    int rdTotCnt[16];    /* true/ false for this chip*/
    } BFC_SETUP_READ;
/*
 *	struct to do dma read on dcd brd.
*/
typedef	struct	{
	int	numLagsTot;    /* must match setup value*/
	int	numTotCntsTot; /* must match setup value*/
	int	timeoutTicks;  /* for read*/
	int	*lagBuf;       /* lags data goes here*/
	int	*totCntBuf;    /* totCnt data goes here*/
	int	*ppcIdig;      /* not null, read i dig power cnter*/
	int	*ppcQdig;      /* not null, read Q dig power cnter*/
	} BFC_READ;
/* 
 * structure used to do single word reads.
*/
typedef struct {
	int	numChipsTot;    /* to read*/
	int	numTotCntsTot;  
	int	lagsToRead[16];	/* lags to read each chip*/
	int	chipsToRead[16];	/* chip number each chip .. # 1 to 8*/
	int	rdTotCnt[16];	/* true/false for each chip*/
	int *lagBuf;	    /* lag data goes here*/
	int *totCntBuf;	    /* totCnt data goes here*/
	int *ppcIdig;	    /* null --> don't read */
	int *ppcQdig;	    /* null --> don't read */
	} BFC_READ_SINGLE;
/*
 *  digital filter setup
*/
typedef struct {
    int bwNum;      /* 1..9 min thru max*/
    int lagConfig;  /* we are using*/
    int useDnyquist;    /* use double nyquist*/
    int useTestPat; /* connect test pattern*/
    } DF_SETUP;
/*
 *	hold all info needed for single reads..
*/
typedef	struct	{
	int	startCmd;	/* available this config*/
	BFC_SETUP_READ rdSu;	/* read setup structure*/
	BFC_READ       rd;	/* for read*/
	int	dmpIntLenMclks; /* dmp integration length in master clocks*/
	int	numDumps; 	/* number of dumps to accum*/
	int	numSbcIn;	
	int	numSbcOut;	
	int	lagSbcIn;	
	int	lagSbcOut;	
	int	lagSbcInMax;	/* max we can have this config*/
	} BFC_READINFO;
/*
 *	power info 1 signal
*/
typedef	struct	{
	float	lag0Norm;	/* - bias/ bias*/
	float	ads;		/* alpha/sigma for 3 level or lag0Norm of 0 level*/
	float	pwrRatio;   /* measured/expected value*/
	float	pc;			/* power counter for this 0 lag*/
	} BFC_POWER_ONE;

typedef struct {
	int		numRet;		/* num get power measures returned 1,2*/
	int	    level3;		/* true/false*/
	BFC_POWER_ONE pwr[2];	/* can return max of 2*/
	}BFC_POWER;

typedef struct {
	BFC_POWER   pwrI;	
	int	 		attnDb[2];	/* current setting*/
	int			attnDbToAdd[2];/* after adjustment what's needed*/
	float	 pcLag0Ratio[2];	/* measured/expected  lag0/pc ratio */ 
	} BFC_ADJPWR; 
/********************** 
*	dcdR structures..
*/
/*
 * decode setups per board. Should be one for each board openned
*/
typedef struct {
	BFC_SETUP	suAr[BFC_MAX_BOARDS];
	} BFCR_SETUP;
/*
 * digital filter setups
*/
typedef struct {
	DF_SETUP	suAr[BFC_MAX_BOARDS];
	} BFCR_DF_SETUP;
/*
 * 	setup for reads on dcdProgL
*/
typedef	struct	{
	int	lagConfig;	/* if lagConfig < 0 use lagsChip,chipsToRd*/
	int	numLagsSbcIn;	/* number of lags each input sbc*/
	int	rdTotCnt;	/* true/false*/
	int	pcCode;		/* 00 non 1 i,2 q, 3 iq*/
	} BFCR_SETUPREAD1;

typedef struct {
	BFCR_SETUPREAD1 suAr[BFC_MAX_BOARDS];
	} BFCR_SETUPREAD;
/*
 *  start datataking on bfcProgL
*/
typedef	struct	{
	int	startCmd;	/* to send to decoder*/
	int	numDumps;	/* to run*/
	} BFCR_STARTDT; 
/*
 *	struct send to bfcProgL to do reads
*/
typedef	struct	{
	int	numBoards;	/* to read from (order is open order*/
	int	timeOutTicks;/* timeout in clock ticks*/
	int	numWords[10];	/* to read each decoder board*/
	int	*baList[10];   /* address to put data for each decoder board*/
	} BFCR_READ;
/*
 *	struct for stat readback from all dcd boards
*/
typedef	struct	{
	int	numBrdsInUse;	/* boards in use*/
	int	cpuNum[10];	/* cpuNum each board*/
	int	errNum[10];     /* last errno each board*/
	} BFCR_STAT;
/*
 *	struct to setup dcd processing program..
*/
typedef	struct	{
		int		passThru;	/* true --> no processing*/
		int     lagsPerSbc; /* to use*/
        int     packing;/* 8,16,32 bits to pack*/
        int     toShift;  /* right shift this many bytes to pack*/
        int     inBufsPerOBuf;/* how many inbufs before an outbuf*/
        int     integTimeClocks;/* for bias removal*/
	} BFCR_PROCPROG_SETUP1;

typedef	struct	{
	char                 *suAr[BFC_MAX_BOARDS];
	} BFCR_PROCPROG_SETUP;
/*
 *	adjust power filled in on return from adjpower
*/
typedef	struct	{
		int			numBoards;     /* user fills in.order is open order*/
		int			integLenClocks;
		BFC_ADJPWR  adjPwr[10];/* max 10 cpus*/
	} BFCR_ADJPWR;
/* 
 *	get power filled in on return from getpower
*/
typedef	struct	{
		int			numBoards;     /* user fills in.order is open order*/
		int			integLenClocks;
		BFC_POWER   pwrI[10];/* max 10 cpus*/
	} BFCR_GETPWR;
#endif	/* INCbfch*/
