/*
 *	include file for bitSwitch macros... 
*/
#ifndef INCbitSwitchh
#define INCbitSwitchh

#ifndef UCHAR 
#define UCHAR  unsigned char
#endif
#ifndef USHORT
#define USHORT unsigned short
#endif
#ifndef UINT  
#define UINT   unsigned int
#endif
/*
 *      nibtble is a bit reversed 4 bits...
*/
static UCHAR nibtble[16]={0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15};

/*
 *	bit switch a byte
*/
#if FALSE
#define bitSwByte(bdata) \
               ( (nibtble[(int)(((unsigned char)bdata) & 0x0f)   ]<<4) | \
               (nibtble[(int)(((unsigned char)bdata) & 0xf0)>>4]) )
#endif
#define bitSwByte(bdata) \
               ( (nibtble[(int)(((unsigned char)bdata) & 0x0f)   ]<<4) | \
               (nibtble[(int)((unsigned char)bdata>>4)&0x0f]) )
/*
 *	bit switch a short
*/
#define bitSwShort(sdata) \
   (((USHORT)bitSwByte((UCHAR)( (USHORT)(sdata)     & 0xff)) << 8 ) | \
    ((USHORT)bitSwByte((UCHAR)(((USHORT)(sdata)>>8) & 0xff))      )     )
/*
 *	bit switch an int
*/
#define bitSwInt(idata) \
   (((UINT)bitSwShort((USHORT)( (UINT)(idata)     & 0xffff)) << 16 ) | \
    ((UINT)bitSwShort((USHORT)(((UINT)(idata)>>16) & 0xffff))      )     )

#endif  /* bitSwitchh*/
