/*
 *      include file for cmdNodes.c
*/
#ifndef INCcmdNodesh
#define INCcmdNodesh


#include	<bufPoolLib.h>
/*
 *
 *	allocation of command numbers:
 *
 * 	1-99    global
 *      100-19  program
 *      200-299 agents...

 *	global commands supported by all programs
 * cmd       arg1      arg2    arg3
 * CMDGLSTART   ??
 * CMDGLEXIT   none
 * CMDGLNOP    sem to give ,
 * CMDGLSETUP   variable...
 * CMDGLDATA    pbufnode, bytesout (include header)
 * CMDGLINT     bufnum    (interrupt but no data)
 * CMDGLOUTQ    pAoq      (new output Q)
*/
#define	CMDGLSTART	1
#define CMDGLEXIT       2
#define CMDGLNOP        3
#define CMDGLSETUP      4
#define CMDGLDATA       5
#define CMDGLINT        6
#define CMDGLOUTQ       7
/*
 *      message format used to pass info between programs 
*/
typedef struct {
        BUFNODE bnode;                  /* buf node at the front*/
        int     cmd;                    /* to send*/
        int     arg1;                   /* bytes or eof cnt etc*/
        int     arg2;                   /* from start of data node*/
        int     arg3;                   /* where data is stored*/
        }  CMDMSG;
typedef CMDMSG *CMDMSG_PTR;
/*
 *	functions prototypes
*/
STATUS      cmdbpCreate(int nodesize,int numnodes);
void	    cmdbpNull(void);
STATUS      cmdbpRemove(void);
CMDMSG_PTR  cmdGetMsg(AOQ_PTR paoq,FUNCPTR chkstop, int chktimeout);
STATUS      cmdPutMsg(AOQ_PTR paoq,int cmd, int parm1,int parm2,int parm3,
		      FUNCPTR chkstop, int chktimeout,char *prgname);
STATUS      cmdNodeFree(CMDMSG_PTR pcmdNode,FUNCPTR chkstop, int chktimeout);
CMDMSG_PTR  cmdNodeGet(int size_req,FUNCPTR chkstop,int chktimeout);
STATUS      cmdGlSync(AOQ_PTR paoq,SEM_ID sem ,FUNCPTR chkstop,
                          int chktimeout,char *prgname);
CMDMSG_PTR  cmdWaitForSetup(AOQ_PTR pinpcmdQ,FUNCPTR chkstop,
                            int chktimeout,char *prgname);
#endif /* INCcmdNodesh*/
