#ifdef VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<stdio.h>
#include	"cor.h"
/* 
 *	include file for corLib.c  .
*/
#ifndef INCcorLibh
#define INCcorLibh

/* some parameters for corProg 	*/

/*  define max num freq bufs for corProg. this impacts memory on corLProc
	since it allocates an accum buf for each freq Buf
*/
#define	COR_MAX_FREQ_BUFS	    4

/* we can have a maximum of two cals 0 off, 1 on	*/

/* maximum number of steps/cycle.. a step is a cal or freq change */

#define	COR_MAX_STEPS_IN_CYCLE	(COR_MAX_FREQ_BUFS*2)

/* 	used as indices into calI arrary [] 	*/

#define COR_CAL_OFF		0
#define COR_CAL_ON 		1

/* low correlation best setting for alpha/sig... murray 9 level, hagen 3 lev*/
#define	ADS_OPTM_9LEV	.266916
#define	ADS_OPTM_3LEV	.6115059
/* prototypes	*/

void    corPrSetup(FILE *fp,COR_SETUP *psu);
void    inC_comp_ads(float lag01s,float *alphadsigma,float *alphadsigmaratio); 
void    inC_comp9_ads(float lag0N,float *alphadsigma,float *pvoltratio); 
void    inC_comp9_adsN(float lag0N,float *alphadsigma,float *pvoltratio); 
void    inC_cosftN(float *pdata,int n); 
float   inC_erfcn(int indx,float a);  
STATUS inC_3lev(int numSbcIn,int lenSbcIn,int lagConfig,
          	   double clockCycles,float *pinbuf,float *pdata,float *pads);
void   inC_3levCor(int numSbcIn,int lenSbcIn,double integCycles,float *acf,
     			   float *pads);
void   inC_3levXCor(int lenSbcIn,double integCycles,float *pdata,float *pads);
STATUS inC_9lev(int lenSbcIn,int numSbcOut,int lagConfig,
     			double clockCycles,float *pinbuf,float *pdata,float *pads);
void   inC_9levCor(int lenSbc,float *pacf);

void   inC_spec3lev(int numSbcIn,int lenSbcIn,int numSbcOut,int lenSbcOut,
        			int lagConfig,double clockCycles,float *pinbuf,
        			float *data,float *pads);
void   inC_spec9lev(int numSbcIn,int lenSbcIn,int numSbcOut,int lenSbcOut,
					int lagConfig,double clockCycles,float *pindata,float *data,
    			    float   *pads);
void   inC_specCmplx(int lenSbcIn,float *pdata);
void   inC_stokes(int numSbcIn,int lenSbcIn,double clockCycles,
        		  float *pinp,float *ptemp,float *pI,float *pV,float *pQ,
        		  float *pU,float *pads);

#endif	/* INCcorLibh*/
