/*
 *	include file for corProg.c .. holds keywords 
 * mods.
 *27aug96,pjp, added dataFormat
*/
#ifndef INCcorProgKeysh
#define INCcorProgKeysh

/*	includes	*/
#ifdef VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<aoParse.h>
 
/*	defines		*/

#define	PARSE_PRE_COR	"cor_"

#define COR_IND_BWNUM       0
#define COR_IND_DMPLEN      1
#define COR_IND_LAGCONFIG   2
#define COR_IND_DBLNYQUIST  3
#define COR_IND_CHIPTESTMODE 4
#define COR_IND_RELBITSHIFT 5
#define COR_IND_ENABLANKING 6 
#define COR_IND_EXTSTART    7
#define COR_IND_DMPSPERINT  8
#define COR_IND_BRDLIST     9
#define COR_IND_LAGSPERSBC 10
#define COR_IND_RDTOTCNTS  11
#define COR_IND_RDPOWCNTR  12
#define COR_IND_DEFAULT    13
#define COR_IND_DATAFORMAT 14
#define COR_IND_ADJPWR     15
#define COR_IND_CALCYCLE   16
#define COR_IND_FRQCYCLE   17
#define COR_IND_WAITDMP    18
#define COR_IND_DMPDELAY   19
#define COR_IND_TESTPAT    20

KEY_DEF corKeys[]={

	/* decode setup keys... */

{"cor_bwnum"       ,6,PARSE_T_ARINT,
		           "#int. bandwidth 1-(50mhz) .. 9-(.15mhz)"},
{"cor_dmplen"      ,8,PARSE_T_INT,
			"#int. Dump integration length (in master clocks)"},
{"cor_lagconfig"   ,8,PARSE_T_ARINT,
			"#int. lag config 1...9"},
{"cor_dblnyquist"  ,6,PARSE_T_LOG,
			"#alpha. t/f y/n use double nyquist"},
{"cor_chiptestmode",6,PARSE_T_LOG,
			"#alpha. t/f, y/n use chipTestMode"},
{"cor_relbitshift" ,6,PARSE_T_ARINT,
			"#int.relBitShift digFil -3to3..shift direction.<0-->more gain"},
{"cor_enablanking" ,6,PARSE_T_LOG,
			"#alpha. t/f, y/n enable decoder blanking"},
	/***************************************/
{"cor_extstart"    ,6,PARSE_T_INT,
			"#int. 0--imd, 1--1sec tick, 10--10sec tick"},
{"cor_dmpsperinteg",8,PARSE_T_INT,
			"#int. dumps per integration"},
{"cor_brdlist"     ,6,PARSE_T_ARINT,
			"#ints. list of cpunums of boards to use"},
{"cor_lagspersbc"  ,8,PARSE_T_ARINT,
			"#int. lags per subcorrelator (on input)"},
{"cor_rdtotcnts"   ,7,PARSE_T_LOG,
			"#alpha. read total counts lag"},
{"cor_rdpowcntr"   ,7,PARSE_T_LOG,
			"#alpha. t/f, y/n read power counters"},

{"cor_default"     ,7,PARSE_T_NONE,
			"#noargs, set to default args"},
{"cor_dataformat"  ,6,PARSE_T_ARINT,
			"#int. 1,2,3 raw,levelcor,spectra"},

{"cor_adjpwr"      ,6,PARSE_T_LOG,
			"#int. t/f y/n adnust pwr before datataking"},

{"cor_calcyc"      ,7,PARSE_T_STRING,
			"#string. cal cycle ynyn y-on,n-off"},

{"cor_frqcyc"      ,7,PARSE_T_STRING,
			"#string. frq cycle 1234 fbuf 1,2,3,4"},

{"cor_waitdmp"     ,5,PARSE_T_STRING,
			"#string. no, tick, cmd"},

{"cor_deldmp"     ,7,PARSE_T_INT,
			"#int. usecs for delay if wait dmp is hardeware delay"},
{"cor_testpattern" ,5,PARSE_T_LOG,
			"#log.no longer used"},
{NULL,0,0,NULL},
        };
#endif
