/*
 *	include file for dcd Lib
*/
#ifndef INCdcdLibh
#define INCdcdLibh
#include	<dcd.h>
#include	<stdio.h>
#include   "pncl.h"

/*
 * prototypes for lib
*/
/*
 * sun and vxworks routines
*/

STATUS  dcdChkPnLen(int codeLen);
STATUS  dcdCmpPnC(int codeLen,int minVal,int maxVal,char *code);
STATUS  dcdCmpLpnc(PNCL_SHIFTREG *pstVal,int retLen,int minVal,int maxVal,
     			   char *code);
STATUS  dcdCmpBwDiv(DCD_SETUP *pdcdSetup,int *pbwDiv);
STATUS  dcdCmpBwNum(int bwDivisor,int useDnyquist,int lagconfig,int *pbwNum);
STATUS  dcdCmpDfBits(int bwNum,int relShiftReq,int use9Level,int *pbitsToUse,
					 int *prelShiftUsed);
STATUS  dcdCmpSfBits(float baud,int relShiftReq,int use9Level,int *psmpToAdd,
     				  int *pbitsToUse,int *prelShiftUsed);
STATUS  dcdVwDtIn(int tickStart,int nlagsIn,int lagCf, int dmpLen,
		     int numDmp,int timeoutTicks,int *plagDat,int *ptotCntDat,
		  int *ppcIdig,int *ppcQdig,DCD_READINFO *prdI);
STATUS  dcdVwSDtIn(int  tickStart,int numLagSbcIn,int lagConfig,int *pinpLagDat,
     	  int *pinpTotCntDat,int *ppcIdig,int *ppcQdig,int *pstartCmd,
	      DCD_READ_SINGLE *prdI);
#if FALSE 
STATUS  dcdVwDtInRdChp(int nlagsIn,int lagCf,int *plagDat,int *ptotCntDat, 
		  int *ppcIdig,int *ppcQdig,DCD_RDCHIPS *prdChips);
#endif

STATUS  dcdFillRdSu(int lagsPerSbcIn,int lagConfig,int rdTotCnts,
		    int timeoutTicks,
		    DCD_CFINFO *pcfI,DCD_SETUP_READ *prdSu,DCD_READ *prdI);
void    dcdPrRdSu(FILE *fp,DCD_SETUP_READ *psu);
void    dcdPrSetup(FILE *fp,DCD_SETUP *psu);
void	dcdPrStatus(FILE* fp,int status);
STATUS  dcdLagCfInfo(int lagConfig,DCD_CFINFO *pcfI);
STATUS  dcdRdSngSu(int lagsPerSbcIn,int lagConfig,int rdTotCnts,
		    DCD_CFINFO *pcfI,DCD_READ_SINGLE *prdSu);
/*
STATUS  dcdConfInfo(int lagConfig,int *pnumSbcI,int *pnumSbcO,int *p9lev,
		int *p3lev,int *pcmplex,int *pdecode,int *pram,int *intlv);
*/
/*	
 *	vxWorks only functions
*/
#ifdef VXWORKS
STATUS dcdVwAdjPwr(int fd,int dumpLen,int toLoop,DCD_SETUP *pcursetup,
				   DCD_ADJPWR *padjPwr);
STATUS dcdVwDfSetup(int fd,DF_SETUP *pdfSetup);
#if FALSE
STATUS dcdVwDtFInRd(int fd,int tickStart,int numLagSbcIn,int lagConfig,
		    int pcCode,int dmpLenMClks,int numDmps,int *plagDatInp,
		    float *psumTCnt,float *psumLagDat,float *psumPc);
#endif
STATUS dcdVwDtInRd1(int fd,int tickStart,int numLagSbcIn,int lagConfig,	
	 	    int dmpLenMClks,int *plagDat,int *ptotCntDat,
		    int *pnumWdsLag,int *pnumwdsTotC,int *ppcI,int *ppcQ);

STATUS dcdVwSDtInRd1(int fd,int tickStart,int numLagSbcIn,int lagConfig,
     		int *plagDat,int *ptotCntDat,int *plagsRd,
     		int *ptotCRd,int *ppcIdig,int *ppcQdig);

STATUS  dcdVwGetData(int fd,int tickStart,int numLagsSbc,int numSbc,
	 	     int *psbcList,int *totCntDat,int*bufAdr,int *platint);
STATUS  dcdVwGetData(int fd,int tickStart,int numLagsSbc,int numSbc,
		     int* psbcList,int *bufAdr,int *totCntAdr,int *plateInt);
STATUS  dcdVwGetPwr(int  fd,int dumpLen,DCD_SETUP *pcurSetup,DCD_POWER *ppwrI);
STATUS  dcdVwGetMFData(int fd,int tickStart,int numDumps,int numSbc,
		     int numLagsSbc,float *totCntDat,float *bufSum,int *bufInp,
		     int dumpIntegLen);
STATUS  dcdVwGetSetup(int fd,DCD_SETUP *pdcdSetup);
STATUS  dcdVwLdRam(int fd,int startAdr,int numLocs,int reverseOrder,char *buf);
#if FALSE
STATUS  dcdVwRdChipInit(int numLagsSbc,int *ptotCntDat,int *bufAdr,
         	        int *ppcIdig,int *ppcQdig,DCD_RDCHIPS *prdChips);
#endif
STATUS  dcdVwRdRam(int fd,int startAdr,int numLocs,int reverseOrder,char *buf);
STATUS  dcdVwSetup(int fd,DCD_SETUP *pdcdSetup);
STATUS  dcdVwSfSetup(int fdIpDio,int clockDiv,int numToAdd,int outputBit,
					 int wideBand);  

/*	
 *	sun only functions
*/
#else 
STATUS  dcdRmtGetSetup(int fdsock,DCD_SETUP *pdcdSetup,int *pdsc);
STATUS  dcdRmtLdRam(int fdsock,int numAdr,char *ramBuf,int *pdsc);
STATUS  dcdRmtRdRam(int fdsock,int numAdr,char *ramBuf,int *pdsc);
STATUS  dcdRmtRead(int fdsock,int tickStart, int lagConfig,int lagSbcIn,
		int *lagBuf,int *pdsc);
STATUS dcdRmtSndSetup(int fdsock,DCD_SETUP  *psu,int *pdsc);
STATUS dcdRmtStartSE(int fdsock,int *pdsc);
STATUS dcdRmtSetAttn(int fdsock,int *pattenVals,int *pdsc);


#endif
#endif	/* INCdcdLibh*/
