/*
 *	include file for hdrProgc  decoding of doppler info.
 * mods.
*/
#ifndef INCdopKeysh
#define INCdopKeysh

/*	includes	*/
#ifdef VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<aoParse.h>
 
/*	defines		*/

#define	PARSE_PRE_DOP	"dop_"

#define DOP_IND_FACTOR      0
#define DOP_IND_VEL         1
#define DOP_IND_FBCREST     2
#define DOP_IND_FOFFSET     3
#define DOP_IND_VOBSPROJ    4
#define DOP_IND_TIME        5 
#define DOP_IND_VELCRD      6
#define DOP_IND_ALLBANDS    7
#define DOP_IND_VELTYPE     8
#define DOP_IND_LAST        8

LOCAL KEY_DEF dopKeys[]={

	/* decode setup keys... */

{"dop_factor"      ,6,PARSE_T_DOUBLE,
		           "#double. doppler factor. f0*factor=fdop"},

{"dop_vel"         ,6,PARSE_T_DOUBLE,
			"#double. velocity in velocity frame (or z)"},

{"dop_fbcr"   ,8,PARSE_T_DOUBLE,
			"#double. freq band center rest freq. Mhz"},

{"dop_foff"   ,6,PARSE_T_ARDBL,
			"#darray. freq offset double array. up to 4 nums. see stat Mhz"},

{"dop_vobsp"  ,6,PARSE_T_DOUBLE,
			"#double. projected velocity observer in velCrd km/sec"},

{"dop_tm"     ,5,PARSE_T_INT,
			"#int. seconds from midnite for doppler projection"},

{"dop_vcrd" ,6,PARSE_T_STRING,
			"#alpha. vel coord sys. topo,geo,helio,lsr"},

{"dop_allb" ,5,PARSE_T_LOG,
			"#alpha. doppler correct all subbands t/f"},

{"dop_vtype" ,6,PARSE_T_STRING,
			"#alpha. vel,zo,zr."},
{NULL,0,0,NULL},
        };
#endif
