/*
 *	include file for pntProg.h  
 *  This is the state of pntProg that can be run on vxWorks or sun os.
 * 30nov98 - updated for tiedown changes..old file pntProgState.hold
 * 15sep99 - include tiedown auto tracking pattern
 * 10dec99 - velObsProj now just a single double.
 *
*/
#ifndef INCdopStateh
#define INCdopStateh
#define DOPST_VELTYPE_VEL 0
#define DOPST_VELTYPE_ZO  1 
#define DOPST_VELTYPE_ZR  2

typedef struct {
    unsigned int  dopCorAllBands:1;/* 1 yes, 0 just center of band*/
    unsigned int  velCrdSys:4;     /* 1-geo,2-helio,3-lsr */
    unsigned int  velType:2;       /* 0-vel,1-zo,2-zr*/
	unsigned int  fill:25;
    } DOP_STAT_WORD;

typedef struct {
    double  dopFactor; /* frqOutBCtopo=dopFactor*frqBCR rest frame*/

    double  velOrZ;    /* km/sec or z..see stat.velType*/

    double  freqBCRest;  /* rest freq band center Mhz*/
    double  freqOffsets[4];/* Mhz to compute center freq of each band.
							*1. if dopCorall, then add to freqBCRest to 
								get the  rest frequencies center each band.
							*2. if dopCorall false, then add to freqBCTopo
								to get the topocentric center each band.
								(should match value in iflo.
							*/
    double  velObsProj; /* velocity of observer in vel coord system
							 projected along the line of site.km/sec*/

    int     tmDop;      /* when doppler was computed. sec Mid*/
	DOP_STAT_WORD stat; /* stat word*/
    } DOP_STATE; /* 8*8 + 2*4=72 bytes*/

#endif  /*INCdopStateh */
