#ifndef INCephRdrStdh
#define INCephRdrStdh
/*
	ephRdrStd.h-- Std Radar ephemeris binary record structure
*/
#define MAXREC	210

typedef struct { 
	int mjd;			/* modified Julian date */
	int ast_min;			/* starting minute */
	int ast_hr;			/* starting sidereal hour */
	int nitems;			/* number of valid array elements */
	int el[MAXREC];			/* elevations in 1/1000 degree */
	int az[MAXREC];			/* azimuth in 1/1000 degree */
	double rtt[MAXREC];		/* round trip time in seconds */
	double df[MAXREC];		/* relative doppler shift, hz */
	double ra[MAXREC];		/* right ascension, hours */
	double dec[MAXREC];		/* declination, degrees */
	} RADAREPH;
/*
 *	prototypes...
*/
extern STATUS rephload (long  datereqd,char *filename,RADAREPH *peph,
		 char *hdr1,char *hdr2,int  hdr1l,int  hdr2l);
#endif  /*INCephRdrStdh*/
