/* hdrClp.h - include file for coded long pulse program portion of 
 *            datataking headers
 *	%W%   %G%
*/
/* modification history
current len 03nov94 13words or 52 bytes
delta
1.1 21sep94 	check in 1st time
    03nov94     current length : 13words or 52 bytes
    05feb95     changed version from 1.00 to x1.0
*/
#ifndef INChdrClph
#define INChdrClph
#include	<stdio.h>
#include	<string.h>
#include	<hdrLib.h>

#define	HDRAO_CLP_ID	"CLP "
#define HDRAO_CLP_CUR_VER  " 1.0"

/*
 *	macros to access header locatoins
*/
/*
 *	pass in start of header, return ptr to start of riPortion of header
*/
#define HDRAO_CLP_GET(phdr)  ( \
	 (HDRAO_CLP*) ( \
	      ((char*)(phdr)) + \
              HDR_S_GET_OFF(((HDRAO_STD *)(phdr))->sec.proc)\
	     ))
/*
 *	see if it's a clp header section. pass in ptr to clp header
*/

#define HDRAO_CLP_ISCLP(pclpHdr)  (strncmp(pclpHdr->id,HDRAO_CLP_ID,4)== 0)
	    
typedef struct {
/*
 *	here's the coded long pulse program specific junk.
 *	It is stored in the sec.proc portion of the header
*/
	char	id[4];			/* CLP  not null terminated*/ 
	char	ver[4];	 		/* 1.00 no null termination*/
	int	ippsAvg1Freq;		/* how many spectra incoh added*/
	int	numIfFreq;		/* 1 or 2 if 400/460 switching*/
	int	numHeights;		/* number of height spectra requested*/
	int	spc1stHeight;		/* height index 1st spectra. start 1*/
	int	spcHeightStep;		/* heights between spectra returned*/
	int	decimateFactor;		/* bandwidth decimation of spectra*/
	int	zeroExtdXform;		/* zero extend the transform*/
	int	firstTxSmp;		/* 1st sample for decoding cnt from 1*/
 	/* computed by program 	*/
	int	spcLen;			/* spectra length in rec, cmplfftlen*/
	int	decimatedCodeLen;       /* cmplx words code after decimation*/
	int	spcThisRec;		/* number spectra this rec*/
	}	HDRAO_CLP;

void    hdrPrClp(FILE *fptr,HDRAO_CLP *ppwrHdr);
#endif /*INChdrClph*/
