/*hdrDcd.h - include file for dcdProg portion of headers
*  %W%    %G%
*/
/*modification history:
----------------------
1.1,19aug94 moved under sccs
1.2,19aug94 outstanding
    23nov94 changed itemp[3] to ipp,gw,startOn...
*/
#ifndef INChdrRih
#define INChdrRih
#include	<dcd.h>
#include	<stdio.h>
#include	<hdrLib.h>

/*
 *	dcd config info for headers
*/
#define HDRAO_DCD_ID	   "dcd "
#define HDRAO_DCD_CUR_VER  " 1.0"
/*
 *	macros to access header locatoins
*/
/*
 *	pass in start of header, return ptr to start of riPortion of header
*/
#define DCDHDR_GET(phdr)  ( \
	 (HDRAO_DCD *) ( \
	      ((char*)(phdr)) + \
              HDR_S_GET_OFF(((HDRAO_STD *)(phdr))->sec.inp)\
	     ))
typedef struct {
/*
 *	here's the dcd specific junk
 *	extra space at bottom makes multiple of 8 bytes and can be used
 *	for additions later on
*/
    char    id[4];			"dcdp" no null termination*;
	char    ver[4];			"xx.x" version...
	int	masterClkPeriod;/* master clock period in nanosecs*/
	int	dumpIntegLen;   /* in master clock counts*/
	int numDumps;		/* included in integration*/
	int	lagSbcIn;		/* lags per sbc before processing*/
	int lagSbcOut;		/* lags per sbc after processing*/
	int numSbcIn;		/* num sbc/board before processing*/
	int numSbcOut;   	/* num sbc/board after processing*/
	int	bwDivisor;	    /* bwDivisor * 1./masterClkPer = bw out*/
						   < 0 --> multiply by 1./masterClk*/
	int	lagConfig;		/* for correlator*/
		/* below could is in lagConfig*/
    int levels;			/* 3,9*/
	int stokes;			/* true/false*/
		/* ... */
	int	doubleNyquist;	/* true/false*/
	int chipTestMode;	/*  true/false*/
	int blankingEnabled;/* true/false*/
	int startOn;		/* 0- imd 1 - 1sectick 10- 10sec tick 99- exttick*/

	int dataFormat;	 	/* 1 raw acf's, 2 combined acfs, 3 spectra*/
	int	totCnts;		/* true/false included with data*/
	int	powerCnter;     /* true/false included with data */
	int free[4];		/* current length 24*4=96 bytes*/
	}	HDRAO_DCD;

void    hdrPrDcd(FILE *fptr,HDRAO_DCD *phdr);
#endif /*INChdrDcdRih*/
