/* hdrMracf.h - include file for mracf/topsd program portion of 
 *            datataking headers
 *	%W%   %G%
*/
/* modification history
delta
x.x 08nov94 	copied from hdrClp.h
x.x 16feb94     remove numRecsDataOrNoise. since data /noise now in separate
x.x             scans, just use recsInGrp.
x.x 18feb94     add txHeight 0/1 --> transmitter height included for each
                IF freq.
*/
#ifndef INChdrMracfh
#define INChdrMracfh
#include	<stdio.h>
#include	<string.h>
#include	<hdrLib.h>

#define	HDRAO_MRACF_ID	     "MACF"
#define HDRAO_MRACF_CUR_VER  " 1.0"

/*
 *	macros to access header locatoins
*/
/*
 *	pass in start of header, return ptr to start of riPortion of header
*/
#define HDRAO_MRACF_GET(phdr)  ( \
	 (HDRAO_MRACF*) ( \
	      ((char*)(phdr)) + \
              HDR_S_GET_OFF(((HDRAO_STD *)(phdr))->sec.proc)\
	     ))
/*
 *	see if it's a mracf header section. pass in ptr to mracf header
*/

#define HDRAO_MRACF_ISMRACF(pmracfHdr)  (strncmp(pmracfHdr->id,HDRAO_MRACF_ID,4)== 0)
	    
typedef struct {
/*
 *	here's mracf program specific junk.
 *	It is stored in the sec.proc portion of the header
 *      Data records have the rf pulse on, noise recs have the rf pulse off.
 *	When data and noise are taken, they are kept in separate rec(s).
 *	The output record size if fixed for data and noise. Zero padding 
 *	is done on the last record of the data and noise recs..
*/
	char	id[4];			/* MACF  not null terminated*/ 
	char	ver[4];	 		/* 1.00 no null termination*/
	int	ippsAvgData;		/* # ipps avg all IF/RF data*/
	int	ippsAvgNoise;		/* # ipps avg all IF/RF noise*/
	int	numIfFreq;		/* 1 or 2 if 400/460 switching*/
	int	numHeights;		/* number of heights requested*/
	int	numLags;		/* they want returned*/
	int	numDcPnts;		/* number cmplx dc points 1 rf freq*/
	int	firstTxSmp;		/* 1st sample Tx to use cnt from 1*/
	int	recIsDataRec;		/* 1--> data rec, 0--> noise*/
	int     heightsThisRec;		/* number heights this record*/
	int	dcPntsThisRec;		/* number cmplx dc points this rec*/
					/* pass recs/grp to ap in this loc*/
	int	txspIpp;		/* samples/pair/ipp trans ipp*/
	int	txHeight;		/* 1--> transmiter spectra included*/
	int	numFreqSw;		/* # tx freq to switch with sps*/
	float   txFrqOff1;		/* frq offset 1st frqSwitch hz*/
	float   txFrqOff2;		/* frq offset 2nd frqSwitch hz*/
	float   txFrqOff3;		/* frq offset 3rd frqSwitch hz*/
	float   txFrqOff4;		/* frq offset 4th frqSwitch hz*/
	int	fr3;
	}	HDRAO_MRACF;

void    hdrPrMracf(FILE *fptr,HDRAO_MRACF *pmracfHdr);
#endif /*INChdrMracfh*/
