/*hdrPt.h - include file for ptProg portion of headers
*  %W%    %G%
*/
/*modification history:
----------------------
x.x 03oct96,pjp, started.
*/
#ifndef INChdrPth
#define INChdrPth
#include        <pt.h>
#include        <stdio.h>
#include        <hdrLib.h>

/*
 *      pt config info for headers
*/
#define HDRAO_PT_ID       "pt  "
#define HDRAO_PT_CUR_VER  " 1.0"

#define PTHDR_TRIGMODE_IMD       1
#define PTHDR_TRIGMODE_ONSTART   2
#define PTHDR_TRIGMODE_IPP       3
#define PTHDR_TRIGMODE_GATE      4

#define PTHDR_RDFLAG_USE32XFER   1 
#define PTHDR_RDFLAG_USEDMA      2 
/*
 *      macros to access header locatoins
*/
/*
 *      pass in start of header, return ptr to start of riPortion of header
*/
#define PTHDR_GET(phdr)  ( \
         (HDRAO_PT*) ( \
              ((char*)(phdr)) + \
              HDR_S_GET_OFF(((HDRAO_STD *)(phdr))->sec.inp)\
             ))
typedef struct {
/*
 *      here's the pentek specific junk
 *      extra space at bottom makes multiple of 8 bytes and can be used
 *      for additions later on
*/
    char    	id[4];     /*"PTPR" no null termination**/
    char    	ver[4];    /*"xx.x" version no null termination*/
	int		    brdsFlag;  /* 1 - pt1, 2- pt2, 3 pt1,pt2*/;
	int		    trigMode;  /* 1 imd start no trig pulse 
	                          2 - ext trig at start
	                          3 - trig at ipp (ext trig), 
							  	  take smpPerIpp samples then wait for
							      next ipp (ext trig).
						      4 - gated trig. only take samples while 
								  exttrig gate is high.
					       */
	int			startOn;  /* 0 - start according to trig flag,
							   	  start time is time of start cmd req.
							  1 - if trigFlag=0 (no trig). wait for 1 sec
						          tick in prog then start.
							      trigflag=1 wait in software for 1 sec tick
								         then issue cmd to start on next
									     trig assume that trig is a tick.
						   */
    int			extSmpClk;	/* 0 --> internal smpClk
							   1..65535 - ext smp clock and divider used on
									      it. The gw should be the actual
									      sampled rate*/
    int         smpPerIpp;             /* smp 1 dig/ipp*/
    int         ippsPerBuf;/* output to tape*/
    int         ippNumStartBuf; /* varies each rec.1st ipp of buf. cnt from 1*/ 
    int          packing;                /* usually 12 bits*/
	/*
     * ipp is an act of faith. Whatever the user enters.
	*/
    float       ipp;    /* ipp in usecs. resolution .1 usecs*/
    float       gw;     /* gate width in usecs. resolution .1 usecs*/
	int			rdFlag; /* bit 0 - 0-->D16 xfers 1-->D32 xfers
	                       bit 1 - 0-->no DMA, 1-->use Dma*/
	int		    free1;  /* for multiple of 8 bytes*/
    }       HDRAO_PT;

void    hdrPrPt(FILE *fptr,HDRAO_PT *phdr);
#endif /*INChdrPth*/
