/* hdrPwr.h - include file for power program portion of datataking headers
 *	%W%   %G%
*/
/* modification history
delta
1.1  	check in 1st time
1.2,19aug94 	 outstanding
    25aug94 	 changed name to hdrPwr.h
*/
#ifndef INChdrPwrh
#define INChdrPwrh
#include	<stdio.h>
#include	<string.h>
#include	<hdrLib.h>

#define	HDRAO_PWR_ID	"PWR "
#define HDRAO_PWR_CUR_VER  "1.00"

/*
 *	type of program run
 *	heights, spectra, heights and spectra
*/
#define	HDRAO_PWR_PROGMODE_H		1
#define	HDRAO_PWR_PROGMODE_SP	 	2
#define	HDRAO_PWR_PROGMODE_H_SP		3
/*
 *	how the data was decoded
*/
#define HDRAO_PWR_DCD_XMTER		1
#define HDRAO_PWR_DCD_THEORETICAL		2
/*
 *	 type of data in output record
 *	 H- height data, SP- spectral data
*/
#define HDRAO_PWR_REC_H   		1
#define HDRAO_PWR_REC_SP  		2
/*
 *	macros to access header locatoins
*/
/*
 *	pass in start of header, return ptr to start of riPortion of header
*/
#define HDRAO_PWR_GET(phdr)  ( \
	 (HDRAO_PWR*) ( \
	      ((char*)(phdr)) + \
              HDR_S_GET_OFF(((HDRAO_STD *)(phdr))->sec.proc)\
	     ))
/*
 *	see if it's a power header section. pass in ptr to power header
*/

#define HDRAO_PWR_ISPWR(ppwrHdr)  (strncmp(ppwrHdr->id,HDRAO_PWR_ID,4)== 0)
	    
typedef struct {
/*
 *	here's the power program specific junk.
 *	It is stored in the sec.proc portion of the header
 *	extra space at bottom makes multiple of 8 bytes and can be used
 *	for additions later on
 *  Grp - a group consists of a set of averaged data. 
 *     if height only then it is incremented for each average done 
 *     If height and spectra, the the height and all the spectra data
 *     have the same group number for a given average. The type o
 *     record is determined by recType. recs/grp tell how many output
 *     records are needed for a given grp and type. 
 *    
*/
	char	id[4];			/* POWR not null terminated*/
	char	ver[4];	 		/* 2.11 no null termination*/
	int	progMode;		/* pwr_h,pwr_sp,pwr_h_sp*/
	int	decodingMode;		/* sampled xmiter or theoretical*/
	int	recType;		/* height or spectral data*/
	int	grpNum;		        /* which average data came from*/
	int	recsPerGrp;		/* Records in this grp and type*/
	int	recOfGrp;		/* which record of group this is*/
	int	hIppsAvged;		/* for height info*/
	int	spcNumHeight;		/* number of spectra*/
	int	spc1stHeight;		/* height index 1st spectra. start 0*/
	int	spcLenFft;		/* spectra length if used*/
	int	spcAvged;		/* spectra avged*/
	int	spcThisRec;		/* number spectra this rec*/
	}	HDRAO_PWR;

void    hdrPrPwr(FILE *fptr,HDRAO_PWR *ppwrHdr);
#endif /*INChdrPwrh*/
