#ifndef incHP34970LIBH
#define incHP34970LIBH

/*	defines */
#define HP34970_DEV_U1    "/hp34970_u1" 
#define HP34970_DEV_U2    "/hp34970_u2" 
#define HP34970_U1_DEF_ADR   0x0b
#define HP34970_U2_DEF_ADR   0x0c
#define HP34970_TIMEOUT  	60*5
/*
 *	typedefs
*/
typedef struct mfCard {
	int		card  ;		/* card location 1,2,3*/
	int		digInp;		/* 16 bits digital i/o*/
	int		digOut;		/* 16 bits digital i/o*/
	int		totalize;	/* input totaliz value*/
	float   dac[2];			/* dac voltages*/
	} HP34970MF_CARD;

typedef struct {
	int		card  ;		/* card location 1,2,3*/
	char	muxOrder[40];/* order to read the mux*/
	int		numToRead;  /* read this many from the start*/
	} HP34970MUX_CARD;
/* 
 *	prototypes
*/
int     hp34970Create(int gpibAdr,char *devNum);
int     hp34970Open(char *devNum);
int     hp34970DtoA(int fd,float volts,int card,int chan);
int     hp34970DigOut(int fd,int data,int card,int chan);
int     hp34970FRes(int fd,float rangeOhms,float resOhms,int card,int chan,
					float *pohms);
STATUS hp34970QEMsg(int fd,int maxLen,char *pmsg,int *pnumReturned);
double  hp34970IoTime(void);

/* for gpibenet interface */

int     hp34970EOpen(char *gpibENm,char *devNm);
int     hp34970EDtoA(int gd,float volts,int card,int chan);
int     hp34970EDigOut(int gd,int data,int card,int chan);
int     hp34970EFRes(int gd,float rangeOhms,float resOhms,int card,int chan,
					float *pohms);
STATUS hp34970EQEMsg(int gd,int maxLen,char *pmsg,int *pnumReturned);
double  hp34970EIoTime(void);

#endif /*incHP34970LIBH*/
