#ifndef incHP8648LIBH
#define incHP8648LIBH

/*	defines */
#define HP8648_DEV_D1    "/hp8648_d1" 
#define HP8648_DEV_D2    "/hp8648_d2"
#define HP8648_DEV_D3    "/hp8648_d3"
#define HP8648_DEV_D4    "/hp8648_d4"
#define HP8648_D1_DEF_ADR  0x17
#define HP8648_D2_DEF_ADR  0x18
#define HP8648_D3_DEF_ADR  0x19
#define HP8648_D4_DEF_ADR  0x1a
#define HP8648_TIMEOUT  60*5

#define HP8648_MAX_FREQ 3200.E6 
#define HP8648_MIN_FREQ 100.e3
#define HP8648_MAX_AMP  14.0
#define HP8648_MIN_AMP  -136.0

/* 
 *	prototypes
*/
int     hp8648Create(int gpibAdr,char *devNum);
int     hp8648Open(char *devNum);
#if FALSE
STATUS  hp8648QErr(int fd,int* perrnum);
#endif
STATUS  hp8648QAmp(int fd,double  *pamp);
STATUS  hp8648QFreq(int fd,double  *pfreq);

STATUS  hp8648SAmp(int fd,double  amp);
STATUS  hp8648SFreq(int fd,double  freq);
STATUS  hp8648SRf(int fd,int on);  
#endif /*incHP8648LIBH*/



