#ifndef incHP87130LIBH
#define incHP87130LIBH

/*	defines */
#define HP87130_DEV_1      "/hp87130_1" 
#define HP87130_1_DEF_ADR  0x09
#define HP87130_TIMEOUT  60*5
#define HP87130_SENSE_ERR   1001
#define HP87130_TIMEOUT_ERR 1006
#define HP87130_MAX_ERRS    32    

/*
 *	typedefs
*/
typedef	struct	{
	int	card;		/* 1 thru 8*/
	int     chn;
	int	chnEnd;		/* if > 0 then end of range*/
	} CHN_ELM;	

/*
 *	hold query info.
 *	val 0-8 is a bitmap of the cards 1-8,
 *	if a bit is mask[i] is non-zero , then the value for card i, that bit
 *	was read back
*/
typedef	struct	{
	int	val[8];
	int	mask[8];
	} CHN_STATE;
/*
 *	hold errors parsed from error string. For verify,
 *	sense and timeout there is an additional set of info for open/closed
 *	for each switch. Note that verify will check the sense for all
 *	switches, not just the one you changed.
*/
typedef	struct	{
	int	errNum;		/* from error string*/
	int	snsOrTOErr;     /* true if sense or timeout error*/
	int	card;		/* 1..8*/
	int	errOpen;	/* 32bits sense error open*/
	int	errClose;       /* 32bits sense error sw closed*/
	} HP87130_ERR;

typedef struct {
	int	numErrs;	/* we've found*/
	HP87130_ERR errAr[HP87130_MAX_ERRS];/* we can hold*/
	} HP87130_ERRS;
	

typedef	struct	{
	int 	val[8][31];
	int	mask[8];
	} CHN_WIDTH;
/* 
 *	prototypes
*/
STATUS  hp87130Clear(int fd);	
int     hp87130Create(int gpibAdr,int devNum);
int     hp87130Open(int devNum);

STATUS  hp87130ChClose(int fd,int numElm,CHN_ELM *pchnElm);
STATUS  hp87130ChkErrs(int fd,FILE *fp,HP87130_ERRS *perrI);
STATUS  hp87130ChDrive(int fd,int On,int numElm,CHN_ELM *pchnElm);
STATUS  hp87130ChOpen(int fd,int numElm,CHN_ELM *pchnElm);
STATUS  hp87130ChWidth(int fd,int width,int numElm,CHN_ELM *pchnElm);
STATUS  hp87130ChVerify(int fd,int On,int numElm,CHN_ELM *pchnElm);
int     hp87130ChView(int fd,int Qclosed,int numElm,CHN_ELM *pchnElm,
		  	 CHN_STATE *pchnState);
STATUS  hp87130ErrStrParse(char* errStr,HP87130_ERR *perr);
int	hp87130OpcWait(int fd);	
STATUS  hp87130QCdEERomCycles(int fd,int *pnumCycles);

STATUS  hp87130QError(int fd,int *errNum,char *errStr,int maxStrLen);
STATUS  hp87130QDrive(int fd,int Qon,int numElm,CHN_ELM *pchnElm,
		      CHN_STATE *pchnState);
STATUS  hp87130QVerify(int fd,int Qon,int numElm,CHN_ELM *pchnElm,
		      CHN_STATE *pchnState);
STATUS  hp87130Wait(int fd);
STATUS  hp87130QWidth(int fd,int numElm,CHN_ELM *pchnElm,
		      CHN_WIDTH *pchnWidth);

STATUS  hp87130QCdType(int fd,int card,int *pctype);	
STATUS  hp87130RdErr(int fd,int *perrVal);
STATUS  hp87130Recall(int fd,int reg);
STATUS  hp87130Store(int fd,int reg);

#endif /*incHP87130LIBH*/
