#ifndef incHP8719LIBH
#define incHP8719LIBH

#include	<stdio.h>
/*	defines */
#define HP8719_DEV_1    "/hp8719_1"
#define HP8719_DEF_ADR  0x10
/* timeout.. set long enough for longest integration..*/
#define HP8719_TIMEOUT  120*60

/*	typedefs	*/

typedef struct {
	float	val1;
	float   val2; 
	} HP8719_FLOAT_DAT;

typedef struct {
	int		numPntsRd;		/* number data points we read*/
	int	    numPntsMax;     /* we allocated for*/
	char	hdrid[2];		/*#A.. fixed length, not null terminated*/
	short   bytesData;		/* bytes that follow*/
	HP8719_FLOAT_DAT fl[1]; /* when allocate, make this corrent length*/
	} HP8719_FREC;

typedef HP8719_FREC *HP8719_FREC_ID;
/*
 * record with phase info
*/
typedef struct {
	float	*pdat;		    /* ptr to phase data*/
	int	    numPnts;		/* num points allocated for FREC*/
	HP8719_FREC_ID fRecId;
	} HP8719_PH_FREC;

/* 
 *	prototypes
*/
#ifdef VXWORKS
int     hp8719Create(int gpibAdr,int devNum);
int     hp8719Open(void);
HP8719_FREC_ID hp8719CrFRec(int numPnts);
void    hp8719DbgEcho(int on);
STATUS  hp8719GADat(int fd,char *preq,int maxLenReply,char *preply);
STATUS  hp8719GFDat(int fd,char *preq,int numPnts,HP8719_FREC_ID id);
STATUS  hp8719GMPhase(int fd,float *pphase,float *pfreqMhz);
STATUS  hp8719GTPhase(int fd,HP8719_PH_FREC *prec);
int     hp8719GNumPnts(int fd);
STATUS  hp8719SCmd(int fd,char *obuf);
STATUS  hp8719Swp(int fd,int numSweeps);



#endif

#endif /*incHP8719LIBH*/



