#ifndef INCif1Conh
#define INCif1Conh
/*  
 * constants used by if1Prog.c
 *
*/
/*
*history
12jul98,<pjp001> got rid of pole z filters
*/
#define IF1_DONT_CHANGE   -1
#define IF1_87130_MAX_SW_ERRS 25

#define IF1_HP3488_SLOTS           5
#define IF1_HP3488_2_SLOTS         1
#define IF1_HP3488_1              "u1"
#define IF1_HP3488_2              "u2"
#define IF1_87130_PULSE_WIDTH_MS 30
#define IF1_87130_NUM_CARDS       3
#define IF1_HP34970_1             "u1"
#define IF1_34970_MF1_CARD          1
#define IF1_34970_MF2_CARD          2
#define IF1_34970_MUX_CARD          3


/* 	for cable selection */

#define IF1_FIBER       1
#define IF1_HELIAX      2

/* 	for hybrid selection */
 
#define IF1_HYBRID_OUT  1
#define IF1_HYBRID_IN   2

/*	for phase adjuster at 10 ghz
    90 deg over 6 bits is 90/64 */

#define IF1_PHASE_ADJ_DEG_PER_STEP  1.40625

/*
 * cal values
*/
#define	IF1_LCORCAL	0
#define	IF1_HCORCAL	1
#define	IF1_LXCAL	2
#define	IF1_HXCAL	3
#define	IF1_LCAL	4
#define	IF1_HCAL	5
#define	IF1_L90CAL	6
#define	IF1_H90CAL	7
/*
 * lband filter bank
*/
#define IF1_LBFB_MIN_FNUM 1 
#define IF1_LBFB_MAX_FNUM 9
#define IF1_LBFB_MASK  0x1ff
 
#define IF1_LBNFB_MIN_FNUM 1 
#define IF1_LBNFB_MAX_FNUM 4
#define IF1_LBNFB_MASK  0xff

#define IF1_SBWFB_MIN_FNUM 1 
#define IF1_SBWFB_MAX_FNUM 4
#define IF1_SBWFB_MASK  0xff
/*
 * 430 gr filter bank codes. The bit values are 1 less than this
*/
#define IF1_430FB_4    1
#define IF1_430FB_10   2
#define IF1_430FB_20   3
#define IF1_430FB_25   4

/*
 * lbnarrow filter bank filter numbers
*/
#define IF1_LBNFB_FNUM_VAR     1
#define IF1_LBNFB_FNUM_HIPASS  2
#define IF1_LBNFB_FNUM_BNDPASS 3
#define IF1_LBNFB_FNUM_SPARE   4
#define IF1_LBNFB_MUXADR_POLA  1
#define IF1_LBNFB_MUXADR_POLB  2

#define IF1_LBNFB_MOTST_BRKSET	0
#define IF1_LBNFB_MOTST_BRKREL	1
/*
 * receiver monitoring <4dec98.. min_dewar 1->0 till we figure out
*/
#define IF1_RCVMON_MIN_DEWAR 0
#define IF1_RCVMON_MAX_DEWAR 10
#define IF1_RCVMON_MIN_ADR   0
#define IF1_RCVMON_MAX_ADR   0x60


 
/*	for 11 db attenuators. This is the number of indices-1 in table */

#define IF1_ATTN_MAX_DB		11

#define IF1_ZM_ATTN_MAX_DB  1.5

/*	20 ghz synths 	 
	10mar98,pjp levels were measured at 2.6ghz.
				unlevel lite ocurs at 16, -8 dbm
*/

#define IF1_SYN_MAX_AMP	15
#define IF1_SYN_MIN_AMP	 -7

/* info for parsing keywords/values	*/

#define PARSE_PRE_IF1	  		"if1_"

#define IF1_IND_RFNUM           0
#define IF1_IND_RFATTN          1
#define IF1_IND_ZMNORMAL        2
/* below not used.. 
 * left in to handle old scripts that still have them in
 * if no old users of these keywords, below could be used for
 * something else
*/
#define IF1_IND_ZMNDON          3
#define IF1_IND_ZMATTN          4
#define IF1_IND_ZMNDATTN        5
#define IF1_IND_ZMNDTOA         6
/* */
#define IF1_IND_IFNUM           7
#define IF1_IND_IFATTN          8
#define IF1_IND_HYBRID          9
#define IF1_IND_PHDSIG         10
#define IF1_IND_PHDLO          11
#define IF1_IND_PHBSIG         12
#define IF1_IND_PHBLO          13
#define IF1_IND_FIBER          14
#define IF1_IND_INFO           15
#define IF1_IND_SHUTSB         16
#define IF1_IND_SYN1           17
#define IF1_IND_SYN2           18
#define IF1_IND_SYNB           19
#define IF1_IND_SYNA1          20 
#define IF1_IND_SYNA2          21
#define IF1_IND_SYNAB          22
#define IF1_IND_SYNRF1         23
#define IF1_IND_SYNRF2         24
#define IF1_IND_SYNRFB         25
#define IF1_IND_CALTYPE        26
#define IF1_IND_LBFB           27
#define IF1_IND_LBAFB          28
#define IF1_IND_LBBFB          29
#define IF1_IND_CALRCVR        30
#define IF1_IND_RCVMADR        31
#define IF1_IND_RCVMDEWAR      32
#define IF1_IND_AC1SW          33
#define IF1_IND_AC2SW          34
#define IF1_IND_LBWCIRLIN      35 
#define IF1_IND_COMPMON        36
#define IF1_IND_SHUT           37
#define IF1_IND_430FB          38
#define IF1_IND_SBWFB          39
#define IF1_IND_SBWAFB         40
#define IF1_IND_SBWBFB         41
#define IF1_IND_IFFRQ          42
#define IF1_IND_IF750NB        43
#define IF1_IND_IF2_12WB       44
#define IF1_IND_TERACON        45
#define IF1_IND_TILT           46
#define IF1_IND_CBCIRLIN       47 
#endif
