/*
 *	key definitions for if1Prog
*/
#ifndef INCif1ProgKeysh
#define INCif1ProgKeysh

/*	includes	*/
#ifdef VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<aoParse.h>
 
/*	defines		*/
/*	prefix for keytable if1_ defined in if1Con.h	*/


KEY_DEF if1Keys[]={
{"if1_rfnum"     ,7,PARSE_T_INT,
			        "#int. rfFreq number 1..n"},

{"if1_rfattn"    ,7,PARSE_T_ARINT,
		            "#intarr. rf atten db. pol a,b 0..11"},

{"if1_zmnormal"  ,8,PARSE_T_LOG,
		            "#alpha. zeeman switch normal position"},


{"if1_zmndon"    ,9,PARSE_T_LOG,
		            "#alpha. zeeman noise diode on"},

{"if1_zmattn"    ,7,PARSE_T_ARFLT,
		            "#fltarr. pol a,b attenuation 0 1.5 db .1 db step"},

{"if1_zmndattn" ,9,PARSE_T_FLOAT,
		            "#float. zm noise diode level. 0..16.5db .1db steps"},

{"if1_zmndtoa"  ,9,PARSE_T_LOG,
		            "#alpha. zm noise diode to pol a"},

{"if1_ifnum"     ,7,PARSE_T_INT,
		            "#int. if1 freq number 1..5"},

{"if1_ifattn"    ,7,PARSE_T_ARINT,
		            "#intarr. if1 atten db. pol a,b 0..11db 1db steps"},

{"if1_hybrid"    ,5,PARSE_T_LOG,
		            "#alpha. use 10ghz hybrid"},

{"if1_phdsig"    ,8,PARSE_T_FLOAT,
		            "#float. signal phase adjustment degrees"},

{"if1_phdlo"     ,8,PARSE_T_FLOAT,
		            "#float. lo phase adjustmen degrees"},

{"if1_phbsig"    ,8,PARSE_T_INT,
		            "#int. signal phase adjustment binary units"},

{"if1_phblo"     ,8,PARSE_T_INT,
		            "#int. lo phase adjustment binary units"},

{"if1_fiber"     ,6,PARSE_T_ARLOG,
		            "#alpha. pol a,b use fiber..false-->heliax"},

{"if1_info     ",6,PARSE_T_ARDBL, 
				  "#dblar. lo1Hi lo2hi if1Mhz if2Mhz 10Gc(0,1)"},

{"if1_sbshcl"    ,6,PARSE_T_LOG,
		          "#ALPHA. sband shutter closed, true/1 --> closed"},

{"if1_syn1"      ,8,PARSE_T_DOUBLE,
		            "#double. freq for synth 1 in hz."},

{"if1_syn2"      ,8,PARSE_T_DOUBLE,
		            "#double. freq for synth 2 in hz."},

{"if1_synb"      ,8,PARSE_T_ARDBL,
		            "#dblar. freq for synth 1,2 in hz"},

{"if1_syna1"     ,9,PARSE_T_DOUBLE,
		            "#double. amplitude dbm for syn1 output 14..0dbm."},

{"if1_syna2"     ,9,PARSE_T_DOUBLE,
		            "#double. amplitude dbm for syn2 output 14..0dbm."},

{"if1_synab"     ,9,PARSE_T_ARDBL,
		            "#dblar. amplitude dbm  for synth 1,2."},

{"if1_synrf1"    ,10,PARSE_T_INT,
		            "#int. syn 1 rf  0-off, 1-on"},

{"if1_synrf2"    ,10,PARSE_T_INT,
		            "#int. syn 2 rf  0-off, 1-on"},

{"if1_synrfb"    ,10,PARSE_T_ARINT,
		            "#intar. syn1,syn2 rf 0-off, 1-on (1 num/synth)."},

{"if1_caltype"  ,8,PARSE_T_STRING,
		      "#string. hcal,lcal,hxcal,lxcal,h90cal,l90cal,hcorcal,lcorcal."},

{"if1_lbfb"     ,7,PARSE_T_ARINT,
		      "#intar. lband filter bank pol a and b 1-10."},

{"if1_lbafb"    ,7,PARSE_T_ARINT,
		      "#intar. lband filter bank pol a 1-10."},

{"if1_lbbfb"    ,7,PARSE_T_ARINT,
		      "#intar. lband filter bank pol b 1-10."},

{"if1_calrcvr"  ,8,PARSE_T_INT,
		      "#int. rcvr to use 1-15 for receiver."},
{"if1_rmadr  "  ,7,PARSE_T_INT,
		      "#int. rcvr monitor address 0..0x60."},
{"if1_rmdewar"  ,7,PARSE_T_INT,
		      "#int. rcvr monitor dewar  1..10."},
{"if1_ac1sw"  ,7,PARSE_T_INT,
		      "#int. ac1 power switch 0-15. max 4 devices or together"},
{"if1_ac2sw"  ,7,PARSE_T_INT,
		      "#int. ac2 power switch 0-7. max 3 devices.or together"},
{"if1_lbwpol"  ,7,PARSE_T_STRING,
		      "#string. l,c lbw linear/circular switch switch"},
{"if1_cmpmonon",6,PARSE_T_LOG,
		      "#log.  t/f, y/n  no longer used.."},
{"if1_shcl"    ,6,PARSE_T_LOG,
		          "#ALPHA. generic rcvr shutter closed, true/1 --> closed"},
{"if1_430fb"  ,8,PARSE_T_INT,
		          "#int. 430 fb 1..4:"},
{"if1_sbwfb"  ,8,PARSE_T_ARINT,
                  "#intar. sbandwide fbank:1 - 4"},
{"if1_sbwafb" ,8,PARSE_T_ARINT,
              "#intar. sbandwide filter bank pol a 1-4."},

{"if1_sbwbfb" ,8,PARSE_T_ARINT,
              "#intar. sbandwide filter bank pol b 1-4."},

{"if1_iffrq"  ,7,PARSE_T_DOUBLE,
              "#intar. sbandwide filter bank pol b 1-4."},

{"if1_750nb"  ,5,PARSE_T_LOG,
              "#log. 750If narrow band filter"},

{"if1_2to12wb"  ,5,PARSE_T_LOG,
              "#log. 2 to 12 ghz IF wide band 0 to 2 ghz"},

{"if1_teracon",6,PARSE_T_LOG,
              "#log. ac power to tertiary control on/off (y/n or t/f)"},

{"if1_tilt"  ,6,PARSE_T_LOG,
              "#log. mon tilt sensor. default is temp"},
{"if1_cbpol"  ,7,PARSE_T_STRING,
		      "#string. l,c cband  linear/circular switch switch"},
{NULL,0,0,NULL},
        };

#endif
