#ifndef INCif1ProgLibDath
#define INCif1ProgLibDath
/*
 * table used to configure the switches for the upstairs if/lo
 * 08mar00 - added SWSHUT_RCV for shutters for non-sband rcvrs.
 * 12apr01 - added defines for lbn filter bank
 * 06feb03 - updated rfswitch table for new positions.
*/
#include	"if1ProgLib.h"

/*
 *      switch Table for hp87130 switch driver.
 *		This is the rf,if, some attenuators,cable,etc
 *	first the basic tables that locate switch names with addresses.
*/
/*                       swNum        name  verify mutExcl crd ch1 ch2 */
LOCAL SWI_87130  swTbl87130[] ={
                 { SW1A1       ,"SW1A1"      , 1,    1,    1,  6, 11 },
                 { SW1B1       ,"SW1B1"      , 1,    1,    2,  6, 11 },
                 { SW1A2       ,"SW1A2"      , 1,    1,    1, 12, 17 },
                 { SW1B2       ,"SW1B2"      , 1,    1,    2, 12, 17 },
                 { SW2A        ,"SW2A"       , 1,    1,    1,  0,  5 },
                 { SW2B        ,"SW2B"       , 1,    1,    2,  0,  5 },
                 { SW3A        ,"SW3A"       , 1,    1,    1, 18, 23 },
                 { SW3B        ,"SW3B"       , 1,    1,    1, 24, 29 },
                 { SW5A        ,"SW5A"       , 1,    1,    2, 18, 23 },
                 { SW5B        ,"SW5B"       , 1,    1,    2, 24, 29 },
                 { SW4         ,"SW4"        , 1,    1,    3, 18, 23 },
                 { SW6A        ,"SW6A"       , 1,    0,    3, 16, 16 },
                 { SW6B        ,"SW6B"       , 1,    0,    3, 17, 17 },
                 { SW7A        ,"SW7A"       , 1,    0,    3, 24, 24 },
                 { SW7B        ,"SW7B"       , 1,    0,    3, 25, 25 },
                 { SW8A        ,"SW8A"       , 1,    0,    3, 26, 26 },
                 { SW8B        ,"SW8B"       , 1,    0,    3, 27, 27 },
                 { SWATTN_RF_A ,"SWATT1"     , 1,    0,    3,  8, 11 },
                 { SWATTN_RF_B ,"SWATT2"     , 1,    0,    3, 12, 15 },
                 { SWATTN_IF1_A,"SWATT3"     , 1,    0,    3,  0,  3 },
                 { SWATTN_IF1_B,"SWATT4"     , 1,    0,    3,  4,  7 },
                 { -1          ,            0, 0,    0,    0,  0,  0 }
                     };

/*       
 *  hp3488 switch table #1
 *  card 1 is just readback
 */
/*                       swnum         name       Slot bSt bend mutualexcl */
LOCAL SWI_3488   swTbl3488[]={
				 { SWCBCIRLINM      ,"SWCBCIRLINM", 1, 1, 2,FALSE}, 
				 { SWXFER_ZM        ,"SWXFERZM   ", 2, 0, 0,FALSE}, 
                 { SW750_NB         ,"SW750NB    ", 2, 1, 1,FALSE},
                 { SW2_12WB         ,"SW2_12WB   ", 2, 2, 2,FALSE}, 
				 { SWLBFBB          ,"SWLBFBB    ", 2, 3,11,FALSE},
				 { SWTILT           ,"SWTILT     ", 2,12,12,FALSE},
				 { SWAC1SW          ,"SWAC1      ", 2,13,15,FALSE},
                 { SWPHADJ_SIG      ,"SWPHADJ_SIG", 3, 0, 6,FALSE},
                 { SWPHADJ_LO       ,"SWPHADJ_LO ", 3, 7,13,FALSE},
				 { SWSHUT_SB        ,"SWSHUT_SB  ", 3,14,14,FALSE},
				 { SWSHUT_RCV       ,"SWSHUT_RCV ", 3,15,15,FALSE },
				 { SWCBCIRLIN       ,"SWCBCIRLIN ", 4, 1,1 ,FALSE},
                 { SWTERACON        ,"SWTERACON  ", 4, 7, 7,FALSE},
				 { SWCALTYPE        ,"SWCALTYPE  ", 4, 8,10,FALSE},
				 { SWLBWCIRLIN      ,"SWLBCIRLIN ", 4,15,15,FALSE},
				 { SWLBFBA          ,"SWLBFBA    ", 5, 0, 8,FALSE},
				 { SWCALRCVR        ,"SWCALRCVR  ", 5, 9,12,FALSE},
				 { SWAC2SW          ,"SWAC2      ", 5,13,15,FALSE},
				 /* note ac2sw now has only 2 bits. connected to 
				  * 14,15. for now leave 13,14, 15 in software
				  * since the software uses 1,2,4 to access 13,14,15
				  * if you change to 14,15 you need to remap the
				  * devices 1,2,4 to 1,2 .. currently only vlbi cal on 15
				  */
#if FALSE
				 { SWRCVMADR   ,"SWRCVMADR  ", 4, 0,6 ,FALSE},
				 { SWRCVMDEWAR ,"SWRCVMDEW  ", 4,11,14,FALSE},
#endif
                 {       -1    ,            0, 0, 0, 0,0    }
                      };
/*
 *  2nd  hp3488_2 switch table
 */
/*                   swnum         name       Slot bSt bend mutualexcl */
LOCAL SWI_3488   swTbl3488_2[]={
				 { SW430FB      ,"SW430FB     ", 1, 0,1,FALSE},
				 { SWALFAFBPWR  ,"SWALFAFBPWR ", 1, 2 ,2 ,FALSE},
				 { SWALFAFB1A   ,"SWALFAFB1A  ", 1, 3 ,3 ,FALSE},
				 { SWALFAFB2A   ,"SWALFAFB2A  ", 1, 4 ,4 ,FALSE},
				 { SWALFAFB1B   ,"SWALFAFB1B  ", 1, 5 ,5 ,FALSE},
				 { SWALFAFB2B   ,"SWALFAFB2B  ", 1, 6 ,6 ,FALSE},
				 { SWSBWFBA     ,"SWSBWFBA    ", 1, 12,15,FALSE},
				 { SWSBWFBB     ,"SWSBWFBB    ", 1, 8,11,FALSE},
                 {       -1    ,            0, 0, 0, 0,0    }
                      };

/*
 * table mapping rf switch numbers to  freq, or string
 * must be in order of rf_table
*/
LOCAL IF1_NUM_TO_FREQ rfNumFrqTbl[]={
	   {    1  , 327  , "    327"},
	   {    2  , 430  , "    430"},
	   {    3  , 610  , "    610"},
	   {    4  , 800  , "    800"},
	   {    5  ,1000  , "   1000"},
	   {    6  ,1400  , "   1400"},
	   {    7  ,2000  , "   2000"},
	   {    8  ,3000  , "   3000"},
	   {    9  ,5000  , "   5000"},
	   {   10  ,7000  , "   7000"},
	   {   11  ,9000  , "   9000"},
	   {   12  ,2380  , "   2380"},
	   {   13  ,12000 , "  12000"},
	   {   14  ,15000 , "  15000"},
	   {   15  ,16000 , "  16000"},
	   {   16  ,18000 , "  18000"},
	   {   -1  ,0     , "     "}};

LOCAL IF1_NUM_TO_FREQ mixerNumFrqTbl[]={
	   {    1  , 300  , "  300"},
	   {    2  , 750  , "  750"},
	   {    3  ,1500  , " 1500"},
	   {    4  ,10000 , "10000"},
	   {    5  ,   0  , " thru"},
	   {    6  ,  590 , " seti"},
	   {   -1  ,   0  , "     "}};

/* here is the new layout 6feb03
 *      rf freq sw table
 *      the table rfNumFrqTbl[] above maps rfNum to frequencies.
 *                           Pol A                       Pol B
 *         rfNum numSw   sw1 pos sw2,pos sw3,pos   sw1  pos sw2,pos sw3,pos*/
LOCAL RF_ENT rfSwTbl[] = {
/*free 1*/ {  15 , 1 , { SW2A,1,    0,0,    0,0 ,     0,0,     0,0,    0,0}},
/*sbTx 2*/ {  14 , 2 , { SW2A,1, SW2B,1,    0,0 ,     0,0,     0,0,    0,0}},
/*xb   3*/ {  11 , 2 , { SW2A,3, SW2B,3,    0,0 ,     0,0,     0,0,    0,0}},
/*cbh  4*/ {  10 , 2 , { SW2A,4, SW2B,4,    0,0 ,     0,0,     0,0,    0,0}},
/*cb   5*/ {   9 , 2 , { SW2A,5, SW2B,5,    0,0 ,     0,0,     0,0,    0,0}},
/*lbn  6*/ {   6 , 4 , {SW1A1,1, SW2A,6,SW1B1,1 ,  SW2B,6,     0,0,    0,0}},
/*sbw  7*/ {   7 , 4 , {SW1A1,2, SW2A,6,SW1B1,2 ,  SW2B,6,     0,0,    0,0}},
/*sbhi 8*/ {   8 , 4 , {SW1A1,3, SW2A,6,SW1B1,3 ,  SW2B,6,     0,0,    0,0}},
/*lbw  9*/ {   5 , 4 , {SW1A1,4, SW2A,6,SW1B1,4 ,  SW2B,6,     0,0,    0,0}},
/*free 10*/{ 993 , 4 , {SW1A1,5, SW2A,6,SW1B1,5 ,  SW2B,6,     0,0,    0,0}},
/*free 11*/{ 994 , 6 , {SW1A2,1,SW1A1,6, SW2A,6 ,  SW1B2,1,SW1B1,6, SW2B,6}},
/*sbn  12*/{  12 , 6 , {SW1A2,2,SW1A1,6, SW2A,6 ,  SW1B2,2,SW1B1,6, SW2B,6}},
/*611   13*/{  3 , 6 , {SW1A2,3,SW1A1,6, SW2A,6 ,  SW1B2,3,SW1B1,6, SW2B,6}},
/*430   14*/{  2 , 6 , {SW1A2,4,SW1A1,6, SW2A,6 ,  SW1B2,4,SW1B1,6, SW2B,6}},
/*327   15*/{  1 , 6 , {SW1A2,5,SW1A1,6, SW2A,6 ,  SW1B2,5,SW1B1,6, SW2B,6}},
/*noise 16*/{ 16 , 6 , {SW1A2,6,SW1A1,6, SW2A,6 ,  SW1B2,6,SW1B1,6, SW2B,6}},
        {   -1, 0 , {    0,0,    0,0,    0,0 ,     0,0,    0,0,    0,0}}};

/*
 *      mixer switch table .. first mixing stage
 *		the table  mixerNumFrqTbl[] above maps from mixerNum to frequency
*/
LOCAL MIXER_ENT mixerSwTbl[] = {
/*       ifNum    inpA     inpAB             outAB  */
/*300  */  {    1 , {SW4,1}, {SW3A,2,SW5A,2}, {SW3B,2,SW5B,2}},
/*750  */  {    2 , {SW4,3}, {SW3A,3,SW5A,3}, {SW3B,3,SW5B,3}},
/*1500 */  {    3 , {SW4,5}, {SW3A,4,SW5A,4}, {SW3B,4,SW5B,4}},
/*10000*/  {    4 , {SW4,4}, {SW3A,1,SW5A,1}, {SW3B,1,SW5B,1}},
/*0    */  {    5 , {-1,-1}, {SW3A,5,SW5A,5}, {SW3B,5,SW5B,5}},/*straight thru*/
/*seti */  {    6 , {SW4,6}, {SW3A,6,SW5A,6}, {SW3B,6,SW5B,6}},/*seti if*/
        {   -1 , {  0,0}, {   0,0,   0,0}, {   0,0,   0,0}}
        };
/*
 *  Cable table (heliax/fiber)
*/
LOCAL CABLE_TBL cableTbl = {
           { SW6A, IF1_SWOPEN  }, /* fib A*/
           { SW6A, IF1_SWCLOSED}, /* heliax A*/
           { SW6B, IF1_SWOPEN  }, /* fib B*/
           { SW6B, IF1_SWCLOSED}  /* hel B*/
      };
/*      
 *    hybrid table  (10ghz linear to circular)
*/
LOCAL HYBRID_TBL hybridTbl = {
     {SW7A,IF1_SWOPEN  ,SW7B,IF1_SWOPEN  ,SW8A,IF1_SWOPEN  ,SW8B,IF1_SWOPEN  },
     {SW7A,IF1_SWCLOSED,SW7B,IF1_SWCLOSED,SW8A,IF1_SWCLOSED,SW8B,IF1_SWCLOSED}
     }; 
/*      
*    to go db to switch values. the values in table are the binary
*    switches to  throw, the index is the value in db's
* 	
*/
LOCAL int    attnDbToSw[] = {
                     0,1,2,3,4,5,6,7,0xc,0xd,0xe,0xf
                };
/*
 *  for setSw3488 mask for bits 1..16
*/
LOCAL unsigned int  bitTbl[]={ 0x1       ,0x3       ,0x7       ,0xf       ,
                               0x1f      ,0x3f      ,0x7f      ,0xff      ,
                               0x1ff     ,0x3ff     ,0x7ff     ,0xfff     ,
                               0x1fff    ,0x3fff    ,0x7fff    ,0xffff    ,
                               0x1ffff   ,0x3ffff   ,0x7ffff   ,0xfffff   ,
                               0x1fffff  ,0x3fffff  ,0x7fffff  ,0xffffff  ,
                               0x1ffffff ,0x3ffffff ,0x7ffffff ,0xfffffff ,
                               0x1fffffff,0x3fffffff,0x7fffffff,0xffffffff
                 };
#endif
