#ifndef INCif2Conh
#define INCif2Conh
/*
 * 09feb05 added sigsrc
*/
/*		includes	*/

/*  
 * constants used by if2Prog.c
 *
*/
#define IF2_DONT_CHANGE   -1
#define IF2_DLOG_PWR_NAME  "/share/obs4/if2/pwr/log"

#define IF2_HP3488_SLOTS_POL       5
#define IF2_HP3488_SLOTS_CEN       0
#define IF2_HP3488_POL_A          "d1"
#define IF2_HP3488_POL_B          "d2"
#define IF2_HP3488_CEN            "d3"

/*	for 11 db attenuators. This is the number of indices-1 in table */

#define IF2_GAIN_MIN_DB	   -11
#define IF2_GAIN_MAX_DB		30

/*
 *   frequencies for input to iflo
*/
#define IF2_INPCFR_1500 1500
#define IF2_INPCFR_750   750
#define IF2_INPCFR_300   300
#define IF2_INPCFR_750NB   1
#define IF2_INPCFR_ALFA    2
/*
 *   center frequencies of bands for mixer input
*/
#define IF2_MCFR_1750   1750
#define IF2_MCFR_1500   1500
#define IF2_MCFR_1250   1250
#define IF2_MCFR_750     750
/*
 *   vlba input frequencies
*/
#define IF2_VLBA_1500   1500
#define IF2_VLBA_750     750
/*
 *   center freq for amp inp
*/
#define IF2_AMPINP_SYNTH      1
#define IF2_AMPINP_300      300
#define IF2_AMPINP_GHELIAX  200
/*
 *  unique positions on some of the synth switches.
*/
#define IF2_SYNNUM_VLBA_A 1
#define IF2_SYNNUM_VLBA_B 2
#define IF2_SYNNUM_SBAND  3
#define IF2_SYNNUM_SPARE  4
/* 
 * posisitions for synth switches.
*/
#define IF2_SYNPOS_30MHZ      1
#define IF2_SYNPOS_VLBA       2
#define IF2_SYNPOS_IF2        3
#define IF2_SYNPOS_FRONTPANEL 4
#define IF2_SYNPOS_SPARE      2

/*
 * device positions on amp output
*/
#if FALSE
<pjp013> no more extinp
#define IF2_AMPOUT_COR        1
#define IF2_AMPOUT_CONT       2
#define IF2_AMPOUT_DCD        3
#define IF2_AMPOUT_SPARE4     4
#define IF2_AMPOUT_SPARE5     5
#define IF2_AMPOUT_SPARE6     6
#define IF2_AMPOUT_SPARE7     7
#endif
/*
 * signal source codes:
*/
#define IF2_SIGSRC_CH         0
#define IF2_SIGSRC_GR         1
#define IF2_SIGSRC_NOISE      2

/*  for parsing keywords/values	*/

#define PARSE_PRE_IF2	  		"if2_"

#define IF2_IND_GAIN            0
#define IF2_IND_INPFRQ          1
#define IF2_IND_MIXFRQ          2
#define IF2_IND_AMPINP          3
#define IF2_IND_EXTINP          4
#define IF2_IND_SYNDEST         5
#define IF2_IND_VLBAINP         6
#define IF2_IND_XFRNORMAL       7
#define IF2_IND_30MHZIF         8
#define IF2_IND_SBDOP           9
#define IF2_IND_GLFRQ          10
#define IF2_IND_SYNFRQ         11
#define IF2_IND_SYNAMP         12
#define IF2_IND_NOISE          13
#define IF2_IND_CALSRC         14
#define IF2_IND_VIS30MHZ       15
#define IF2_IND_PWRMET         16
#define IF2_IND_430BLNK        17
#define IF2_IND_SIGSRC         18
#define IF2_IND_RDRBLNK        19
#define IF2_IND_ALFAAMP        20
/*
 * structure for program logging
*/
typedef struct {
    int     timeStamp;  /* dddsssss when power measured*/
    short   pwr1;       /* units .01 dbm*/
    short   pwr2;       /* units .01 dbm*/
    } IF2_PWR_LOG;

#endif
