/*
 *	include file for interference monitoring with hp8590 spectrum
 *	analyzer
 * history:
*/
#ifndef INCintfMonLibh
#define INCintfMonLibh


/*      defines         */

#define  HDR_LEN	      sizeof(INTFMON_HDR)
#define  SPC_SAMPLES_SPECTRA  401
#define  BYTES_PER_SAMPLE_OUT sizeof(short)
#define  HDR_MARKER "HDR_"
#define  OMNI_DIR   -1

/*      typedefs        */

#if FALSE
typedef struct {
        float   cfrMhz;         /* cfr of spectra */
        float   spanMhz;        /* span in mhz */
        int     year;           /* year .. 4 digits */
        int     dayNum;         /* day number of year */
        int     secMid;         /* seconds from midnite start integration */
        int     integTime;      /* secs of integration */
        int     srcAzDeg;       /* 0=north, 180=south */
        int     spcSamples;     /* 401 */
        } INTFMON_HDR;          /* header for rec*/
#endif 
/*
 * additions needed to header
 *  change: spanMhz --> spanData  (defined by filter inserted)
 *     add: spanAna -->            span of spectrum analyzer used
 *     add: dataFlag--> bitfield ... bad data flag 1 bit
 *	                         ... ant used 2 bits...
 *     add: antRollDeg -->          role of ant for log periodics...
 *  
*/
typedef struct {
	char    hdrMarker[4];   /* holds the 4 characters "HDR_" */
        int     hdrlen;         /* bytes in header*/
        int     reclen;         /* hdr + data in bytes*/
	char    version[4];     /* like v2.1. not null terminated*/
	int     date;           /* yyyyddd */
        int     time;           /* seconds since midnite*/
        float   cfrDataMhz;     /* cfr of spectra */
        float   cfrAnaMhz;  	/* cfr of spectrum analyzer */
        float   spanMhz;        /* span in mhz */
        int     integTime;      /* secs of integration */
        int     srcAzDeg;       /* 0=north, 180=south -1 omni */
        } INTFMON_HDR;          /* header for rec*/
 
typedef struct {
        INTFMON_HDR  hdr;          /* for output */
        short     data[SPC_SAMPLES_SPECTRA];    /* output shorts */
        } INTFMON_REC;

/*
 *	library declaractions 
*/
int  IMInpRec(int fd,int pipeRead,INTFMON_HDR* phdr,short* pdata);
int  IMInpRecs(int fd,INTFMON_HDR* phdrStart,INTFMON_HDR* phdrEnd,int maxRecs,
               INTFMON_REC* precArr);
void IMPrHdr(FILE* fp,int outHdr,INTFMON_HDR* phdr);
STATUS  IMSrchHdr(int fd,int pipeRead,INTFMON_HDR* pBhdr,int maxBytesTot,
    	         INTFMON_HDR* phdr,short *pdata,int *pbytesSkipped);


#endif	/* INCintfMonh*/
