/* 
 *	include file for ipFifo
 *        
*/
#ifndef INCipFifoh
#define INCipFifoh
#include	<stdio.h>
#include	"ipic.h"

/*	start duplicating some defs for correlator */

#define IPFIFODEVNAME	"/ipFifo"
/*
 *  interrupts 0- data ready,
*/
#define IPFIFO_INT0_NUM    0xff
/* 
 *	ipFifo particular ioctl's
*/
#define IPFIFOIOCWAITINT	       0x5
#define IPFIFOIOCSTATUS            0x6 
#define IPFIFOIOCDEBUG             0xa 
#define IPFIFOIOCENAINT            0xb 
#define IPFIFOIOCDISINT            0xc 
#define IPFIFOIOCRESET             0xf 

#define IPFIFOIOCLDWRDCNT          0x19 
#define IPFIFOIOCRDWRDCNT          0x1a 
#define IPFIFOIOCSTART             0x1b 
#define IPFIFOIOCRDINTVEC          0x1c 
#define IPFIFOIOCRDSINGLEWRD       0x29 
#define IPFIFOIOCRDDMA             0x2a 
#define IPFIFOIOCLAST              0x2c
/*
 * iosel addresses useds:
 * the ipFifo uses ioSelAB, (or CD)  to address registers.
 * There is a mask for each register that masks the allowable data bits.
*/
#define	IPFIFO_ADR_LD_INT_VEC     0X00
#define	IPFIFO_ADR_LD_CMD_WRD     0X01 
#define	IPFIFO_ADR_LD_WRD_CNT     0X02 
#define	IPFIFO_ADR_LD_PERI_BITS   0X03 
#define	IPFIFO_ADR_START_DMA      0X04
#define	IPFIFO_ADR_RD_INT_VEC     0X00 
#define	IPFIFO_ADR_RD_STATUS      0X01
#define	IPFIFO_ADR_RD_WRD_CNT     0X03 
#define	IPFIFO_ADR_RD_FIFO        0X10

/*
 *	data masks for each address
*/
#define	IPFIFO_MSK_INT_VEC        0X000000ff
#define	IPFIFO_MSK_CMD_WRD        0X00000003
#define	IPFIFO_MSK_WRD_CNT        0X0000ffff
#define	IPFIFO_MSK_PERI_BITS      0X00000003
#define	IPFIFO_MSK_STATUS         0X0000007f

/*
 * 	command word bits
 *	note that SE is shift enable, INT is integration
*/
#define IPFIFO_CMD_RESET              0x1 
#define IPFIFO_CMD_START_TRIG         0x2 
#define IPFIFO_CMD_START_IMD          0x3 
/*
 * status bits
*/
#define IPFIFO_STAT_INT_CNT          0x000f
#define IPFIFO_STAT_FIFO_ENABLED     0x0010
#define IPFIFO_STAT_FIFO_EMPTY       0x0020
#define IPFIFO_STAT_FIFO_FULL        0x0040
#define IPFIFO_STAT_FIFO_OVERFLOW    0x0080
/*
 *	wait interrupt structure
*/
typedef struct {
        int     late;           /* for interupt*/
        int     timeout;        /* for wait in ticks*/
        int     intcount;       /* interrupt*/
        int     statAtInt;      /* status at last interrupt*/
        }  IPFIFO_INTINFO;
/*
 *load word count 
*/
typedef struct {
	int	    useInt;		/* true/false*/
	int		wordCnt;	/* 1..32768*/	
	} IPFIFO_WRDCNT;
/*
 * read
*/
typedef struct {
	int		byteCount;		/*  to read.. should be multiple of 4*/
	char    *bufAdr;		    /*  to sto data.. should be multiple of 4*/
	int		timeOutTicks;	/*  for dma read*/
	} IPFIFO_READ;
/*
 * start
*/
typedef struct {
	int		onTrig;		/*  false --> immediate*/
	int		useInt;	    /* true --> turn on interrupt in wordcount*/
	int		wordCnt;    /* >0 --> load it */ 
	} IPFIFO_START;
#endif	/* INCipFifoh*/
