/*
 *	include file for ipGen 
*/
#ifndef INCipGenh
#define INCipGenh
#include	"ipic.h"

#define IPGENDEVNAME_A	"/ipGen_a"
#define IPGENDEVNAME_B	"/ipGen_b"
#define IPGENDEVNAME_C	"/ipGen_c"
#define IPGENDEVNAME_D	"/ipGen_d"
#define IPGENDEVNAME_AB	"/ipGen_ab"
#define IPGENDEVNAME_CD	"/ipGen_cd"
/*
 *	interrupts 0- freq update, 1- 1sec tick
*/
#define	IPGEN_INT0_NUM	0xff
#define	IPGEN_INT1_NUM	0xfe
#define IPGEN_INT_FRQ_UPDATE  0
#define IPGEN_INT_TICK        1
/* 
 *	ipGen particular ioctl's
*/
#define IPGENIOCWAITINT		  0x5
#define IPGENIOCDEBUG             0xa 
#define IPGENIOCENAINT            0xb 
#define IPGENIOCDISINT            0xc 
#define IPGENIOCRESET             0xf 
/*
 * addresses:
 * the ipGenth uses ioSelA, you can use any of the addresses since it will
 * respond to any of them. Bit 15 of the data differentiates between
 * cmd Word and data word
*/
#define IPGEN_ADR	0x0
/*
 *	Data word bits
*/
#define	IPGEN_DATA_WORD	     0x8000
/*
 *	Cmd  word bits
*/
#define IPGEN_CMD_WORD        0x0000
#define IPGEN_CMD_RESET       0x0000
/*
 * macros
*/
#define IPGEN_ADR_IN_REG(a)    ( (a) << 8)
#define IPGEN_DATA_BYTE(a)    ( (a) & 0xff)


typedef struct {
	int     intToUse;	/* 0 1sec tic, 1 data available*/
        int     late;           /* for interupt*/
        int     timeout;        /* for wait in ticks*/
        int     intcount;       /* interrupt*/
        int     statAtInt;      /* status at last interrupt*/
        }  IPGEN_INTINFO;

/*
 * prototypes from lib
*/
void	ipGenPrStatus(FILE* fp,int status);
#endif	/* INCipGenh*/
