/* 
 *	include file for ipPc
 *        
*/
#ifndef INCipPch
#define INCipPch
#include	<stdio.h>
#include	"ipic.h"

/*	start duplicating some defs for correlator */

#define IPPCDEVNAME	"/ipPc"
/*
 *  interrupts 0- data ready,
*/
#define IPPC_INT0_NUM    0xfd
#define IPPC_INT0_LEVEL  0x3
/* 
 *	ipPc particular ioctl's
*/
#define IPPCIOCWAITINT	         0x5
#define IPPCIOCSTATUS            0x6 
#define IPPCIOCDEBUG             0xa 
#define IPPCIOCENAINT            0xb 
#define IPPCIOCDISINT            0xc 

#define IPPCIOCLDINTEGLEN        0x19 
#define IPPCIOCRDINTEGLEN        0x1a 
#define IPPCIOCSTART             0x1b 
#define IPPCIOCRDINTVEC          0x1c 
#define IPPCIOCBLANK             0x1d 
#define IPPCIOCWAITFORTRIG       0x1e 
#define IPPCIOCSTOP              0x1f
#define IPPCIOCRD                0x29 
#define IPPCIOCLDCNFGWRD         0x2a 
#define IPPCIOCLAST              0x2a
/*
 * iosel addresses useds:
 * the ipPc uses ioSelAB, (or CD)  to address registers.
 * There is a mask for each register that masks the allowable data bits.
*/
#define	IPPC_ADR_LD_INTEGLEN_LSB 0X00 
#define	IPPC_ADR_LD_INTEGLEN_MSB 0X01 
#define	IPPC_ADR_LD_CONFIG_WRD   0X02 
#define	IPPC_ADR_LD_INT_VEC      0X03
#define	IPPC_ADR_LD_CMD_WRD      0X04 

#define	IPPC_ADR_RD_INTEGLEN_LSB 0X00 
#define	IPPC_ADR_RD_INTEGLEN_MSB 0X01 
#define	IPPC_ADR_RD_STATUS       0X02
#define	IPPC_ADR_RD_INT_VEC      0X03 
#define	IPPC_ADR_RD_PC_START     0X10 

/*
 *	data masks for each address
*/
#define	IPPC_MSK_INT_VEC        0X000000ff
#define	IPPC_MSK_CMD_WRD        0X00000003
#define	IPPC_MSK_STATUS         0X0000001f
/*
 * 	command word bits
*/
#define IPPC_CMD_STOP               0x1 
#define IPPC_CMD_START_TRIG         0x2 
#define IPPC_CMD_START_IMD          0x3 
/*
 * 	configuration bits
*/
#define IPPC_CFG_ENA_BLANK          0x1
#define IPPC_CFG_WAIT_EVERY_INTEG   0x2
#define IPPC_CFG_INTERRUPT_ENA      0x4 
/*
 * status bits
*/
#define IPPC_STAT_INTEG_ENA        0x0001
#define IPPC_STAT_BLANK_ENA        0x0002
#define IPPC_STAT_WAIT_EVERY_INTEG 0x0004
#define IPPC_STAT_INT_ENA          0x0008
#define IPPC_STAT_DATA_AVAIL       0x0010
/*
 * misc...
*/
#define IPPC_MAX_NUM_PC                 8 
/*
 *	wait interrupt structure
*/
typedef struct {
        int     late;           /* for interupt*/
        int     timeout;        /* for wait in ticks*/
        int     intcount;       /* interrupt*/
        int     statAtInt;      /* status at last interrupt*/
        }  IPPC_INTINFO;
/*
 * read
*/
typedef struct {
	int		pcToRead;		/*  bit mask. 0=1st 1-->read*/
	int	    packInAr;		/* true--> push down to low positions*/
    int     pcData[8];	    /*  read data into here*/
	int		timeOutTicks;	/*  for read*/
	} IPPC_READ;
#endif	/* INCipPch*/
