/*
 *	include file for ipSyn 
 * 26nov96.. removed 1 sec tick interrupt. now used by extTick..
*/
#ifndef INCipSynh
#define INCipSynh
#include	"ipic.h"

#define IPSYNDEVNAME	"/ipSyn"
/*
 *	interrupts 0- freq update, 1- 1sec tick
*/
#define	IPSYN_INT0_NUM	0xff
#define	IPSYN_INT1_NUM	0xfe
#define IPSYN_INT_FRQ_UPDATE  0
#define IPSYN_INT_TICK        1
/* 
 *	ipSyn particular ioctl's
*/
#define IPSYNIOCWAITINT		  0x5
#define IPSYNIOCSTATUS            0x6 
#define IPSYNIOCDEBUG             0xa 
#define IPSYNIOCENAINT            0xb 
#define IPSYNIOCDISINT            0xc 
#define IPSYNIOCRESET             0xf 
#define IPSYNIOCLDFRQ             0x10 
#define IPSYNIOCLDIPP             0x11 
#define IPSYNIOCUPDIMD            0x13 
#define IPSYNIOCUPDTICK           0x14 
#define IPSYNIOCUPDIPP            0x15 
#define IPSYNIOCCDFRQ             0x16 
#define IPSYNIOCCDIPP             0x17 
#define IPSYNIOCXFERSW            0x18
/*
 * addresses:
 * the ipSynth uses ioSelA, you can use any of the addresses since it will
 * respond to any of them. Bit 15 of the data differentiates between
 * cmd Word and data word
*/
#define IPSYN_ADR	0x0
/*
 *	Data word bits
*/
#define	IPSYN_DATA_WORD	     0x8000
#define	IPSYN_IPP_REG	     0x0000
#define	IPSYN_FREQ_REG1	     0x2000
#define	IPSYN_FREQ_REG2	     0x4000
#define	IPSYN_SET_DATA_READY 0x1000
#define	IPSYN_REG_ADR_5      0x0500
#define	IPSYN_REG_ADR_4      0x0400
#define	IPSYN_REG_ADR_3      0x0300
#define	IPSYN_REG_ADR_2      0x0200
#define	IPSYN_REG_ADR_1      0x0100
#define	IPSYN_REG_ADR_0      0x0000
#define IPSYN_XFER_RELAY_XMT 0x6001
#define IPSYN_XFER_RELAY_RCV 0x6000
/*
 *	Cmd  word bits
*/
#define IPSYN_CMD_WORD        0x0000
#define IPSYN_CMD_RESET_FLGS  0x0000
#define IPSYN_CMD_RESET_DDS   0x1000
#define IPSYN_CMD_UPDATE_IMD  0x2000
#define IPSYN_CMD_UPDATE_TICK 0x3000
#define IPSYN_CMD_UPDATE_IPP  0x4000
/*
 * status bits
*/
#define IPSYN_STAT_MASK            0xfc00
#define IPSYN_STAT_DATA_ERR        0x8000
#define IPSYN_STAT_DATA_READY      0x4000
#define IPSYN_STAT_UPDATE_ON_IPP   0x2000
#define IPSYN_STAT_NO_50MHZ_CLK    0x1000
#define IPSYN_STAT_NO_1_SEC_TICK   0x0800
#define IPSYN_STAT_NO_POWER        0x0400
/*
 * macros
*/
#define IPSYN_ADR_IN_REG(a)    ( (a) << 8)
#define IPSYN_DATA_BYTE(a)    ( (a) & 0xff)

#define CLOCKFRQ	    50e6 
#define TWO_48          2.81474976710656e14
#define FREQ_CNV        TWO_48/CLOCKFRQ

/* values to pass info ioctl for xfer relay	*/

#define IPSYN_XFER_RCV				0
#define IPSYN_XFER_XMT				1
#define IPSYN_RESET_FLAGS			1
#define IPSYN_RESET_DDS  			2

typedef struct {
	int     intToUse;	/* 0 1sec tic, 1 data available*/
        int     late;           /* for interupt*/
        int     timeout;        /* for wait in ticks*/
        int     intcount;       /* interrupt*/
        int     statAtInt;      /* status at last interrupt*/
        }  IPSYN_INTINFO;

typedef struct {
	double   frq;	 	/* value to code, freq or ipp*/
	int	 syn1;		/* true false*/
	int	 lastFreq;	/* last freq to send true/false*/
	unsigned short code[6];	/* coded values,ind 0 gets adr 0 etc..*/
        }  IPSYN_CODEFREQ;

/*
 * prototypes from lib
*/
void	ipSynPrStatus(FILE* fp,int status);
#endif	/* INCipSynh*/
