/*
 *	include file for ipTer 
 * 02nov01 - added mcctemp read
*/
#ifndef INCipTerEnch
#define INCipTerEnch
#include	"ipic.h"

#define TERENCDEVNAME	"/terEnc"
/*
 *	interrupts 0- freq update, 1- 1sec tick
*/
#define	TERENC_INT0_NUM	0xff
#define TERENC_INT_TICK        1
#define TERENC_MAX_LOOP_STATUS 100
/* 
 *	ipTer particular ioctl's .. stay away from 0x12
*/
#define TERENCIOCWAITINT		  0x5
#define TERENCIOCDEBUG             0xa 
#define TERENCIOCRESET             0xf 
/*
 * ipTerEnc ioctl's are 0x10 up..
 * ipTerVel ioctl's tart at 0x30  .. they should not overlap...
*/
#define TERENCIOCRDENC             0x10 
#define TERENCIOCRDENCZ            0x11 
#define TERENCIOCRDENCM            0x13 
#define TERENCIOCRDSTATWD          0x14 
#define TERENCIOCRDPOT             0x15 
#define TERENCIOCRDCMD             0x16 
#define TERENCIOCRDCMDMASK         0x17 
#define TERENCIOCLDCMD             0x18 
#define TERENCIOCLDCMDMASK         0x19 
#define TERENCIOCSNDCMD            0x1a 
#define TERENCIOCENASAF            0x1b 
#define TERENCIOCLDSNDCMD          0x1c 
#define TERENCIOCRDSTATWDALL       0x1d 
#define TERENCIOCRDMCCTEMP         0x1e 
/*
 *iosel  addresses:
*/
/* 	active encoder */	

#define IPTER_E_RDENC_HOLD	 	0xf

#define IPTER_E_RDENC_LV  	 	0x0
#define IPTER_E_RDENC_RV  	 	0x1
#define IPTER_E_RDENC_LH  	 	0x2
#define IPTER_E_RDENC_RH  	 	0x3
#define IPTER_E_RDENC_T   	 	0x4

/*	z index (once a turn)		*/

#define IPTER_E_RDENC_LV_Z  	 	0x5
#define IPTER_E_RDENC_RV_Z  	 	0x6
#define IPTER_E_RDENC_LH_Z  	 	0x7
#define IPTER_E_RDENC_RH_Z  	 	0x8
#define IPTER_E_RDENC_T_Z  	 	0x9

/*	m index (master.. once in middle)*/

#define IPTER_E_RDENC_LV_M  	 	0xa 
#define IPTER_E_RDENC_RV_M  	 	0xb
#define IPTER_E_RDENC_LH_M  	 	0xc
#define IPTER_E_RDENC_RH_M  	 	0xd
#define IPTER_E_RDENC_T_M  	 	0xe

/* status word addresses */

#define IPTER_E_STAT_FLTS 	 	0x10
#define IPTER_E_STAT_PWR  	 	0x11
#define IPTER_E_STAT_IND  	 	0x12
#define IPTER_E_STAT_LIM  	 	0x13
#define IPTER_E_STAT_LB_CMD 	    0x14
#define IPTER_E_STAT_LB_MASK	    0x15

#define IPTER_E_RD_CMD 	        0x16
#define IPTER_E_RD_CMD_MASK       0x17
#define IPTER_E_STAT_WD6          0x18

/* mcc temp */

#define IPTER_E_RD_MCCTEMP        0x1A

/* potentiometer */

#define IPTER_E_POT_LV            0x1B
#define IPTER_E_POT_RV            0x1C
#define IPTER_E_POT_LH            0x1D
#define IPTER_E_POT_RH            0x1E
#define IPTER_E_POT_T             0x1F

/*
 * 	write address
*/
#define IPTER_E_LDCMD             0x00
#define IPTER_E_LDMSK             0x01
#define IPTER_E_SNDCMD            0x02
#define IPTER_E_ENABLE_SAFETY     0x03

/*
* masks
*/
#define	IPTER_E_STATWDS_UPDATED   0x0001
#define	IPTER_E_STATWD6_PE01      0x0002
#define	IPTER_E_STATWD6_PE23      0x0004
#define	IPTER_E_STATWD6_PE45      0x0008
#define	IPTER_E_STATWD6_PE        0x000e

#define	IPTER_E_CMD_ACPWR         0x8000

#define	IPTER_E_CMD_LV_DRV        0x4000
#define	IPTER_E_CMD_RV_DRV        0x2000
#define	IPTER_E_CMD_LH_DRV        0x1000
#define	IPTER_E_CMD_RH_DRV        0x0800
#define	IPTER_E_CMD_T_DRV         0x0400

#define	IPTER_E_CMD_LV_Z          0x0200
#define	IPTER_E_CMD_RV_Z          0x0100
#define	IPTER_E_CMD_LH_Z          0x0080
#define	IPTER_E_CMD_RH_Z          0x0040
#define	IPTER_E_CMD_T_Z           0x0020

#define	IPTER_E_CMD_LV_M          0x0010
#define	IPTER_E_CMD_RV_M          0x0008
#define	IPTER_E_CMD_LH_M          0x0004
#define	IPTER_E_CMD_RH_M          0x0002
#define	IPTER_E_CMD_T_M           0x0001
 
/* 	typedefs	*/

typedef struct	{
	unsigned int	crcErr :5;	/* lv,rv,lH,rH,T*/
	unsigned int	mIndErr:5;  /* lv,rv,lH,rH,T*/
	unsigned int	zIndErr:5;  /* lv,rv,lH,rH,T*/
	unsigned int 	filler:17;
	} TERENC_ST;

typedef struct	{
	int		vL;
	int		vR;
	int		hL;
	int		hR;
	int		t;	/* tilt*/
	char     crcE; /* vl,vr,hl,hr,tilt*/
	char    mIndE;
	char    zIndE;
	char	fill;
	} TERENC_DAT_ERRS;

typedef struct	{
	int		vL;
	int		vR;
	int		hL;
	int		hR;
	int		t;	/* tilt*/
	int	  fill;
	} TERENC_DAT;
#if FALSE
typedef struct	{
	int		vL;
	int		vR;
	int		hL;
	int		hR;
	int		t;	/* tilt*/
	} TERENC_POT_DATA;
#endif

/*
 *	to readback selected statwords and optionally send cmd
*/
typedef struct {
	int	    wdsToUse;	/* statwds to read back.. bitmask*/
	int	    sndCmd;	    /* if non zero, send cmd with 0 mask*/
	int		statWds[7]; /* return data here*/
	} TERENC_STAT_WDS_SEL;

/*
 * to load and send command and mask
*/
typedef struct {
	int		cmd;	/* to get returned, bitmap b0->b6*/
	int		cmdMask;/* to get returned, bitmap b0->b6*/
	} TERENC_LDSND_CMD;

/*
 * prototypes from lib
*/
void	ipTerEPrStatus(FILE* fp,int status);

#endif	/* INCipTerh*/
