/*
 *	include file for ipTer 
*/
#ifndef INCipTerVelh
#define INCipTerVelh
#include	"ipic.h"

#define TERVELDEVNAME	"/terVel"
/*
 *	interrupts 0- freq update, 1- 1sec tick
*/
#define	TERVEL_INT0_NUM	0xff
#define TERVEL_INT_TICK        1
#define TERVEL_MAX_LOOP_STATUS 100
/* 
 *	ipTer particular ioctl's .. stay away from 0x12
 *  RDVEL    reads from the VtoF converter .. 
 *  RDVELREG reads from the ipBoard reg. This is what we send
*/

#define TERVELIOCDEBUG             0x0a 
  
#define TERVELIOCRDVELATOD         0x30 
#define TERVELIOCRDVELREG          0x31 
#define TERVELIOCRDMONPORT         0x32 
#define TERVELIOCRDINTLEN          0x33 
#define TERVELIOCRDTEMP            0x34 
#define TERVELIOCRDSTAT            0x35 


#define TERVELIOCLDVEL             0x36 
#define TERVELIOCLDINTLEN          0x37 
#define TERVELIOCSNDVEL            0x38 
#define TERVELIOCLDSNDVEL          0x39 

/*
 *iosel  addresses:
*/
/* 	read velocity reg in ip board  (what we are sending)*/	

#define IPTER_V_RDVELREG_LV  	 	0x0
#define IPTER_V_RDVELREG_RV  	 	0x1
#define IPTER_V_RDVELREG_LH  	 	0x2
#define IPTER_V_RDVELREG_RH  	 	0x3
#define IPTER_V_RDVELREG_T   	 	0x4

#define IPTER_V_RDSTAT    	 	    0x5
#define IPTER_V_RDINTLEN  	 	    0x6

/*	 read the velocities read back from VtoF converted */

#define IPTER_V_RDVELATOD_LV  	 	0x10
#define IPTER_V_RDVELATOD_RV  	 	0x11
#define IPTER_V_RDVELATOD_LH  	 	0x12
#define IPTER_V_RDVELATOD_RH  	 	0x13
#define IPTER_V_RDVELATOD_T   	 	0x14

#define IPTER_V_RDMONPORT_LV  	 	0x15
#define IPTER_V_RDMONPORT_RV  	 	0x16
#define IPTER_V_RDMONPORT_LH  	 	0x17
#define IPTER_V_RDMONPORT_RH  	 	0x18
#define IPTER_V_RDMONPORT_T   	 	0x19

#define IPTER_V_RDTEMP        	 	0x1A

/*
 * 	write address
*/
#define IPTER_V_LDVEL_LV  	 		0x0
#define IPTER_V_LDVEL_RV  	 		0x1
#define IPTER_V_LDVEL_LH  	 		0x2
#define IPTER_V_LDVEL_RH  	 		0x3
#define IPTER_V_LDVEL_T   	 		0x4

#define IPTER_V_SENDVEL   	 		0x5
#define IPTER_V_LDINTLEN  	 		0x6

/*
* masks
*/
#define	IPTER_V_STAT_UPDATED      0x0001
#define	IPTER_V_STAT_LOCAL        0x0002
#define	IPTER_V_STAT_PE_TOVCC     0x0004
#define	IPTER_V_STAT_PE_FROMVCC   0x0008
#define	IPTER_V_STAT_PE_LOOPBACK  0x0010
#define	IPTER_V_STAT_VTOF_INTEG_DONE 0X0020
#define	IPTER_V_STAT_MASK         0X003f

/* 	typedefs	*/


typedef struct	{
	int		vL;
	int		vR;
	int		hL;
	int		hR;
	int		t;	/* tilt*/
	} TERVEL_DATA;

/*
 * prototypes from lib
*/
void	ipTerVPrStatus(FILE* fp,int status);

#endif	/* INCipTerh*/
