/*
 *	include file for lMsgLib.c 
*/
#ifndef INClMsgLibH
#define INClMsgLibH

#include	<semLib.h>
#include	<string.h>
#include	<stdio.h>
#define	LMSG_STRUCT_VALID	123456789

/*
 * data structure for local messages.
*/
typedef struct	{
	int	structValid; /* set to 12345678 after setup ok*/
	int	numMsgs;    /* max number of msgs*/
	int	lenMsgBytes;/* length one element in bytes*/
	char    *pmsgs;	    /* ptr to start of msgs*/

	SEM_ID  freeBufSem;    /* counting sem, free bufs in ar*/
	int	nextFreeBufInd;    /* location next free buf to take*/
	int	curNumFreeBufs;/* in array*/

	SEM_ID  msgBufSem;     /* counting sem, Number msgs in ar*/
	int	nextMsgBufInd; /* location next msg to return*/
	int	curNumMsgs;    /* location next msg to return*/
	}  LMSG_INFO;

typedef LMSG_INFO *LMSG_ID;



/*	prototypes	*/

void    lMsgCounts(LMSG_ID   id,int *pnumElm,int *pnumFree,int *pnumMsg);
void    lMsgDbg(LMSG_ID   id,FILE *fp);
void   *lMsgGetFreeBuf(LMSG_ID pid,int timeOut);
void   *lMsgGetMsg(LMSG_ID pid,int timeOut);
void    lMsgFree(LMSG_ID pId);
LMSG_ID lMsgInit(int numElm,int lenElmBytes);
void   *lMsgPeekMsg(LMSG_ID pid,int timeOut);
STATUS  lMsgPutFreeBuf(LMSG_ID pid,int notSent);
STATUS  lMsgPutMsg(LMSG_ID pid);
#if FALSE
/*
 * person that puts msgs
*/
lMsgGetFreeBuf( )
	1. take free buf sem;
	2. return ptr,
	3. increment next free buf ind

lMsgPutMsg( )
	1. give msgBufSem

/* 
 * person that takes msgs..
*/

lMsgGetMsg( )
	1. take msgBufSem.
	2. compute msg address.
	3. increment next msg ptr

lMsgPeekMsg()
	1. take msgBufSem.
	2. compute msg address.
	3. give msgBufSem since this msg stays on queue.

lMsgPutFreeBuf( )
	1. give freeBufSem
#endif

#endif  /* lMsgLibH */
