#ifndef INCllgLibh
#define INCllgLibh

/*
 *	include file for llgLib.c low level generic routines for
 *	ttProg, tieProg, agcProg
 *
modification history:
xx.x,06apr96,pjp ... in op struct add lastError. if op.stat comes out error,
		             calling program can look here for the erorr num.
*/

#include	<vxWorks.h>
#include	<stdio.h>
#include	<semLib.h>
#include	"aoMsg.h"
#include	"lMsgLib.h"

/*
 *  commands input to output program
*/
#define  LLG_CMD_POSITION               1
#define  LLG_CMD_FLUSH                  2
/*
 * status output program
*/
#define LLGO_STAT_NOTRUNNING            0
#define LLGO_STAT_RUNNING       	1
#define LLGO_STAT_EXITTED       	2
#define LLGO_STAT_ERROR_EXIT    	3

/*      typedefs        */

/*
 * output program generic info
*/
typedef struct {
        char            prgName[20];  /* name of program*/
        int             stat;         /* 0 not running*/
                                        /* 1 running*/
                                        /* 2 normal exit*/
                                        /* 3 error exit */
		int		        lastErr;	  /* we had*/
        int             quit;         /* to get output program to quit*/
        int             secLastTick;  /* seconds midnite last tick*/
        int             secNextTick;  /* seconds midnite next tick*/
	    int		lmsgHasTimeStamp;/* true if local msg has time stamp*/
        int             holdingMsg;/* true --> currently holding*/
		SEM_ID          semTickProc;  /* flush on end of tick processing*/
        /*
         * Monitoring..Output program MO..
        */
        int             MmsgsInput;     /* msgs we've input*/
        int             MmsgsSent;      /* msgs we've sent*/
        int             MmsgsDiscarded; /* time has passed*/
        int             MmsgsHeld;      /* for future times, 1 per msg*/
        int             MmsgsHeldCnt;   /* for future times, 1 per sec hld*/
        int             McntTickTimeouts;/* times we timed out on tick*/
        /*
         *  timing junk
        */
        int             toGetLocMsg;    /* ticks to wait for a local msg*/
        int             usecsNeededBeforeTick;/* before wait for tick*/
        } LLG_OP_INFO;
/*
 * generic output info..
*/
typedef struct {
         /*
          * queues/msgs
         */
        char            prgName[20];    /* name of this program*/
        AOMSG_Q_ID      inpCmdQ;        /* input command queue*/
        AOMSG_Q_ID      replyQ;         /* replys to msgs sent by us*/
        LMSG_ID         lMsgId;         /* id to pass loca messages*/
        int             maxLocMsgs;     /* max number local msgs*/
        int             maxLocMsgLen;   /* msg length in bytes*/
        int             flushLmsgs;     /* true --> flushing local msgs*/
        int             toGetLbuf;      /* getting local buf ttProg*/
        int             toGetRemMsg;    /* waiting for msg from remote*/
        LLG_OP_INFO     op;             /* output program generiv info*/
	    volatile int	*pprRunning;	/* to global variable*/
	    volatile int	*pstopProg;	/* to global variable*/
        } LLG_INFO;
/*
 *      generic msg.. all msgs must have a cmd/timeStamp at the front.
*/
typedef struct {
        int     cmd;            /* what the msg is */
        int     timeStamp;      /* seconds from midnite*/
        } LLG_LMSG;
/*
 * tick time , sec midnite, usecs from tick
*/
typedef struct {
	int	secMidnite;
	int	usecSinceTick;
	} LLG_TICK_TIME;
/*
 *	prototypes
*/
void    llgEndProg(LLG_INFO *pllgI);
STATUS  llgFlushBufs(LLG_INFO *pllgI);
STATUS  llgStartProg(char *prgName,char *prgNameO,char *inpCmdQName, 
		     volatile int  *pprRunning,volatile int *pstopProg,
		     int maxRemMsgs,int maxLocMsgs,int maxLocMsgLen,
       	     int toGetLocBuf,int toGetRemMsg,int toGetLoLocg,
       	     int usecsNeededBeforeTick,int lmsgHasTimeStamp,
		     LLG_INFO *pllgI);
void    llgEndOProg(LLG_OP_INFO *popI,int exitStat);
void    llgClrFlush(LLG_INFO *pllgI);
STATUS  llgGetLMsg(LLG_INFO *pllgI,int nextSec,LLG_LMSG **ppmsg,int *ptimeDif,
        	   LLG_TICK_TIME *ptickTime,int *pgoWaitOnTick,int *pflushing);
STATUS  llgSemTPFlush(LLG_OP_INFO *popI);
STATUS  llgSemTPWait(LLG_OP_INFO *popI,int timeout);
STATUS  llgStartOProg(LLG_OP_INFO *popI);
int     llgWaitTick(LLG_OP_INFO *popgI);
void    llgDbg(FILE *fp,LLG_INFO *pllgI);


#endif  /* llgLibi */
