/*
 *	include file for laser ranging
*/
#ifndef INClrh
#define INClrh
/*
 * laser ranger data read back into from file
*/
typedef struct {
    /* line 1 */
    int     dayNum;
    int     hour;
    int     min;
    int     sec;
    /* line 2  this data is not valid*/
    float   zaCh[2]; /* degrees*/
    float   az;     /* degrees*/
    int     wrap;
    /* line 3 */
    float   tempB;      /* bowl temperature F*/
    float   tempP;      /* platform temp F*/
    /* line 4-10 distance, measure time */
    float   dist[7];
    int     tmMeas[7];  /* time for measurement in seconds*/
    /* line 11  */
    float   tiltNS;     /* north south tilt sensor*/
    float   tiltEW;     /* east west  tilt sensor*/
    float   tiltTc;     /* tilt sensor time constant units ???*/
    /* line 12  */
    int     timeStp;    /* seconds between reading.. = 120 seconds*/
    /* line 13  */
    int     zeros[2];   /* two zeros*/
    }   LR_DATA;


#endif	/* INClrh*/
