/*
 *	include file for phil's tarlib.a (target library routines)
 *
 * history:
 * 4/7/92  - created
*/
#ifndef INCmodellibh
#define INCmodellibh
#ifdef	VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<stdio.h>

/*	defines	*/

#define MAX_MODEL_COEF  13
#define MAX_ENCTBL_ENTRY 41
#define	ENCTBL_STEP	 	 .5

/*	typedefs	*/

typedef struct {
    char     modelName[40]; /* name of model*/
    char     encoderName[40]; /* name of encoder*/
    char     format[20];
    int      coefInModel;   /* per axis*/
    int      modelHasEncTbl;/* true if model uses incoder table*/
    double   azCoef[20];
    double   zaCoef[20];
    double   encTblAz[41];
    double   encTblZa[41];
    } MODEL_INFO;

/*	prototypes	*/

void modelDmp(MODEL_INFO *pmodI,FILE *fp);
STATUS modelCmpAll(MODEL_INFO *pmodI,int numPnts,double *pazDeg,double *pzaDeg,
			       double *pazCor,double *pzaCor);
STATUS modelCmpEnc(MODEL_INFO *pmodI,int numPnts,double *pazDeg,double *pzaDeg,
			     double *pazEncCor,double *pzaEncCor);
STATUS modelCmpMod(MODEL_INFO *pmodI,int numPnts,double *pazDeg,double *pzaDeg,
			     double *pazModCor,double *pzaModCor);
void modelFmtA(MODEL_INFO *pmodI,int numPnts,double *pazDeg,double *pzaDeg,
			   double *pazModCor,double *pzaModCor);
void modelFmtB(MODEL_INFO *pmodI,int numPnts,double *pazDeg,double *pzaDeg,
			   double *pazModCor,double *pzaModCor);
void modelFmtM(MODEL_INFO *pmodI,int numPnts,double *pazDeg,double *pzaDeg,
			   double *pazModCor,double *pzaModCor);
STATUS modelInp(char *pdir,char *pmodelFileNm,char *pmodelName,
      			char *pencFileNm,MODEL_INFO *pmodI);
#endif	/*INCmodelh*/  
