#ifndef	INCmtioh
#define INCmtioh
/*
 * Structures and definitions for mag tape io control commands
 */
/* from ioccom.h .. mag tape io control commands */

#define _IOCPARM_MASK   0xff            /* parameters must be < 256 bytes */
#define _IOC_OUT        0x40000000      /* copy out parameters */
#define _IOC_IN         0x80000000      /* copy in parameters */
/* the 0x20000000 is so we can distinguish new ioctl's from old */
#define _IOR(x,y,t)     (_IOC_OUT|((sizeof(t)&_IOCPARM_MASK)<<16)|('x'<<8)|y)
#define _IOW(x,y,t)     (_IOC_IN|((sizeof(t)&_IOCPARM_MASK)<<16)|('x'<<8)|y)

/*      mtio.h  */

#define  MTIOCTOP        _IOW(m, 1, struct mtop)         /* do a mag tape op */

#define MTWEOF          0       /* write an end-of-file record */
#define MTFSF           1       /* forward space over file mark */
#define MTBSF           2       /* backward space over file mark (1/2" only )*/
#define MTFSR           3       /* forward space to inter-record gap */
#define MTBSR           4       /* backward space to inter-record gap */
#define MTREW           5       /* rewind */
#define MTOFFL          6       /* rewind and put the drive offline */
#define MTNOP           7       /* no operation, sets status only */
#define MTRETEN         8       /* retension the tape (cartridge tape only) */
#define MTERASE         9       /* erase the entire tape */
#define MTEOM           10      /* position to end of media */
#define MTNBSF          11      /* backward space file to BOF */

/* structure for MTIOCTOP - mag tape op command */

struct  mtop    {
        short   mt_op;          /* operations defined below */
        daddr_t mt_count;       /* how many of them */
};
#endif	/*INCmtioh*/
