/* 
*	physical limits for some values in  agcProg
*/
#ifndef INCpntAGCLimh
#define INCpntAGCLimh
/*
*modfication history..
26mar96,pjp	- started. the software position limits are not yet the
		  the correct ones.
xx.x,19jun97,pjp updated gr,ch,az from mike davis memo 6/97
xx.x,19oct97,pjp Kicked unbalance limit up to 19.5 deg
xx.x, 5nov97,pjp set azimuth max vel to half slew rate until az rails are
			 fixed.
			 - set greg neg velocity to -.02 deg/sec
xx.x,13feb98,pjp set greg neg velocity back to  -.04 deg/sec
xx.x,16apr98,pjp az axis velocity back to max 
xx.x,05mar99,pjp set greg neg velocity back to  -.04 deg/sec
*/
#ifndef MAX
#define MAX(a,b)	( (a)>(b)?(a):(b))
#endif
#ifndef MIN
#define MIN(a,b)	( (a)<(b)?(a):(b))
#endif

/*	time limits in 1 day.. units  millisecs		*/

#define VTX_LIM_TIME_MS_MIN         0
#define VTX_LIM_TIME_MS_MAX         86399999

/*
 *	azimuth, gregorian, carriage house software position/velocity LIMITS
 *        position units are encoder values .0001 degrees 
 *	  velocity units are encoder values/sec .0001 degrees/sec
 *	
modification history:
26jun97 updated to ricardo eliases mail msg 25jun97
	    az,gr,ch, ch/gr limit
*/
/*
 *	AZIMUTH LIMITS plc Pre,Final, agc software final, Vel min/max, accel lim.
*/
#define VTX_PLIM_POSMAX_AZ_TTD               7190000
#define VTX_FLIM_POSMAX_AZ_TTD               7200000
#define VTX_SWFLIM_POSMAX_AZ_TTD             7199900

#define VTX_PLIM_POSMIN_AZ_TTD                 10000
#define VTX_FLIM_POSMIN_AZ_TTD             	       0
#define VTX_SWFLIM_POSMIN_AZ_TTD                 100

#define VTX_SWLIM_VELMAX_AZ_TTDS	              4167 
#define VTX_SWLIM_VELMIN_AZ_TTDS	             -4167 

#if FALSE
#define VTX_SWLIM_VELMAX_AZ_TTDS	              2000 
#define VTX_SWLIM_VELMIN_AZ_TTDS	             -2000 
#endif

#define VTX_SWLIM_ACCEL_AZ_TTDSS                  1000 

/*	
 *	GREGORIAN LIMITs 
 *  emgLim -  04feb05 measured
 *   down  = za=  .9581
 *     up  = za=19.7804
 *  hardware limits: 04feb05 strikers replace cam switch 
 *     tried for: final .04 inside emg, pre: .04 inside final.
 *                listed below is what we ended up with.
 *   downFinal: 1.0187 driving into the limit.
 *   downPre: : 1.05  (eyeballed when light went on..)
 *   upFinal:  19.7378
 *   upPre:    19.7019
 *
 * software Pre,Final,Vel min/max
 * Note the plim,flim are from the plc values
 *          swflim is from the agcProg (in the vme)
 *
*/
#define VTX_PLIM_POSMAX_GR_TTD                196400
#define VTX_FLIM_POSMAX_GR_TTD                197000
#define VTX_SWFLIM_POSMAX_GR_TTD              196900

#define VTX_PLIM_POSMIN_GR_TTD               11100  
#define VTX_FLIM_POSMIN_GR_TTD             	 10500 
#define VTX_SWFLIM_POSMIN_GR_TTD           	 10600 

#define VTX_SWLIM_VELMAX_GR_TTDS	               417 
#define VTX_SWLIM_VELMIN_GR_TTDS	              -417 
#if FALSE
  22jun98 1/2 slew downhill till reg board fixed
  8oct98 back to full slew
  05mar99 back to full slew
#define VTX_SWLIM_VELMIN_GR_TTDS	              -200 
#endif
#define VTX_SWLIM_ACCEL_GR_TTDSS                   250 
/*	
 *	carriage house LIMITS 
*/
#define VTX_PLIM_POSMAX_CH_TTD                199400
#define VTX_FLIM_POSMAX_CH_TTD                200000
#define VTX_SWFLIM_POSMAX_CH_TTD              199900

#define VTX_PLIM_POSMIN_CH_TTD                 -1800 
#define VTX_FLIM_POSMIN_CH_TTD                 -2400
#define VTX_SWFLIM_POSMIN_CH_TTD               -2300

#define VTX_SWLIM_VELMAX_CH_TTDS	               417 
#define VTX_SWLIM_VELMIN_CH_TTDS	              -417 

#define VTX_SWLIM_ACCEL_CH_TTDSS                   250 
/*
 * VTX_COL_CHKTTD	      min separatation ch,gr. for Collision check.			
   				          this is the slowdown limit 8.27 is the final limit
*/
#define VTX_COL_CHKTTD						     83300
/*
 * gregorian ch wait balance ...mutual limits
 * HI_CHKTTD - above this gr position, illegal ch position exist
 * VTX_GR_HI_CHK_SCALE	  ZcTTD=(ZgTTD-HICHKTTD)/CHK_SCALE  line for high check
 * VTX_GR_LOW_CHKTTD 	  gr below this position, ch must move down from 20 deg
 * VTX_GR_LOW_CHK_SCALE   ZcTTD=(CHK_SCALE*(ZgTTD-VTX_GR_LOW_CHKTTD) + 200000
*/
#define VTX_GR_HI_CHKTTD						195000
#define VTX_GR_HI_CHK_SCALE					     .2500 
#define VTX_GR_LOW_CHKTTD 		                 10000
#define VTX_GR_LOW_CHK_SCALE 				     3.66667
/*
 * when we compute the slave position :
 * SLV_XX_YY_hi/low xx is slave, yy is master.
 *    when ch is slave: 
 *         go to 8.6 when greg < 9 degrees
 *         go to max(20) when greg > 18 degrees
 *    in between do a linear ramp.
 *
 *    when ch master
 *      park greg at 10 degrees.
*/
#define VTX_SLV_CH_GR_LOW_TTD				     00000
#define VTX_SLV_CH_GR_HI_TTD 				    200000
#define VTX_SLVPOS_GR_SIT_TTD			        100000
/*
 * macro to limit az to max/min physical positions
*/
#define VTX_LIMCHK_AZTTD(azReqTTD)   ( MIN(VTX_SWFLIM_POSMAX_AZ_TTD, \
					MAX(azReqTTD,VTX_SWFLIM_POSMIN_AZ_TTD)))

#define VTX_LIMCHK_GRTTD(grReqTTD)   ( MIN(VTX_SWFLIM_POSMAX_GR_TTD, \
					MAX(grReqTTD,VTX_SWFLIM_POSMIN_GR_TTD)))

#define VTX_LIMCHK_CHTTD(chReqTTD)   ( MIN(VTX_SWFLIM_POSMAX_CH_TTD, \
					MAX(chReqTTD,VTX_SWFLIM_POSMIN_CH_TTD)))

#define VTX_LIMCHKV_AZTTDS(azReqTTDS)   ( MIN(VTX_SWLIM_VELMAX_AZ_TTDS, \
					MAX(azReqTTDS,VTX_SWLIM_VELMIN_AZ_TTDS)))

#define VTX_LIMCHKV_GRTTDS(grReqTTDS)   ( MIN(VTX_SWLIM_VELMAX_GR_TTDS, \
					MAX(grReqTTDS,VTX_SWLIM_VELMIN_GR_TTDS)))

#define VTX_LIMCHKV_CHTTDS(chReqTTDS)   ( MIN(VTX_SWLIM_VELMAX_CH_TTDS, \
					MAX(chReqTTDS,VTX_SWLIM_VELMIN_CH_TTDS)))

#endif  /* pntAGCLimh */
