/*
 *	include file for prgMgr   access routines
 * history:
 * 25aug95 started
*/
#ifndef INCPRGMGRH 
#define INCPRGMGRH 

/*	includes	*/

#include	"aoMsg.h"
#include	"bufPoolLib.h"
/*	defines		*/
/*	these are indices into the prgMgr table		
	When added new entries, be sure that you don't go over
	PRG_TLB_MAX_INDEX in prgMgr.c.. If needed,increase 
	PRGTBL_MAX_INDEX and then recompile prgMgr
	.. note we only use -999,0,1.. all others come from disc file
*/

#define	PRGNUM_NOPROG  -999
#define	PRGNUM_PRGMGR 	 0
#define PRGNUM_GWPROG    1
#define	PRGNUM_SWPROG	 2
#define	PRGNUM_QPROG 	 3
#define	PRGNUM_TPPROG	 4
#define	PRGNUM_DSPROG	 5
#define	PRGNUM_APPROG	 6
#define	PRGNUM_SKPROG	 7
#define	PRGNUM_SPSPROG	 8
#define	PRGNUM_TPINPPROG 9
#define	PRGNUM_MCPPROG  10
#define	PRGNUM_RIPROG	11
#define	PRGNUM_TTPROG   12
#define	PRGNUM_TTTST    13
#define	PRGNUM_AGCPROG  14
#define PRGNUM_AOMPING  15
#define	PRGNUM_AGCTST   16
#define	PRGNUM_IF1PROG  17
#define	PRGNUM_LAST     17


/*	max lengths for character strings in prgMgr table	*/

#define	MAXLEN_PRGNAME  16
#define	MAXLEN_CPUNAME  16

/*	status of a particular program	*/ 

#define	PM_PROGSTAT_LOC_NOT_LOADED 	 0
#define	PM_PROGSTAT_LOC_LOADED 	 	 1
#define	PM_PROGSTAT_LOC_RUNNING	 	 2
#define	PM_PROGSTAT_REM                  3 

#define PM_PROGRAM_LOCAL		"local"
#define PM_ROUTINE_NONE 		"none"
/*
 *	prgmgr buf pool cmds
*/
#define PM_BPCMD_CREATE		 1 
#define PM_BPCMD_DELETE 	 2 
#define PM_BPCMD_QUERYBYNAME 3
#define PM_BPCMD_QUERYALL    4

/*	typedefs	*/
/*	for the wait and start functions passed in	*/

typedef int        (*FUNC_WAIT)( int timeout);
typedef STATUS     (*FUNC_START)( void );

/*	prototypes	*/

/*	 
 *  routines acceping prgNum
*/
STATUS     prgMFAddALocProg(int prgNUm,AOMSG_Q_ID inpQId,AOMSG_Q_ID replyQId);  
STATUS       prgMFChkTbl(void);
AOMSG_Q_ID prgMFGetInpQ(int prgNum);  
AOMSG_Q_ID prgMFGetReplyQ(int prgNum);  
int        prgMFGetRunning(int prgNum);  
int		   prgMFGetTid(int prgNum);
int 	   prgMFGetFds(int prgNum,int *fdAr);

/*
 * routines accepting prgName
*/
AOMSG_Q_ID prgMGetInpQ(char *prgName);  
AOMSG_Q_ID prgMGetReplyQ(char *prgName);  
int        prgMGetRunning(char *prgName);  

STATUS     prgMInfo(int prgNum,int *premote,int *ploadedLoc,int *prunningLoc,
		        AOMSG_Q_ID *pinpQId,AOMSG_Q_ID *preplyQId);

int    prgMListNum(int statCode,int *NumArr,int maxDim);
int    prgMListName(int statCode,char NameArr[][MAXLEN_PRGNAME],int maxDim);

STATUS prgMNamToAdr(char* prgNam,AOM_ADR *aomA);
STATUS prgMNamToNum(char* prgNam,int *prgNum);
STATUS prgMNumToNam(int prgNum,char *prgNam);
STATUS prgMQidToNum(AOMSG_Q_ID msgQId,int *pprgNum);

STATUS prgMRegLPrg(char *prgName,AOMSG_Q_ID inpQId,AOMSG_Q_ID replyQId);
void   prgMUnRegLPrg(char *prgName);
STATUS prgMStopLProg(int prgNum);
STATUS prgMWaitData(char *prgName,int timeOut);
/*
 * bp routines
*/
BUFPOOL_PTR   prgMBpCreate (char *bpName,int numBufs,int bufLenBytes);
STATUS        prgMBpQuery(char *bpName,int *pnumBufs,int *pbufLenBytes,
						  BUFPOOL_PTR *ppbufPool);
STATUS        prgMBpQueryAll(int maxEntries,char bpNameAr[][8],int *numBufsAr,
							 int *bufLenBytesAr);
/*
 *	aomsg routines that need to be here do to loading order
*/
STATUS    aoMsgPMAddLocProg(AOM_ADR *pto, AOM_ADR *pfrom, char *prgName,
                            AOMSG_Q_ID inpQId,AOMSG_Q_ID replyQId,int timeout);
STATUS    aoMsgPMStartProg( AOM_ADR *pto, AOM_ADR *pfrom, char *prgName,
                            int timeout);
STATUS    aoMsgPMSignal( AOM_ADR *pto, AOM_ADR *pfrom, int prgNum,
                         int signalL, int timeout);

void   prgMgrDbg(void);

#endif	/* INCPRGMGRH*/
