#ifndef incPZFILTERH
#define incPZFILTERH
/*
 * PoleZeroFilter box.. selects 2,3,10%bandwidth and adjusts center
 * 30Mar95 - talked to joe janning 513-870-9060 ohio.. pole zero
 * 1. The bw setting is a level .. i find it active low.. he was surprised
 * 2. The strobe is for the tune bits only and is a falling edge....
 * 3. for tuning, you need:
 *           200ns setup time data valid to strobe going low
 *	       6us hold time of strobe and data. 
 *
*/
/*	defines */

#if FALSE
 29aug96.. these are old test values.. 
/*  digital output bits for various functions. 
 *  the mapping from digital output bits to pzfilter input (via the cable is):
 *  dig out	pzpin
 *   b0-7       p14,p15,p1-6   8 tuning bits
 *   b8         p8		10% bw
 *   b9		p9		3.3%bw
 *   b10	p10		2%  bw
 *   b11	p11		bybass filter
 *   b12	p12		strobe chan 1
 *   b13	p13		strobe chan 2
*/
#define	PZF_BW_10_BIT	0x0100
#define	PZF_BW_3_BIT 	0x0200
#define	PZF_BW_2_BIT 	0x0400
#define	PZF_BW_BYPASS 	0x0800
#define	PZF_STROBE_CHN1 0x1000
#define	PZF_STROBE_CHN2 0x2000
#define PZF_CHN_MASK   (PZF_STROBE_CHN1 | PZF_STROBE_CHN2)
#define PZF_BW_MASK    (PZF_BW_10_BIT |PZF_BW_3_BIT | PZF_BW_2_BIT | PZF_BW_BYPASS) 
#define PZF_TUNE_MASK   0x00ff
#define PZF_TUNE_MIN    0x0000
#define PZF_TUNE_MAX    0x00fa
#define PZF_RF_IN_OUT_ISOLATION 0x00fb
#define PZF_PWR_SAVE_MODE       0x00ff
#endif
/*  digital output bits for various functions. 
 *  the mapping from digital output bits to pzfilter input (via the cable is):
 *  dig out	pzpin
 *   b3-10      p14,p15,p1-6   8 tuning bits
 *   b11        p10	2%  bw
 *   b12		p9	3.3%bw
 *   b13	    p8 10%  bw
 *   b14		p11		bybass filter
 *   b15	    p12,p13		strobe chan 1,chan2 
*/
#define	PZF_BW_10_BIT	0x2000
#define	PZF_BW_3_BIT 	0x1000
#define	PZF_BW_2_BIT 	0x0800
#define	PZF_BW_BYPASS 	0x4000
#define	PZF_STROBE_HI   0x8000
#define PZF_STROBE_LO(data) ( (data) & 0x7fff)
#define PZF_BW_MASK    (PZF_BW_10_BIT |PZF_BW_3_BIT | PZF_BW_2_BIT | PZF_BW_BYPASS) 
#define PZF_TUNE_MASK   0x07f4
#define PZF_TUNE(data)  ( ((data) << 3) & PZF_TUNE_MASK)
#define PZF_TUNE_MIN    0x0000
#define PZF_TUNE_MAX    0x00fa
#define PZF_RF_IN_OUT_ISOLATION 0x00fb

#endif /*incPZFILTERH*/
