/*
 *	include file for phils qlib qphLib under ~phil/vw/datatk/pnt/gen
*/
#ifndef INCqphLibh
#define INCqphLibh
/*
*history..
*/

/*	includes	*/
#include	<vxWorks.h>
#include	"aoMsg.h"
#include	<sys/times.h>
/*
 *  the queue is set so that put=get --> empty, put+1=get -->full, all done
 *  modulo maxElmts. to clear queue, just set put=get. There is no
 *  protection since only one persons puts/takes from queue.
*/

/*	defines		*/

/*
 * defines to acces queue
 * FLUSH - clears the queue
 * empty,full tests for empty/full
 * GETPTR lets you look at entry in queue without removing it.
 *
 * normal usage would be
 * 1. flush as start
 * 2. put .. qphPut()
 * 4. get - PTQGet
*/
#define QPH_FLUSH(pq) ((pq)->indPut =(pq)->indGet = 0 )
#define QPH_EMPTY(pq) ((pq)->indPut == (pq)->indGet)
#define QPH_FULL(pq)  ( (((pq)->indPut + 1) == (pq)->indGet ) \
			            ? 1 \
			            : (((pq)->indPut  == ((pq)->maxElmts - 1)) && \
			                 ((pq)->indGet     == 0 )) \
				          ? 1 : 0 )
#define QPH_NUMINQ(pq) ( ( (pq)->indPut >= (pq)->indGet) \
						 ? (pq)->indPut  - (pq)->indGet   \
				         : (pq)->maxElmts + (pq)->indPut - (pq)->indGet )
				
#define QPH_GETPTR(pq)  ( (pq)->pent + (pq)->indGet * (pq)->bytesPerEnt )

/*	typedefs	*/

typedef struct {
        int     maxElmts;       /* we allocated*/
        int     indPut;         /* put index.. 0 based*/
        int     indGet;         /* put get  .. 0 based*/
        char    *pent;          /* ptr to queue*/
	    int	    bytesPerEnt;	/* bytes per entry*/
        } QPH;


/*	prototypes	*/

void    qphDelete(QPH *pq);
STATUS  qphGet(QPH *pq,char *pent);
STATUS  qphInit(int maxNumElmnts,int bytesPerElmnt,QPH *pq);
STATUS  qphPut(QPH *pq,char *pent);


#endif  /* qphLibh */
