#ifndef INCrcvMonh
#define INCrcvMonh
/*  
 * in idl use: byte,byte,short to get these.
 */
typedef struct {
	unsigned int	    rcvNum:8;	/*rcvnum 1->15*/
	unsigned int          fill:5; 
	unsigned int	  hemtLedA:1; /* hemt is on*/
	unsigned int  	  hemtLedB:1; /* hemt is on*/
	unsigned int lakeShoreDisp:1; /* disp is on*/
	unsigned int         year :16;/* 4 digit year*/
	} RCVM_RCV_STAT;

typedef struct {
	char	key[4];    /* "rcv"  null terminated*/
	RCVM_RCV_STAT stat;
	double  day;		/* daynum of year and fraction of day ast*/

	float	t16K;		/* 16 K temp*/
	float	t70K;		/* 16 K temp*/

	float	tOmt;		/* omt temp*/
	float	pwrP15;		/* plus 15 volts*/ 

	float	pwrN15;		/* neg15 volts*/ 
	float   postAmpP15;

	float   dcur[2][3]; 
	float   dvolts[2][3]; 

#if FALSE
	float	postAmpIA;  /* polA,polB*/
	float	postAmpIB;  /* polA,polB*/
#endif
	} RCVM_RCV_INFO;
#endif

