#ifndef INCrdrDopLibh
#define INCrdrDopLibh
#ifndef	VXWORKS
#include	<vxWorksEm.h>
#else
#include	<vxWorks.h>
#endif
#include	<stdio.h>
#include	<rdrEphm.h>

/* 	defines		*/

/*	keys indices used by sbdProg	*/


#define PARSE_PRE_SBD	"sbd_"

#define  SBD_DOP_NONE           0
#define  SBD_DOP_TX             1
#define  SBD_DOP_RX             2
#define  SBD_DOP_TXRX           3

#define	SBD_IND_EPHMFILE    0	
#define	SBD_IND_EPHMOFF     1	
#define	SBD_IND_DOPCFR      2	
#define	SBD_IND_STEPPOLY    3	
#define	SBD_IND_CMPDOP      4	
#define	SBD_IND_TXDOWNEARLY 5	
#define	SBD_IND_RXECHOSECST 6	
#define	SBD_IND_RXSECNOISE  7	
#define	SBD_IND_CODELEN     8	
#define	SBD_IND_BAUDLEN     9	
#define	SBD_IND_EPHDELAY   10	
#define	SBD_IND_DEPHRATE   11	
#define	SBD_IND_DEPHRTT    12	
#define	SBD_IND_DEPHOFF    13	
#define	SBD_IND_BPFLIPPED  14	
#define	SBD_IND_USEDCD     15	
#define	SBD_IND_PNCL       16	
#define	SBD_IND_FSWNUMFRQ  17
#define	SBD_IND_FSWFIRSTFRQ 18
#define	SBD_IND_FSWSTEPFRQ 19
#define	SBD_IND_FSWSTEPTM  20
#define	SBD_IND_FSWENDTM   21
#define	SBD_IND_IPPDOP     22
#define	SBD_IND_TXLOMULT   23
#define	SBD_IND_DEPHRA     24	
#define	SBD_IND_DEPHDEC    25	

#if FALSE
#define RDR_DOP_NUMCOEF 5
#endif
#define RDR_DOP_NUMCOEF 7

/* <pjp007> rdr_dop_poly now has a single set of coef*/
typedef	struct {
	int		stepTmSec;				/* time 1 step in seconds*/
	int		startIndEphmData;		/* start index in ephmData for poly*/
	int		dayNumAtStartSec;		/* day number at start sec (ast)*/
	int		ephmEntryPerStep;       /* number ephmEntries/step*/
	double  startSec;				/* secMid start time for poly(ast)*/
	double	secToStep;				/* to convert secs to poly step size*/
	double	ephmFreqOffHz;	/* offset for ephemeris file in hz..var notloaded.*/
	double	coef[RDR_DOP_NUMCOEF];	/* coef for polynomial */	
	} RDR_DOP_POLY;

typedef struct {
	int		maxNum;		/* to save*/
	int	    lastInd;    /* saved to . < 0 --> 1st time*/
	double	*dopHz;	    /* user must allocate*/
	double  *time;	    /* user must allocate*/
	}RDR_DOP_SAVE;

typedef struct {
	 RDR_DOP_POLY	polyI[2];	/* <pjp007> info for polynomial tx,rx*/
	 RDR_DOP_SAVE   save;		/* info each minute*/
	 /*
	  * the values output to dds 1,2 are
      *	ddsfrq[i]=dopShift2380*dopScale[i]+dopBase[i];
	  * dopScale will be multipled by -1 if the rxDopBP is flipped on
	  * the input to the rxDopMixing stage.
	 *  <pjp007> below */
	 double         dopScaleFrq[2];/*[txdop,rxdop]*/
	 double         dopScaleTm[2]; /*[txdop,rxdop]*/
	 double	        dopBaseFrq;	   /* dds base for frq = 20e6*/
	 double	        dopBaseTm;	   /* dds base for tm  = 20e6*/
	 double  	    dopFreqLast;	/* last computed frequency*/
	 int			dopCode; /* 0-nodop,1=dop tx, 2-- dop rx*/
	 int			filler;
	 } RDR_DOP_INFO;
	

/*	prototypes		*/

void   rdrDCmpDop(double timeSecs,void *pinfo,int tx,double *pfreqSyn1,
        	      double *pfreqSyn2);
STATUS rdrDCmpPoly(RDR_EPHM_INFO *pephmI,int polyStartIndEphm,
				   int polyStepSizeEntry,int useTx,double ephmFreqOffHz,
				   RDR_DOP_POLY *ppolyI);
STATUS rdrDEphmLd(char *filename,int maxNumEntries,int reqYear,int reqDayNum,
			      int reqSecMidnite,RDR_EPHM_INFO *pephmI);
void   rdrDEphmPr(RDR_EPHM_INFO *pI,FILE *fp,int firstInd,int numEntries);
STATUS rdrDGetStInd(int dayNum,int startSec,int polyStepSize,
					RDR_EPHM_INFO *pephmI,int *pstartIndex);
RDR_DOP_INFO  *rdrDInit(int maxToSave);
void  		   rdrDFree(RDR_DOP_INFO *pdopI);
#endif /*INCrdrDopthLibh*/
