/*
 * rdrEphm - definition of radar ephemeris
*/
#ifndef INCrdrEphmh
#define INCrdrEphmh

/* store up to have a day at 1 minute spacing */

#define RDR_EPHM_MAX_ENTRIES	720

typedef struct	{
	double		raRd;		/* ra  in radians*/
	double		decRd;		/* dec in radians*/
	double		dopCorHz;   /* dopfrq=2380e6+dopCorHz */
	double	    rttSec;		/* round trip time*/		
	} RDR_EPHM_DATA;

typedef struct {
	int			year;		/* 4 digits*/
	int			dayNum;		/* day number 1..365,366*/
	int		    secMidnite; /* seconds from midnight*/
	int			filler;
	}  RDR_EPHM_START; 
	
typedef struct {
	RDR_EPHM_START	startTm;	/* AST start time info*/
	int			    numEntries;
	int				secsPerEntry;/* seconds between each entry*/
	RDR_EPHM_DATA	tx[RDR_EPHM_MAX_ENTRIES];
	RDR_EPHM_DATA 	rx[RDR_EPHM_MAX_ENTRIES];
	} RDR_EPHM_INFO;

#endif

