#ifndef incRFIF1LIBH
#define incRFIF1LIBH

/*
modifications
-------------
xx.x,29jan96,pjp - RFIF1_ELM --> RFIF1_SETUP to look more like iflo2 
xx.x,30jan96,pjp - remove slave from struct. no longer used.
 	 	   move SW_INFO/RF_SW,IF_SW ,rfIf1GetIf1Id,rfIf1GetRfId
		   to lib. not needed globally.

*/
/*	defines */

#define	RFIF1_DONT_CHANGE	-1
#define	RFIF1_HP3488_1		"u1"



/* for rfiElm	*/

#define RFIF1_FIBER		1
#define RFIF1_HELIAX		2
#define RFIF1_HYBRID_OUT        1  
#define RFIF1_HYBRID_IN 	2  

#define RFIF1_CLOSED		1
#define RFIF1_OPEN     		0 
#define RFIF1_MAX_SW_ERRS	25

/*   
 *	switch numbers to identify switches in swTbl
 *	first set on hp87130 device
*/
#define	SW1A1	1
#define	SW1A2	2
#define	SW1B1 	3
#define	SW1B2	4
#define	SW2A 	5
#define	SW2B 	6
#define	SW3A 	7
#define	SW3B 	8
#define	SW4  	9
#define	SW5A   10
#define	SW5B   11 
#define	SW6A   12
#define	SW6B   13 
#define	SW7A   14
#define	SW7B   15 
#define	SW8A   16
#define	SW8B   17 
#define SWATTN_RF_A    18 
#define SWATTN_RF_B    19
#define SWATTN_IF1_A   20
#define SWATTN_IF1_B   21 
/* 
 * following on hp3488 device 
*/
#define SWATTN5_ZM_NDBIG   100
#define SWATTN6_ZM_ND      101
#define SWATTN7_ZM_POLA    102
#define SWATTN8_ZM_POLB    103
#define SWXFER_ZM          104
#define SWND_ZM_ONOFF      105
#define SWND_ZM_TOAB       106
#define SWPHADJ_SIG        107
#define SWPHADJ_LO         108
#define SWPZ430_TUNE       109 
#define SWPZ430_BW         110
#define SWPZ430_STR        111

/*	typedefs	*/

/*
 *	hold info on any switch errors
*/
typedef struct {
	int	swNum;
	int	myErrno;	/* my errno*/	
	int	hpErr1;	/* hp 1st error*/
	int     hpErr2; /* hp 2nd error or 0*/
	} SW_ERR;

typedef struct {
	int	numSwErrs;		/* number valid entries in swErr*/
	SW_ERR  sw[RFIF1_MAX_SW_ERRS];
	} SW_ERRS;
/*
 *	structure to hold entries for the setup call of rfIf1
*/
/*	
 *	zeeman box info. note that A/B refer to pol A/B before the 
 *      xfer switch upstairs. -1 on xferSwNormal --> ignore all of zeeman
 *	switch updates.
*/
typedef struct {
	int	xferSwNormal;   /* 1 --> straight through,0 switch,-1 ignore*/
	float	attnA;		/* a pol attenuator 1.5 db, .1 db steps*/
	float	attnB;		/* B pol attenuator 1.6 db, .1 db steps*/
	int	attnNDLarge;    /* large noise diode atten 15db 1db step*/
	float   attnNDSmall;    /* small noise diode atten 1.5 db .1 db step*/
	int	noiseDiodeOn;   /* true --> diode on*/
	int	noiseDiodeToA;  /* treu --> noise diode goes to pol A*/
	} RFIF1_ZM_SETUP;
/*	
 *	pol z filter setup
*/
typedef struct {
	int	rfFreq;		/* pick which pole z filter -1--> ignore*/
	int	tune;		/* 0..250. 125 is center */
	int	bwPerCent;	/* 2,3,10,0=bypass, -1==don't care*/
	} RFIF1_PZ_SETUP;

typedef	struct {
	int	update87130;	/* do updates to 87130*/
	int	rfFreq;		/* rf switches -1 don't care*/
	int	rfAttnA;	/* rf AttnA -1 dont' care*/
	int	rfAttnB;	/* rfAttnB -1 don't care*/
	int	if1Freq;	/* if1 switches -1 don't care*/
	int	if1AttnA;	/* if1 attnA -1 don't care*/
	int	if1AttnB;	/* if1 attnB -1 don't care*/
	int	cableA;		/* fiber optic or heliax -1 don't care*/
	int	cableB;		/* fiber optic or heliax -1 don't care*/
	int	hybrid;		/* in or out 1,2,or -1 don't change*/
	int	update3488;	/* do updates to 3488*/
	float   phAdjSigADeg;	/* A chan 1.4 deg step*/
	float   phAdjLoBDeg;	/* B chan 1.4 deg step*/
	RFIF1_ZM_SETUP zm;
	RFIF1_PZ_SETUP pz;	/* pole z filter setup*/
	} RFIF1_SETUP; 
/*
 *	globals 
*/

/*	prototypes	*/

STATUS     rfIf1Init(void);
STATUS     rfIf1ReadBack(int *pdata);
void       rfIf1Debug(void);
STATUS     rfIf1Setup(RFIF1_SETUP *psetup,int verify,SW_ERRS *pswErrs);
void       rfIf1ShutDown(void);

/*	hp87130 routines	*/

STATUS rfIf1SetVer87130(int on);
STATUS rfIf1SwName(int swNum,char *swName,int maxLenName);
STATUS rfIf1WaitCmd87130(void);


#endif /*incRFIF1LIBH*/
