#ifndef incRFIRCVDATH
#define incRFIRCVDATH 
#include	<rfiRcvLib.h>
/*
modification history:
--------------------
x.x,01nov95,pjp	- 450 bw 140 filter 5 changed to 430 bw 50 
x.x,28nov95,pjp - added ant num 5,6
x.x,12apr96,pjp - added hi freq. ant 5.. defaults are 6500 mhz 1ghz wide
				- foAmp position 5 has semi rigid going into output.
				  switches before it not really used. set them so that
				  we minimize feed through of other signals.
*/
/*
 *	data for the rfiRcvLib structures. this sould only be included
 *	once in vxWorks. It initializes some static structures.
*/
/*
 *	antennas table. 
*/
RFIRCV_ANT	rfiRcvAntTbl[]={
/* sw1Pos cfr       bw    gain_dbi	*/
{    1  ,  712.5,   1375., 3. },
{    2  ,  850. ,   1300., 6. },
{    3  , 6500. ,  11000., 8. },
{    4  , 6500. ,  11000., 8. },
{    5  , 6500. ,   1000., 6. },
{    6  , 1000. ,   1000., 3. }
};
/*
 *	fiber optic amp table
 *  note position 5 has no input but semirigid hf cable for output
*/
RFIRCV_FOAMP rfiRcvFOAmpTbl[]={
/* sw10Pos sw11Pos  cfr       bw    gain_db noiseFigDb	*/
{     1,     1,     510. ,    980.,   36.5,   1.2     },
{     2,     2,    1500. ,   1000.,   36.4,   1.6     },
{     3,     3,      -1. ,     -1.,    0.,    0.      },
{     4,     4,    6000. ,  12000.,    0. ,   0.      },
{     4,     5,    6500. ,   1000.,    0. ,   0.      }
};

RFIRCV_FILTER rfiRcvFilterTbl[]={

/*
Sw2P sw9P swNI swPI swNO  swPO cfr      bw FltNF AmpGain AmpNf DantNum DFOAmp*/

{ 1,  1,   3,   1,    6,    1,   70.,  140., 1.,   15.6, 2.5,  1,  1},
{ 1,  1,   3,   2,    6,    2,  165.,   70., 1.,   15.6, 2.5,  1,  1},
{ 1,  1,   3,   3,    6,    3,  235.,   90., 1.,   15.6, 2.5,  1,  1},
{ 1,  1,   3,   4,    6,    4,  330.,  140., 1.,   15.6, 2.5,  1,  1},
{ 1,  1,   3,   5,    6,    5,  430.,   50., 1.,   15.6, 2.5,  1,  1},
{ 1,  1,   3,   6,    6,    6,   -1.,  -1. , 1.,   15.6, 2.5,  1,  1},
{ 2,  2,   4,   1,    7,    1,  550.,  200., 1.,   36.6, 1.1,  1,  1},
{ 2,  2,   4,   2,    7,    2,  725.,  210., 1.,   36.6, 1.1,  1,  1},
{ 2,  2,   4,   3,    7,    3,  955.,  290., 1.,   36.6, 1.1,  1,  1},
{ 2,  2,   4,   4,    7,    4,   -1.,   -1., 1.,   36.6, 1.1,  1,  1},
{ 3,  3,   5,   1,    8,    1, 1075.,  350., 1.,   33.4, 1.6,  1,  2},
{ 3,  3,   5,   2,    8,    2, 1325.,  250., 1.,   33.4, 1.6,  1,  2},
{ 3,  3,   5,   3,    8,    3, 1400.,   60., 1.,   33.4, 1.6,  1,  2},
{ 3,  3,   5,   4,    8,    4, 1765.,  670., 1.,   33.4, 1.6,  1,  2},
{ 4,  4,  -1,  -1,   -1,   -1, 6000., 6000., 1.,    0. , 0. ,  0,  0},
{ 4,  3,  -1,  -1,   -1,   -1, 6500., 1000., 1.,   78. , 2.5,  5,  4}
	};

#endif /*incRFIRCVDATH*/
