/*
 *	include file for sbp 
*/
#ifndef INCriDg10h
#define INCriDG10h
#include	"ri.h"


#define NUMPNTS 200
/*
 *	program configuration
*/
typedef struct { 
        RI_CONFIG riconf;
        float   freq;           /* sine wave hz*/
        float   smpFreq;        /* in hz*/
        float   cyclesUsed;     /* in our samples*/
        int     numsamples;     /* for sine wave*/
	char    digToUse;	/* i,q*/
        }  RI10INFO;


/*
 *	results from fitting
*/
typedef struct {
        float   freqeff;        /* effective freq hz*/
        float   ampMinOk;         /* min allowable*/
        float   ampMaxOk;         /* max allowable*/
        float   offSetMaxOk;      /* allowable counts*/
        float   rmsMaxOk;         /* allowable in counts*/
	int     runsFailed;	/* how times at least one error*/
	int     timesrun;	/* the test*/
	float   ampMax[2];	/* largest deviation measured*/
	float   ampMin[2];	/* largest deviation measured*/
	float   offMax[2];	/* largest deviation measured*/
	float   rmsMax[2];	/* largest deviation measured*/
	int     ampErr[2];	/* had err in amp*/
	int     offErr[2];	/* had err in off*/
	int     rmsErr[2];	/* had err in rms*/
        float   amp[2];   /* from fit i,q*/
        float   phase[2]; /* from fit i,q*/
        float   offset[2];/*from fit i,q*/
        float   rms[2];   /* from fit i,q*/
        float   xpoints[NUMPNTS];  /* x values*/
        float   ypointsI[NUMPNTS]; /* i dig measured*/
        float   ypointsQ[NUMPNTS]; /* q dig measured*/
        }  FITINFO;

/*
 *	prototypes
*/

void         checkvalues(FITINFO *pfitInfo,int *perrThisRun,int i);
void         dofit(float freqtouse,int numpoints_fit,float *x,float *y,
		   float *pamp,float *pphase,float *poffset,float *prms,
		   float *pa,float *pb,float *pc);
extern void  gaussj_(float *covar,int *mfit,int *ncvm,float *beta,int *,int *);
#if FALSE
LOCAL STATUS getdata(int fd_sock,int numpoints,int *inbuf,float *ypointsI,
                     float *ypointsQ);
LOCAL void   getparams(int *pnumloops,int *pdone,RI10INFO *priInfo);
#endif
void         lfitp(float freqtouse,float *x,float *y,int ndata,float *a,int ma);
void         printFit(FITINFO *pfitInfo);
STATUS       setupRun(int fd_sock,RI10INFO *priInfo,FITINFO *pfitInfo,
                      int *digIBits,int *digQBits);
STATUS       startup(int *pfd_sock,RI10INFO *priInfo,RI_CONFIG *pcf,
		     FITINFO *pfitInfo);
STATUS       riDg10Com(int *pfd_sock,RI_CONFIG *pcf, FITINFO *pfitInfo);

#endif	/* INCriDg10h*/
