#ifndef	riDg11H
#define riDg11H
/*
 *	fit to mux sine wave
*/
/*
 *	for the arrays of length 2 below, 0 is I digitizer, 1 is q digitizer
*/
#define	DIGI	0
#define DIGQ	1
#define MAX_TESTS 40
#define NUM_POINTS 200
/*
 *	summary info for a test run many times
*/
typedef struct {
	float	sOff;	/* largest offset from 0. can be +/-*/
	float	sAmpMin;	/* min abs()  amplitude measured*/
	float	sAmpMax;	/* max abs() amplitude measured*/
	float   sRms;	/* max rms from fit*/
	int	sOffF;	/* if offset was out of bound*/
	int	sAmpF;	/* if offset was out of bound*/
	int	sRmsF;	/* if offset was out of bound*/
	int	sTimesF;	/* times i or q failed this test*/
	} SUM_INFO;	
/*
 *	hold all the info a particular test. setup and summary
*/

typedef	struct {
	int	tSeqLen;	/* for test -1 --> not defined*/
	int 	t1stSample;	/* for fit ... start at 1*/
	int	tPairMode;	/* true, false --> cycle mode*/
	int	tMuxSeq[8];	/* hold tSeqLen values for mux*/
	SUM_INFO sInfo[2];	/* summary info for i/q teststests*/
	} TEST_INFO;
/*
 *	hold info on all available tests
*/
typedef struct {
	int	tNumTot; 	/*total number of tests available*/
	TEST_INFO *tArray;	/* ptr to array of all tests*/
	} TALL;			
	
/*
 *	hold info on bit usage. 
*/
typedef struct {
	int	bOn[2][12];	/* two dig i/q by 12 bits*/
	int	totCnts;	/* number of samples we've taken 1 dig*/
	} BIT_INFO;
/*
 *	hold info for current set of tests running
*/
typedef struct{
	char	curStr[80];     /* to echo back to user*/
	int	testsToRun;	/* number of tests to run*/
	int	timesToLoop;	/* on this set of tests*/
	int	testList[MAX_TESTS];/* index for each test to run*/
	int	timesLooped;	/* actually done*/
	BIT_INFO bitInfo;
	int	fifoToUse;	/* 1 or 2*/
	char	printer[20];	/* printer to use for hardcopy*/
	} CUR_TESTS;
/*
 *	fit information
*/
typedef	struct	{	
	float	freqSineWave;	/* from ri*/
	float	freqEff;	/* effective freq... pair/cycle mode*/
	float	gw;	/* 1/gw. we correct for cycle/pair later*/
	int	numPntsFit;	/* for fit*/ 
	float	ampMinOk;
	float	ampMaxOk;
	float	offsetMaxOk;
	float	rmsMaxOk;
	float	amp[2];		/* from fit i,q*/
	float	phase[2];	/* from fit i,q*/
	float	offset[2];	/* from fit i,q*/
	float   rms[2];		/* from fit i,q*/
	float	Acof[2];	/* a coef from fit*/
	float	Bcof[2];	/* b coef from fit*/
	float	Ccof[2];	/* c coef from fit*/
	float	xpoints[NUM_POINTS]; /* x data for fit*/
	float   ypointsI[NUM_POINTS];/* y points I dig input*/
	float   ypointsQ[NUM_POINTS];/* y points Q dig input*/
	} FIT_INFO;
	 
int	riDg11Com(FIT_INFO *pfit);


#endif /* riDg11H */
