/*
 *	include file for riProg.h includes the common sun/vw file and
 *	the local vw portion
 * mods.
 *05dec94 .. changed extStart to be integer, 0,1,10
*/
#ifndef INCriProgKeysh
#define INCriProgKeysh

/*	includes	*/
#ifdef VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<aoParse.h>
 
/*	defines		*/
/*	prefix for keytable ri_ defined in riProgLib.h	*/

/*
ri_cycleMode"   ,4,PARSE_T_LOG,
ri_dataSource"  ,4,PARSE_T_STRING,
ri_extStart"    ,7,PARSE_T_LOG,
ri_extTiming"   ,7,PARSE_T_LOG,
ri_fifo"        ,PARSE_T_INT,
ri_gw"          ,5,PARSE_T_DOUBLE,
ri_gwCount"     ,PARSE_T_LOG,
ri_int.pbufPool",PARSE_T_ADR,
ri_int.poutQ"   ,PARSE_T_ADR,
ri_int.extIntFunc",PARSE_T_ADR,
ri_ipp
ri_muxSeq"      ,PARSE_T_ARINT,
ri_muxSWChan"   ,PARSE_T_INT,
ri_packing"     ,4,PARSE_T_INT,
ri_samplerStart",5,PARSE_T_STRING,
ri_secMidToStart",PARSE_T_INT,
ri_seqLen"      ,PARSE_T_INT,
ri_smp/Pair/Ipp",PARSE_T_INT,
ri_usebltrd"    ,PARSE_T_LOG,
ri_useMux"      ,PARSE_T_LOG,
ri_default      ,PARSE_T_LOG,
*/

KEY_DEF riKeys[]={
{"ri_ipp"         ,5,PARSE_T_DOUBLE,
			    "#double. ipp in usecs. Resolution .1usecs"},
{"ri_gw"          ,5,PARSE_T_DOUBLE,
		           "#double. gateWidth in usecs. Resolution .1usecs"},
{"ri_extStart"    ,7,PARSE_T_INT,
			"#int. 0--> imd, 1,10 second tick"},
{"ri_extTiming"   ,7,PARSE_T_LOG,
			"#alpha. External timing inp. y/ or no/f"},
{"ri_samplerStart",5,PARSE_T_STRING,
			"#alpha. Start A/D on :disable,ipp,immediate,soft"},
{"ri_dataSource"  ,5,PARSE_T_STRING,
			"#alpha. Fifo input is:stair,toggle,zero,AToD"},
{"ri_packing"     ,4,PARSE_T_INT,
			"#int. Bits for data packing:        1,2,4,8, or 12"},
{"ri_cycleMode"   ,4,PARSE_T_LOG,
			"#alpha. 1 gw gives 1 or many samples: y/t or n/f"},
{"ri_seqLen"      ,6,PARSE_T_INT,
			"#int. For muxLen and cycleMode. 1 to .."},
{"ri_gwCount"     ,6,PARSE_T_LOG,
			"#alpha.gwCounting y/t no/false"},
{"ri_muxSWChan"   ,8,PARSE_T_INT,
			"#int. 0-->7 mux sineWave chn for input. -1 disable"},
{"ri_fifo"        ,4,PARSE_T_INT,
			"#int. read data out from fifo 1,2, 12-->alternate."},
{"ri_usebltrd"    ,7,PARSE_T_LOG,
			"#alpha. use blt for fast read: y/t or n/f"},
/* for now useMux is not used. MuxSeq will determine if the mux is loaded
   need to modify riConfig but this is a major ....
*/
{"ri_useMux"      ,7,PARSE_T_LOG,
			"#alpha. use the mux: y/t or n/f"},
{"ri_muxSeq"      ,8,PARSE_T_ARINT,
			"#ints. seq. of mux ports to use "},
{"ri_int.pbufPool",9,PARSE_T_ADR,
			"#internal use"},
{"ri_int.poutQ"   ,9,PARSE_T_ADR,
			"#internal use"},
{"ri_int.extIntFunc",9,PARSE_T_ADR,
			"#internal use"},
{"ri_secMidToStart",6,PARSE_T_INT,
			"#int. seconds from midnite to start. < 0--> ignore"},
{"ri_smp/Pair/Ipp",5,PARSE_T_INT,
			"#int. Samples 1 pair per ipp"},
{"ri_ipp/buf"     ,7,PARSE_T_INT,
			"#int. Ipps in 1 buffer"},
{"ri_default"     ,5,PARSE_T_NONE,
			"#noargs, set to default"},
{NULL,0,0,NULL},
        };
#endif
