/*
 *	include file for rmtcLib
 *	remote command lib
*/
#ifndef INCrmtcLibh
#define INCrmtcLibh
#ifdef	VXWORKS
#include	<stdioLib.h>
#else
#include	<stdio.h>
#endif
#include	"aoErrNum.h"

#define	RMTC_SYNC1 "SY1"  
#define	RMTC_SYNC2 "SY2"  
#define RMTC_ACKREQ 0x123456
#define RMTC_NACKREQ 0x1234567
#define RMTC_ANYBUFLENOK -999
 
/*
 *	remote command header to send across the wire
*/
typedef struct {
        char sync1[4];              /*to sync up*/
        int  cmd;                   /*command, ack,nack*/
        int  numbytes;              /* following hdr*/
        int  reqId;	            /* id # or id of ack packet*/
        int  rsvpId; 	  	    /* if this is responding to a header*/
	int  dataVal;		    /* for nacks/ program stat*/
        char sync2[4];              /*to sync up*/
        } RMTC_CMD_HDR;

#if FALSE
/*	made local routines to rmtcLib*/	
void   rmtcHdrFill(RMTC_CMD_HDR *cmdhdr,int cmd,int bytesData,int rsvpId,
		   int dataVal);
STATUS rmtcRcvRspAll(int skfd,int rsvpIdExp,int maxInLen,int *pbytesRet,
		     int *pbytesDPacket,char *rcvBuf,int *perr);
STATUS rmtcRcvRspH(int skfd,int rsvpIdExp,int *pbytesDataToRead,int *perr);
STATUS  rmtcSndIt(int skfd,int cmd,int numbytes,int dataVal,char *buf,
                   int *preqId,int rsvpId,int *perr);
STATUS rmtcSndReq(int skfd,int cmd,int numbytes,int dataVal,char *buf,
		  int *preqId,int *perr);
#endif

void   rmtcDmphdr(FILE *fp,RMTC_CMD_HDR *phdr);
STATUS rmtcDrainData(int skfd,int bytesReq,int *perr);
STATUS rmtcGetData(int skfd,int bytesReq,char *buf,int *perr);
STATUS rmtcIO(int skfd,int cmd,int bytesout,char *obuf,int maxInLen,
	           int *pbytesRet,int *pbytesDPacket,char *ibuf,int *pHandle,
		   int *perr);
STATUS rmtcIOExtra(int skfd,int maxInLen,int *pbytesRet,int *pbytesDPacket,
			char *ibuf,int Handle,int *perr);
STATUS rmtcIOQlen(int skfd,int cmd,int bytesout,char *obuf,int *pbytesIn,
	          int *phandle,int *perr);
STATUS rmtcRcvHdr(int skfd,int *pcmd,int *pbytesData,int *preqId,int *prsvpId,
		  int *pdataVal,int *perr);
STATUS rmtcSndAck(int skfd,int ackVal,int err,int bytesData,char *buf,
		  int rsvpId,int *perr);

#endif	/* INCrtgh*/
