/*
 *	include file for rtg
*/
#ifndef INCrtgh
#define INCrtgh
#include	"aoErrNum.h"
#ifdef	VXWORKS
#include	<stdioLib.h>
#else
#include	<stdio.h>
#endif
/*
 *	riDrv Error messages
*/
#define	S_rtgLib_LOAD_READBACK_MISMATCH		(aoM_rtgLib |0x01)

/*
 *	command word bits for rtg
*/
#define  RTGC_COMMAND_WORD      040000000
#define  RTGC_LOAD              002000000
#define  RTGC_RADAR_MODE        000040000
#define  RTGC_CONTINUOUS_MODE   000100000
#define  RTGC_FIXED_CLOCK       000010000
#define  RTGC_DRIFTED_CLOCK     000020000
#define  RTGC_ENABLE_CAL        000002000
#define  RTGC_DISABLE_CAL       000004000
#define  RTGC_1SEC_TICK         000000400
#define  RTGC_10SEC_TICK        000001000
#define  RTGC_GW_BLANKING       000000100
#define  RTGC_NOGW_BLANKING     000000200
#define  RTGC_CLEAR_PWRFAIL     000000040
#define  RTGC_CLEAR_PEOV        000000020
#define  RTGC_START_ON_TICK     000000004
#define  RTGC_START_IMMEDIATE   000000010
#define  RTGC_STATUS_REQ        000000001
#define  RTGC_VER_REQ           000000002
#define  RTGC_CLEAR_ALL       (RTGC_CLEAR_PWRFAIL | RTGC_CLEAR_PEOV)
/*
 * status bits returned from the RTG
*/
#define  RTGS_NO20MHZ_FIXED       000000001
#define  RTGS_NO20MHZ_DRIFTED     000000002
#define  RTGS_NO10SEC_TICK        000000004
#define  RTGS_NO1SEC_TICK         000000010
#define  RTGS_USING_DRIFTED_CLOCK 000000020
#define  RTGS_USING_1SEC_TICK     000000040
#define  RTGS_RADAR_MODE          000000100
#define  RTGS_USING_GWBLANKING    000000200
#define  RTGS_PARITY_ERROR        000000400
#define  RTGS_TXIPP_DEAD          000001000
#define  RTGS_RDIPP_DEAD          000002000
#define  RTGS_GW_DEAD             000004000
#define  RTGS_CAL_DEAD            000010000
#define  RTGS_RICLK_DEAD          000020000
#define  RTGS_TICK_DEAD           000040000
#define  RTGS_TXIPP_ERR           000100000
#define  RTGS_GD_ERR              000200000
#define  RTGS_GW_ERR              000400000
#define  RTGS_CALDELAY_ERR        001000000
#define  RTGS_CALWIDTH_ERR        002000000
#define  RTGS_SPARE               004000000
#define  RTGS_CAL_ENABLED         010000000
#define  RTGS_PWR_SUP_ERR         020000000
#define  RTGS_PWR_FAIL_ERR        040000000


STATUS rtgChkStatus(int rtgstatus,int incTiming,int incDrifted);
STATUS rtgCmpData(int fd,double *pdatReq,double *pdatActual,int *pmatch);
STATUS rtgCodeData(double ipp,double gd,double gw,double calDelay,
                   double calWidth,int *pcodedData);
void   rtgDecodeOne(int *codeData,double *prslt);
void   rtgDumpStat(int status,FILE *fp);
STATUS rtgGetData(int fd,double *pipp,double *pgd,double *pgw,double *pcd,
		         double *pcw);
STATUS rtgGetStatus(int fd,int *pstatus);
STATUS rtgInputData(int fd,int *codedData);
STATUS rtgLoadVerify(int fd,double *prtgData,int startCmd);
int    rtgOpen(void);
STATUS rtgOutputData(int fd,double ipp,double gd,double gw,double caldelay,
                            double calwidth,int startcmd);
STATUS rtgSendCmd(int fd,int command);
#endif	/* INCrtgh*/
