/*
 *	key definitions for sbdProg
*/
#ifndef INCsbdProgKeysh
#define INCsbdProgKeysh

/*	includes	*/
#ifdef VXWORKS
#include	<vxWorks.h>
#else
#include	<vxWorksEm.h>
#endif
#include	<aoParse.h>
 
/*	defines		*/
/*	prefix for keytable sbd_ defined in rdrDopLib.h */


KEY_DEF sbdKeys[]={
{"sbd_ephname"	   ,8,PARSE_T_STRING,
		        "#alpha . filename for ephmeris file. dummy for dummy ephm"},

{"sbd_ephoff"	   ,8,PARSE_T_DOUBLE,
			        "#double. ephmeris file offset in hz"},

{"sbd_dopcfr"	   ,6,PARSE_T_ARDBL,
		    "#double. freq to cmp dopppler at. syn1 ,syn2 hz (-1-->nochange)"},

{"sbd_steppoly"	   ,7,PARSE_T_INT,
			        "#int. poly step size in units of ephmfile entries"},

{"sbd_cmpdop"  	   ,6,PARSE_T_STRING,
			        "#alpha. do doppler computation on : tx,rx,txrx,none"},

{"sbd_txdownearly" ,7,PARSE_T_INT,
			        "#int. sec to bring tx down early."},

{"sbd_rxechosecst" ,7,PARSE_T_INT,
			        "#int. secs of echo before start rcv cycle."},

{"sbd_rxsecnoise"  ,7,PARSE_T_INT,
			        "#int. sec noise measure at end of rcv cycle."},

{"sbd_codelen"     ,6,PARSE_T_INT,
			        "#int. number of bauds in code to use."},

{"sbd_baudlen"     ,6,PARSE_T_DOUBLE,
					"#double. baudlen in usecs. resolution 25ns"},
{"sbd_ephdelay"    ,8,PARSE_T_INT,
					"#int. ephemeris delay in bauds"},
{"sbd_dephrate"    ,10,PARSE_T_DOUBLE,
					"#double. rate/sec dummy ephmeris"},
{"sbd_dephrtt"     ,10,PARSE_T_DOUBLE,
					"#double. rtt secs for dummy ephmeris"},
{"sbd_dephoff"     ,9,PARSE_T_DOUBLE,
					"#double. doppler offset start dummy ephmfile"},
{"sbd_bpflipped"   ,10,PARSE_T_LOG,
					"#alphas. rxBpFlipped at rxDop mixer input"},
{"sbd_usedcd"      ,5,PARSE_T_LOG,
					"#alphas. using the decoder. t,f"},
{"sbd_pncl"        ,5,PARSE_T_INT,
					"#int. 0 use pnc, 1 use pncl"},
{"sbd_fswnumfrq"   ,8,PARSE_T_INT,
					"#int. number freq for switching. 0--> none"},
{"sbd_fswfirstfrq" ,8,PARSE_T_DOUBLE,
					"#double. first frequency offset in hz."},
{"sbd_fswstepfrq"  ,12,PARSE_T_DOUBLE,
					"#double. freq step in hz."},
{"sbd_fswsteptm"   ,12,PARSE_T_DOUBLE,
					"#double. time for 1 freq in seconds"},
{"sbd_fswendtm"    ,8,PARSE_T_DOUBLE,
					"#double. secs at end of cycle before repeat."},
{"sbd_ippdop"      ,5,PARSE_T_INT,
					"#int. microseconds for ipp doppler update."},
{"sbd_txlomult"    ,7,PARSE_T_INT,
					"#int. 1 or 16. if using times 16 tx multiplier"},
{"sbd_dephpra "    ,10,PARSE_T_INT,
					"#double. ra hhmmss.s for dum ephm"},
{"sbd_dephpdec"    ,10,PARSE_T_INT,
					"#double. dec ddmmss.s for dum ephm"},
{NULL,0,0,NULL},
        };
#endif
