/* splAppVxLib - vxWorks side of split application 		*/
#ifndef INCsplAppVxLibH
#define INCsplAppVxLibH
/*
*modifications
*16may95 - updated to new msg format.
*/

#include	<vxWorks.h>
#include	<stdio.h>
#include	<aoMsg.h>
#include	<apShmCom.h>

/*	defines		*/

#define SIGH_OUTBUF_RDY_MSG_TIMEOUT_TICKS 1
/*
 *  local host info for shared memory setup in skybolt
*/
typedef	 struct {
	APSHMCOM 	*pshmCom;	/* ptr to shared memory*/
	int		nodesInp;	/* number input nodes*/
	int		nodesOut;	/* number output nodes*/
	int		inBufLenW;	/* length 1 input buf in words*/
	int		outBufLenW;	/* length 1 output buf in words*/
	APNODE		*p1stnode_inp;	/* 1st node inp in shm*/
	APNODE		*p1stnode_out;	/* 1st node out in shm*/
	int		node_index_inp; /* current index input node*/
	int		node_index_out; /* current index output node*/
	} AP_BUFI_H;


/*
 *	host side info for split applications
*/
typedef struct   {
	volatile int int_flag;	   /* for signal catcher*/
	FUNCPTR  sigH; 	   	   /* signal handler*/
	AP_BUFI_H bufIh;	   /* shm buf info for host*/
	int	skyPid;		   /* for sky progr*/
	int	setupDone;	   /* we've done setup at least once*/
	double  timeWait;	   /* for free buf put or get,sec*/
	double  timeIo;	    	   /* for free buf put or get,sec*/
	int	numBToAp;	   /* number sent to ap since setup*/
	int	numBFromAp;	   /* number rcved from ap since setup*/
	int	numBSigFromAp;	   /* number rcved signals from ap since setup*/
	SEM_ID  semPutBuf;	   /* wait for our sends to ap to finish*/
	SEM_ID  semGetBuf;	   /* wait for our get from  ap to finish*/
	AOM_ADR msgAdrGetBuf;      /* if non-null put outbufs here*/
	int	msgQSndErrs;	   /* times sig routined failed*/
	int     dmaSemGetTimeouts; /* trying to get dma ctrl*/
	int     dmaSemPutTimeouts; /* ditto*/
        }  AP_SPLINFO_H;



/*	prototypes	*/

AP_SPLINFO_H *apSplApStartup(char *cmdline);
STATUS        apSplApSetup(int nodesInp,int inpBufLenW,int nodesOut,
	        int outBufLenW,int numUserWords,int* usrWords,
		AOM_ADR  *pmsgAdr,AP_SPLINFO_H *psplI);
void          apSplApExit(AP_SPLINFO_H *psplI);
void          apSplExitAll(void);
STATUS        apSplWaitApSetup(AP_SPLINFO_H *psplI);
STATUS        apSplSndBufToAp(AP_SPLINFO_H *psplI,int byteInBuf,char *pbuf);
STATUS        apSplGetBufFromAp(AP_SPLINFO_H *splI,char *pbuf,int maxBytesBuf,
			int *pbytesRead,int *pwasSyncCmd);
void          apDumpNode(FILE* fp,int nodeInd,APNODE* pnd);
void          apDumpShmCom(APSHMCOM *pshmCom,FILE *fp);
void	      splAppDbg(void);

#endif
