/* 
 *	include file for sps 
*/ 
#ifndef INCspsh 
#define INCspsh 
#include	"aoErrNum.h" 
/*
 *	ioctl requests
 *   why does 0x12 not make it into the driver??. changed to 0x13
 * 08feb94 - changed to new status bits
*/
#define SPSSETMSTCLK		 0x01
#define SPSSETSMPCLK0		 0x02
#define SPSSETSMPCLK1		 0x03
#define SPSSETCLKS   		 0x04
#define SPSIOCWAITINT            0x05
#define SPSIOCSTAT               0x06
#define SPSIOCSOFFLEN            0x07
#define SPSIOCGOFFLEN            0x08
#define SPSIOCLDBUF              0x09 
#define SPSIOCDEBUG              0x0a
#define SPSIOCENAINT             0x0b
#define SPSIOCSCLOCKS            0x0c
#define SPSIOCGCLOCKS            0x0d
#define SPSIOCRDBUF              0x0e
#define SPSIOCACTBUF             0x0f
#define SPSIOCDEFSTATE           0x10
#define SPSIOCSNDCMD             0x13
#define SPSIOCUPDATEREGS         0x14
#define SPSIOCGETSTATE           0x15
#define SPSIOCLDSTATE            0x16
#define SPSIOCGALLREGS           0x17
#define SPSIOCDEFSWBUF           0x18
#define SPSIOCENASWBUF           0x19
#define SPSIOCDISSWBUF           0x1a
#define SPSIOCSTATATINT          0x1f
#define SPSIOCGINTINFO           0x20
/*
 *	masks
*/
#define	SPS_MSK_MASTER_CLOCK  0x0000FF00
#define	SPS_MSK_SMP_CLOCK0    0x00FF0000
#define	SPS_MSK_SMP_CLOCK1    0xFF000000
#define	SPS_MSK_MAX_WRDCNT    0x00001FFF
#define	SPS_MSK_BUFOFF        0x00001FFF
#define	SPS_MSK_WRDCNT        0x1FFF0000
#define	SPS_MSK_CMDWRD        0x000003FF
#define	SPS_MSK_STATUS        0x00001FFF
#define SPS_CMSK_CLEAR	      0x00000001
#define SPS_CMSK_ACTIVATE_BUF 0x00000002
#define SPS_CMSK_ACTM         0x0000000C 
#define SPS_CMSK_INT  	      0x00000030
#define SPS_CMSK_TRIG	      0x000000C0
#define SPS_CMSK_SYSCLK       0x00000300
#define SPS_SMSK_TRIG         0x00000300
#define SPS_SMSK_SYSCLK       0x00000400
/*
 *	sps address offsets. These are offsets from the vme base adr of the
 *	sps.
*/
#define SPS_ADR_STATE         0x00000000
#define SPS_ADR_DURATION      0X00008000
#define SPS_ADR_CLOCK         0X00010000
#define SPS_ADR_BUFOFF_WRDCNT 0X00018000
#define SPS_ADR_CMD           0X00020000
#define SPS_ADR_STATUS        0X00028000
#define SPS_ADR_GETACTREG     0X00028000
/*
 *	macros to set bits in address words
*/
#define SPS_SET_CLOCKS(MCLK,SCLK0,SCLK1) \
	      		( (((MCLK)&0xff) << 8) | (((SCLK0)&0xff) << 16) | \
			  (((SCLK1)&0xff) << 24))
#define SPS_SET_MASTER_CLOCK(WRD,VAL)  \
	              ( ((WRD) & (~SPS_MSK_MASTER_CLOCK)) | (((VAL)&0XFF)<< 8))
#define SPS_SET_SMP_CLOCK0(WRD,VAL)  \
	              ( ((WRD) & (~SPS_MSK_SMP_CLOCK0  )) | (((VAL)&0XFF)<<16))
#define SPS_SET_SMP_CLOCK1(WRD,VAL)  \
	              ( ((WRD) & (~SPS_MSK_SMP_CLOCK1  )) | (((VAL)&0XFF)<<24))
#define SPS_GET_MASTER_CLOCK(WRD)  \
	              ( ((WRD) & SPS_MSK_MASTER_CLOCK) >>  8)
#define SPS_GET_SMP_CLOCK0(WRD)  \
	              ( ((WRD) & SPS_MSK_SMP_CLOCK0)   >> 16)
#define SPS_GET_SMP_CLOCK1(WRD)  \
	              ( ((WRD) & SPS_MSK_SMP_CLOCK1)   >> 24)

#define SPS_SET_BUFOFF(WRD,VAL)  \
                        (((WRD) & (~SPS_MSK_BUFOFF)) | \
		         ((VAL) &   SPS_MSK_MAX_WRDCNT) )
#define SPS_SET_WRDCNT(WRD,VAL)  \
	              ( ((WRD) & (~SPS_MSK_WRDCNT)) |\
		       (((VAL) &   SPS_MSK_MAX_WRDCNT) << 16))
#define SPS_GET_BUFOFF(WRD)  ( (WRD) & SPS_MSK_BUFOFF)  
#define SPS_GET_WRDCNT(WRD)  (  ((WRD) & SPS_MSK_WRDCNT) >> 16)  
/*
 *	cmd bits
*/
#define SPS_CMD_CLEAR            0x00000001
#define SPS_CMD_ACTIVATE_BUF     0x00000002
#define	SPS_CMD_ACTM_1STTRIG   0x00000004
#define	SPS_CMD_ACTM_EVERYTRIG 0x00000008
#define	SPS_CMD_ACTM_ENDBUF    0x0000000C
#define	SPS_CMD_INT_BEGBUF_ONCE  0x00000010
#define	SPS_CMD_INT_BEGBUF_EVERY 0x00000020
#define	SPS_CMD_INT_DISABLED     0x00000030
#define	SPS_CMD_TRIGIS_10SEC     0x00000040
#define	SPS_CMD_TRIGIS_1SEC      0x000000C0
#define	SPS_CMD_TRIGIS_EXT       0x00000080
#define	SPS_CMD_DRIFTED_CLOCK    0x00000200 
#define	SPS_CMD_FIXED_CLOCK      0x00000300
/*
 *	macros to access sps status bits
*/
#define	SPS_S_NOFIXEDCLK(stat)      ( (stat) &                   0x001)
#define	SPS_S_NODRIFTEDCLK(stat)    ( (stat) &                   0x002)
#define	SPS_S_INTBEGBUF_START(stat) ( (stat) &                   0x004)
#define	SPS_S_INTBEGBUF_RECIRC(stat) ( (stat) &                  0x008)
#define	SPS_S_START_ON_TRIG(stat)   ( (stat) &                   0x010)
#define	SPS_S_RECIRC_ON_TRIG(stat) ( (stat) &                    0x020)
#define	SPS_S_NBUF_PENDING(stat)    ( (stat) &                   0x040)
#define	SPS_S_MCLK_ENABLED(stat)    ( (stat) &                   0x080)
#define	SPS_S_TRIGIS_10(stat)       (((stat) & SPS_SMSK_TRIG) == 0x100)   
#define	SPS_S_TRIGIS_EXT(stat)      (((stat) & SPS_SMSK_TRIG) == 0x200)   
#define	SPS_S_TRIGIS_1(stat)        (((stat) & SPS_SMSK_TRIG) == 0x300)   
#define	SPS_S_DRIFTED_CLK(stat)     (((stat) &                   0x400)  == 0)
#define	SPS_S_FIXED_CLK(stat)       ( (stat) &                   0x400)
#define	SPS_S_NO_1SEC_TICK(stat)    ( (stat) &                   0x800)
#define	SPS_S_NO_10SEC_TICK(stat)   ( (stat) &                  0x1000)
/*
 *	constants        
*/
#define	SPS_MEMORY_LEN_WDS     0x00002000
#define SPS_DEFBUF_LEN      		10
#define SPS_DEFBUF_STARTADR (SPS_MEMORY_LEN_WDS - SPS_DEFBUF_LEN)

#define SPS_TRIGCODE_10SEC	        1
#define SPS_TRIGCODE_EXT  	        2
#define SPS_TRIGCODE_1SEC	        3

#define SPS_ACTMCODE_1STTRIG		1
#define SPS_ACTMCODE_EVERYTRIG		2	
#define SPS_ACTMCODE_ENDBUF   		3	

#define SPS_INTCODE_BEGBUF_ONCE		1
#define SPS_INTCODE_BEGBUF_EVERY	2	
#define SPS_INTCODE_DISABLE  		3	

#define SPS_ABS_OFF_CODE		1
#define SPS_REL_OFF_CODE		2

#define SPS_MAXBUFS_SW			10

#define SPS_BIT_SP0	       0x00004000
#define SPS_BIT_SP1	       0x00008000
/*
 *	other
*/
#define	SPSDEVNAME "/sps"
/*
 *      structure for interrupt info
*/
typedef struct {
        int     late;           /* for interupt*/
        int     timeout;        /* for wait in ticks*/
        int     intcount;
	int     statAtInt;	/* status at last interrupt*/
        }  SPS_INTINFO;
/*
 *	sps registers
*/
typedef struct {
	int 	bufLen;		/* length of buffer*/
	int	bufOff;		/* buffer offset start of memory*/
	int	mClkDiv;	/* master clock divisor. n where clk=20/(n+1)*/
	int	sClk0Div;	/* smp  clock0  divisor. n where clk=20/(n+1)*/
	int	sClk1Div;	/* smp  clock1  divisor. n where clk=20/(n+1)*/
	}  SPS_REG;

typedef struct {
	int	bufOffAbs;	/* true --> absolute buffer offset*/
	SPS_REG	intfReg;	/* interface registers*/
	int	fixedClock;	/* true. false --> drifted system clock*/
	int     actMode;        /* activate on
				   1 - 1st trig
				   2 - on every trigger
			           3 - end of previous buf (recirculate mode) 
				*/
	int	trigToUse;	/* trigger to use  
				   1 - 10sec tick
			 	   2 - external tick
				   3 - 1sec tick */
	int	intMode;	/* when to generate an interrupt
				   1 - begining of buffer once
				   2 - begging of every buffer
				   3 - disabe interrupts */
	} SPS_STATE;

typedef	struct	{
	int	buflen;
	int	timesToRun;
	int	*pstate;
	int	*pdur;
	} BUFSW_INFO;
/*
 *	interrupt information
*/

typedef	struct	{
	int	intMode;
	int	intcount;
	int	intCurList;	/* if switching*/
	int	intCurBuf;	/* if switching*/
	int	statLastInt;	/* status last interrupt*/
	} SPSINT_INFO;
#endif	/* INCspsh*/
