#ifndef INCsufLibh
#define INCsufLibh
#ifdef	VXWORKS
#include	<vxWorks.h>
#else
#include	"vxWorksEm.h"
#endif

#define	MAXKEYLEN 20
#define MAXVALLEN 80
#define MAXNUMSET 30
#define MAXSUFILES 4
#define SUFILE_NO_KEY    -1
#define SUFILE_BAD_VALUE -2 
#define PRGLINE_ID	"#!"
#ifndef DELIMS
#define DELIMS	" \t\n"
#endif

/*
 * 	keys that we need
*/
#ifndef ERR_PRE
#define ERR_PRE		"  -->err:"
#endif


/*	typedefs	*/

/*
 *	generate a filename format is:
 *   path/basename.su/sps.{ext.}[suffix .. cur,def,user 
*/
typedef struct	{
	char	pathIo[80];	/* path name for input/output */
	char	pathCur[80];	/* for .cur/.def files*/
	char	id[20];
	int	useIdExt;		/* true false*/
	char	idExt[20];
	char    type[20];	/* su,sps,ap,...*/
	char	suf[20];	/* .cur, .def, or user specified*/
	} NAME_INFO;

/*	definition of the SUFILE_DAT structure.
 *	It holds the prog key file and set key value inputs from the
 *	setup file.
*/

typedef struct {
	char	key[MAXKEYLEN];
	char	val[MAXVALLEN];
	} SET_DAT;

typedef struct {
	char	prog[MAXKEYLEN];
	char	key[MAXKEYLEN];
	char	file[MAXVALLEN];
	} PRGSU_FILE;

typedef struct {
	int	numSets;
	SET_DAT psets[MAXNUMSET];
	int     numPrgFiles;
	PRGSU_FILE pprgFiles[MAXSUFILES];
	} SUFILE_DAT;

/*	globals		*/


/*	prototypes	*/

void   nmCpy(NAME_INFO *pto,NAME_INFO *pfrom);
void   nmSetId(NAME_INFO *pnm,char *pid);
void   nmSetIdExt(NAME_INFO *pnm,char *pidExt);
void   nmMake(NAME_INFO *pnm,char *fname);
STATUS nmSetPath(NAME_INFO *pnm,char *path);
STATUS nmSetPathCur(NAME_INFO *pnm,char *path);
void   nmSetSuf(NAME_INFO *pnm,char *psuf);
void   nmSetType(NAME_INFO *pnm,char *ptype);

STATUS suFileAddKey(char* key,char* val,SUFILE_DAT *psufDat);
STATUS suFileAddPrg(char* prg,char* id,char* file,SUFILE_DAT *psufDat);
void   suFileClear(SUFILE_DAT *psuf);
void   suFileCopy(SUFILE_DAT *pto,SUFILE_DAT *pfrom);
int    suFileGetDouble(char *key,SUFILE_DAT *psufDat,double *pdbl);
int    suFileGetFloat(char *key,SUFILE_DAT *psufDat,float *pflt);
int    suFileGetInt(char *key,SUFILE_DAT *psufDat,int *pint);
int    suFileGetStr(char *key,SUFILE_DAT *psufDat,char **ppchar);
STATUS suFileInp(char* fileName,SUFILE_DAT *psufDat);
STATUS suFileKeyMatch(char* key,SUFILE_DAT *psufDat);
STATUS suFileOut(char *file,SUFILE_DAT *psufDat);
STATUS suFilePrgMatch(char* prg,SUFILE_DAT *psufDat);
STATUS suFileSend(char *host,NAME_INFO *pnm);

#endif	/*INCsufLibh*/  
