/* 
 *	include file for swProg.c
*/
#ifndef INCswProgh
#define INCswProgh
#include	<semLib.h>
#include	"aoMsgQLib.h"
#include	"bufPoolLib.h"
#include	"swProgLib.h"

/*      global setup structure that
 *      is used by sun and vxWorks
*/
         
/*
 *      typedef for setup structure swProg
*/
typedef struct  {
        int     tapeOn;    /* 0=false,1=true*/
        int     discOn;    /* 0=false,1=true*/
        int     sockOn;    /* 0=false,1=true*/
        int     gioOn;    /* 0=false,1=true*/
        int     dutycycle;         /* output 1 buf every thismany bufs*/
	int	numOutputs;	   /* we're actually using*/
} SW_INFO;

/*
 *	info for agents that are active
*/
typedef struct {
	int		sndGrps;	/* true/false if true, send groups rather than bufs*/
	int		leftToSend; /* grps or bufs*/
	int		curGrp;		/* sending -1 --> start or last rec no hdr*/
	int		curScan;	/* sending*/
	AOM_ADR aomAdr;		/* address for response*/
	int     msgNum;		/* we initially rcved*/
	int		bufsSent;	/* count the buffers we've sent for this request*/
	} SWAGINFO;

typedef struct {
	int	agActive;	/* number of active agents in array*/
	SWAGINFO agArr[SWMAXAGENTS]; 	/* array to hold active agents*/
	} SWAGLIST;  
/*
 *	function prototypes
*/
STATUS     swAgWantsBufs(AOMSG_Q_ID agInpQ,AOMSG_Q_ID agReplyQ,int numbufs,
                         int *pmsgNumBatch,int chktimeout,char *prgname);
STATUS  swDiscOut(AOMSG_Q_ID replyQ,int on,int timeout);
STATUS  swTapeOut(AOMSG_Q_ID replyQ,int on,int timeout);
STATUS  swSockOut(AOMSG_Q_ID replyQ,int on,int timeout);
STATUS  swStopProgs(void);
STATUS  swProgStart(void);
void    swProgStop(int sync,FUNCPTR chkstop);
int     swProgIsRunning(void);
AOMSG_Q_ID swRetpCmdQ(void);
STATUS swSetup(AOMSG_Q_ID replyQ,char* setupInfo,int chktimeout,char *prgname);
void    swProgDbg(void);
#endif  /* swProgh */
