#ifndef tdAutoTrkH
#define tdAutoTrkH
/*
 * include file for tiedown autotracking
 * put in changes for tracking avghght
 * history:
 * 15apr00 - moved constants TDPRF_INFO TO REF_INFO
 * 01may00 <pjp002> switched pitch roll -> grid to function
 * 31jan02 <pjp027> updated TDFIT2D_PR_1 structure for new fit.
 *                  old version in tdAutoTrk.hOld versoin 10804..
*/
#ifdef VXWORKS
#include	<vxWorks.h> 
#else
#include	<vxWorksEm.h>
#endif
#include	<stdio.h>
#include	<tieProg.h>
/*  
 * reference info
*/
#if FALSE
#define TDATRK_REF12_IN 14.44
#define TDATRK_REF4_IN  14.44
#define TDATRK_REF8_IN  13.33
...
 below till 07apr00.. td4 lost position on 04apr00
#define TDATRK_REF12_IN 14.54
#define TDATRK_REF4_IN  14.62
#define TDATRK_REF8_IN  13.04
...
below till 01mar03
#define TDATRK_REF12_IN 14.697
#define TDATRK_REF4_IN  14.438
#define TDATRK_REF8_IN  13.065
#endif

#define TDATRK_REF12_IN 14.875
#define TDATRK_REF4_IN  14.616
#define TDATRK_REF8_IN  13.243

/* default platform height feet above sea level*/

#if FALSE
till 01MAR03
#define TDATRK_REFPLTHGHT_FT 1256.35
#endif
#define TDATRK_REFPLTHGHT_FT 1256.22

/*	if temp < this, don't bother in trkTemp */

#define TDATRK_DELTA_TEMP_TO_MOVE	.2

/* 	if height change (from last move) is < this don't bother to move
	be careful with float resolution of 7 digits*/

#define TDATRK_DELTA_HGHT_TO_MOVE_FT	.003


#define TDATRK_MAX12_IN (TIE_POS_FLIM12_MAX - TIE_POS_SWLIM_OFFSET)
#define TDATRK_MAX4_IN  (TIE_POS_FLIM4_MAX  - TIE_POS_SWLIM_OFFSET)
#define TDATRK_MAX8_IN  (TIE_POS_FLIM8_MAX  - TIE_POS_SWLIM_OFFSET)

#define TDATRK_MIN12_IN (TIE_POS_FLIM12_MIN + TIE_POS_SWLIM_OFFSET)
#define TDATRK_MIN4_IN  (TIE_POS_FLIM4_MIN  + TIE_POS_SWLIM_OFFSET)
#define TDATRK_MIN8_IN  (TIE_POS_FLIM8_MIN  + TIE_POS_SWLIM_OFFSET)

#if FALSE
...till 28apr00
#define TDATRK_TDIN_PER_PLTFIN	-1.74
#define TDATRK_TDIN_PER_PLTFIN_ROT  1.24
..
till 01mar03 ... 
#define TDATRK_TDIN_PER_PLTFIN	   -1.66
#define TDATRK_TDIN_PER_PLTFIN_ROT  1.31
#endif
/* from 2002 data -1.73 looks good rotation same as before*/
#define TDATRK_TDIN_PER_PLTFIN	   -1.73
#define TDATRK_TDIN_PER_PLTFIN_ROT  1.31
/* 
#define TDATRK_IN_PER_DEGF  (-1.74 * .2) till 26jan00
#define TDATRK_IN_PER_DEGF  (-1.74 * .24) till 02feb00 afternoon
#define TDATRK_IN_PER_DEGF  (-1.74 * .23) till 03feb   afternoon
#define TDATRK_IN_PER_DEGF  (-1.74 * .21) till 06feb 18:45
#define TDATRK_IN_PER_DEGF  (-1.74 * .225) till 07feb 10:45
#define TDATRK_IN_PER_DEGF  (-1.74 * .235) till 07feb 17:25
#define TDATRK_IN_PER_DEGF  (-1.74 * .215) till 03mar00 12
#define TDATRK_IN_PER_DEGF  (-1.74* .215) till 28apr00 
*/
#define TDATRK_IN_PER_DEGF  (-1.73 * .205) 
#define TDATRK_IN_PER_DEGF_DAY_EXTRA  (TDATRK_TDIN_PER_PLTFIN * 0) 
#if FALSE
 till 01mar03
#define TDATRK_REF_TEMP     72.
#endif
#define TDATRK_REF_TEMP     70.
/*
 * max vel in/sec. using 2047 da output
*/
#define TDATRK_MAX_VEL      .086	
/*
 * ramps
*/
#define TDATRK_RAMP_VELMAX     .06
#define TDATRK_RAMP_STEPS_ACCEL 20

#define TDATRK_STAT_UPDATE	 1
#define TDATRK_STAT_NOCHANGE 2
#define TDATRK_STAT_BADTEMP  3

/* 
*   logging
*/
#define TDATRK_DLOG_MAXMSG  50
#define TDATRK_DLOG_FILE_NAME    "/share/obs1/pnt/td/dlogTd"
/*
 * 	typedefs
*/
/*
 * reference values
*/
typedef struct {
    float       defPosIn[3];  /* td default reference not changeable*/
	float		offIn[3];	  /* td req offset from above ref*/
    float       usePosIn[3];  /* td ref position in use.td 12, td 4, td 8*/
	float		usePosMeanIn; /* td mean position we are using*/
    float       defTempF;     /* default reference temp not changeable*/
    float       tempFOff;     /* req temp offset from above*/
    float       useTempF;     /* req temp in use*/
    float       maxPosIn[3];  /* td max tiedown positions inches*/
    float       minPosIn[3];  /* td min tiedown positions inches*/
    float       tdInPerDegFN; /* nightime ..tie inches to move per deg F*/
    float       tdInPerDegF_Dex;/* extra value to add 8->20 hours*/
	/*
	 * following use for pitch,roll,focus computations.
	*/
	float		azTdRd[3];	  /* azimuth positions of tiedowns in radians*/
	float		tdMaxVel;	  /* inches/sec*/
	float		tdRadiusHor;  /* main bearing center to tiedown cable. ft*/
	float		radOptCenIn;  /* optical center to focus:in 434*12.*/
	float		scaleRot;     /* scale factor rotation .tdIn/plFrmIn*/
	float		scaleTr;      /* scale factor translation.tdIn/plFrmIn 1.66*/
	float       S;            /* 1deg*pi/180* 192*12* scaleRot*/
	float       offset;       /* za optical,mechanical*/
	float       zaMin;        /* min za deg*/
	float       zaMax;        /* min za deg*/
	 
	/*
	 * for tracking height we use the reference position and the
	 * average offset from offIn.. note that offIn is td inches
	 * average height is platform feet (-1.66 tdInch/platfrom inch is
	 * the conversion)
	 */
	float		defPlHft;   /*dflt platform height.feet above sealvl. fixed..*/
	float		offPlHft;  /* offset def height computed from offIn*/
	float       usePlHft;/* platform height used*/
} TDATRK_REF_INFO;
/*
 * lr info used by td
 * record avgHght, tempF, and tempAtHght.
 * these values have passed our "okdata" test. 
 * We will often read a temperature but no data (it's raining) so
 * we need separate timestamps for the height, temp.
 * We may track temperature change from the last valid height
 * so we need to record the temp at last height too.
 * The timestamps are those when the laser ranging data was read in
 * vw lrMon.c
*/
typedef struct {
	int	tmLastLrChecked;	/* last lr timestamp we looked at*/
	/*
	 * the following are that we actually used.
	 * we may skip values if data bad or tolerance hasn't
	 * changed. In either case we need to remember the last we
	 * actually used, not that we read .
	*/
	int	tmLastHght;	        /* time for last good height we kept*/
	int	tmLastTemp;	        /* time for last good temp we kept*/
	float avgHghtFt;		/* last avg height we kept*/
	float tempF;		    /* last temp we kept*/
	float tempAtLastHght;   /* temp at last hght we kept*/
	} TDATRK_LRDAT;	
/*
 * computed values for motion
*/
typedef struct {
	int		useRamp; 	/* true if ramps are used*/
	int		trackCode;	/* what type of tracking*/
	TDATRK_LRDAT lrI;
	/* 
	 * computes offset do to temp and computed offsets to to
 	 * pitch,roll,focus, from the position of the az,gr.
	 * these are offsets from the reference position  in use.
    */	
    float   offInCmpTemp; /* offset from ref in inches do to temp*/
    float   offInCmpPlH;  /* offset from ref in inches from trk avg hght*/
	float   offInCmpPos[3];/*from useRef[i] and position computations*/
	/*
  	 * we constrain the offsets to keep the tilt the same and not go
	 * thru a limit. 
	 * Then compute the absolute postions and average positions.
	*/
    float   avgHghtOverflowIn;/* output value decreased by this*/
	float   posInCon[3];/*constrained position each td. includes everything*/
    } TDATRK_CMP_INFO;

typedef struct {
    int         tm;              /* last sent info*/
    float       outPosIn[3];     /* position we output*/
	float		outVel[3];		 /* velocity end of step*/
    } TDATRK_OUT_INFO;  /* we output*/


/*
 * info on computing a ramp. just uses average velocity
*/
typedef struct {
    int         rampAct;   /* true if ramp active*/
    int         stepsA;    /* for acceleration*/
    int         stepsDA;   /* for de-acceleration*/
    int         stepsToDo; /* to make move*/
    int         stepCur;   /* 0 thru stepsToDo - 1*/
    double      velM;      /* maximum velocity in/sec*/
    double      accelM;    /* accel in/sec**2  computed*/
    double      deAccelM;    /* accel in/sec**2  computed*/
	/* 
	 * vel and posIncrement values end of current step
	*/
	float		velEndStepAvg; /* avg Vel End of step*/
	float		posIncStepAvg; /* amount avg position changes this step*/
} TDATRK_RAMP;

/*
 * logging of temp tracking
*/
typedef struct {
    int     timeNow;           /* current sec/midnite*/
    short   tempF;             /* temp in millidegF */
    short   avgHghtOverflowMil; /* computed avg went beyond limit. mils*/
    short   tempDifMil;        /* mils to move from last temp*/
    short   cmpPosMil[3];      /* position sent (mils)*/
    } TDATRK_DLOG_TEMP_MSG;
/*
 * for pitch,roll,focus
 * on disc the 2d table varies most rapidly in az and is dimensioned
 *   [41][360].. on input we extend the last point = firstpoint (0=360)
*/
typedef struct {
	double		  c0;	    /* constant term*/	
	double        az1A;     /* 1az Amp     deg */
    double        az1Ph;    /* 1az phase (radians) */
    double        az3A;     /* 3az ampl    deg */
    double        az3Ph;    /* 3az phase (radians)*/
    double        za3A ;    /* za* 3az*/
    double        za3Ph;    /* za* 3az*/
    double        za4A ;    /* za* 4az <pjp027> here and below*/
    double        za4Ph;    /* za* 4az*/
    double        za6A ;    /* za* 6az*/
    double        za6Ph;    /* za* 6az*/
    double        czaPoly[20];/* zaM,zaM^2....*/
	} TDFIT2D_PR_1;

typedef struct {
	TDFIT2D_PR_1  p;		/* pitch*/
	TDFIT2D_PR_1  r;		/* roll*/
	double		 zaPolyMin;	/* constant to subtract from za Deg*/
	double		 zaPolyDiv;	/* constant to divide into za*/
	int			 zaPolyDeg; /* degree of polynomial*/
	int			 version;	/* yymmdd*/
	} TDFIT2D_PR;
#if FALSE
typedef struct {
    float       az[361];    /* 0-> 360.. first last points the same*/
    float       za[41];     /* 0-> 20 .. in .5 degree steps.*/
    float       p[41][361];  /*          pitch in degrees*/
    float       r[41][361];  /*          roll  in degrees*/
    } TDPR_TBL;

typedef struct {
    TDPR_TBL    *pprTbl;       /* pointer to pitch,roll table*/
	int			 tblInitialized;/* not zero --> intialized*/
	char		 prFname[132]; /* hold pitch,roll filename we are using*/
	float		 lastTdPos[3];
    } TDPRF_INFO;
#endif

typedef struct {
    TDFIT2D_PR   fit2d;       /* holds fit coefficients*/
	double		 pitchOff;	  /* deg. to add to computed value*/ 
	double		 rollOff;	  /* deg. to add to computed value*/ 
	double		 focOff;	  /* radial inches. to add to computed value*/ 
	double		 azDeg;		  /* last az,za,p,r for debugging*/
	double		 zaDeg;
	double	     pitchDeg;	  /* total used computed + pitchOff*/
	double	     rollDeg;    /* total used*/
	double	     focRadIn;   /* radial focus inches. includes offset*/
	double       focPitch;	 /* td focus inches from pitchDeg + pitchOff*/
	double       focErr;	 /* td focus inches from focus and focOff*/
	double       focTot;	 /* td focus inches total*/
	double		 azErrRd;    /* from prf!! note this gets added 1 sec late*/
	double		 zaErrRd;    /* from prf*/
	double       pntErrP[3];	/* poly 2nd order in zaDeg*/
	double       pntErrR[3];	/* poly 2nd order in zaDeg*/
	int			 fitInitialized;/* not zero --> intialized*/
	char		 prFname[132]; /* hold pitch,roll filename we are using*/
    } TDPRF_INFO;



/* prototypes
*/
void tdatrkInit(TDATRK_REF_INFO *prefI);
void tdatrkNewReq(float refOffIn[3],float tempOffRef,int trkCode,
				  TDATRK_REF_INFO *prefI,TDATRK_CMP_INFO *pcmpI);
void tdatrkTemp(TDATRK_REF_INFO *prefI,float refTempF,float tempF,
				int secMid, float *poffInTemp);
void tdatrkHght(TDATRK_REF_INFO *prefI,float curPlHft,float *pcurTdPos,
				float *preqTdPos);
void tdatrkChkLim(TDATRK_REF_INFO *prefI,TDATRK_CMP_INFO *pcmpI);
void tdatrkRampInit(TDATRK_REF_INFO *prefI,float *pcurPos,float *pendPos,
				int stepsA,float maxV,TDATRK_RAMP *pI,float *pstartPos);
void tdatrkRampStep(TDATRK_RAMP *pI);
void tdatrkDump(FILE *fp,TDATRK_REF_INFO *prefI,TDATRK_CMP_INFO *pcmpI,
				TDATRK_RAMP *pI,TDPRF_INFO *pprfI);
STATUS tdPRFInit(char *prFname,TDATRK_REF_INFO *ptdRefI, TDPRF_INFO *pprfI);
STATUS tdPRFcmp(int offsetOnly,double az,double za,TDPRF_INFO *pI,
				TDATRK_REF_INFO *prefI,float *ptdPos);
void  tdPRFErr(TDPRF_INFO *pprfI,TDATRK_REF_INFO *prefI,double zaRad,
			   double pitch,double roll,double focusRadIn,
      		   double *pzaErrRd,double *pazErrRd);

#endif
