/*
 *	include file for tdComLib
*/
#ifndef INCtdComLibh
#define INCtdComLibh

#include	<vxWorks.h>
#include	<semLib.h>

/*
 *  commands to tdProg
*/

#define	TDCOM_CMD_NOP		0
#define	TDCOM_CMD_START_TD	1	
#define	TDCOM_CMD_STOP_TD 	2
#define	TDCOM_CMD_EXIT 		3
#define TDCOM_CMD_FLUSH		4
/*
 * state of tdProgram
*/
#define	TDCOM_STATE_TAKEDATA    1
#define	TDCOM_STATE_WAITING     2
#define	TDCOM_STATE_EXIT 	3

typedef struct {
	int	cmdToTd;	
	int	tdState;	/* current state of td program*/
	int	tdStatus;	/* ok or last errno*/
	SEM_ID  semTd;		/* tdProgram waits on this sem*/
	SEM_ID  semCom;		/* communication prog waits on this sem*/
	SEM_ID  semTakingData;  /* if you want to wait for datataking to 
				   finish.. this is flushed at the end*/
	char	nameTd[32];	/* name td program*/
	char	nameCom[32];	/* name com program*/
	} TDCOM_INFO;	

/*	prototypes	*/

/*
 * routines called by tdCom program
*/
STATUS tdComCleanup(TDCOM_INFO *pinfo);
STATUS tdComCmdToTd(int cmd,TDCOM_INFO *pinfo,int timeout);
void   tdComDump(FILE *fp,TDCOM_INFO *ptdI,char *label);
STATUS tdComExit(TDCOM_INFO *pinfo,int timeout);
STATUS tdComFlush(TDCOM_INFO *pinfo,int timeout);
STATUS tdComInit(char *nameCom,char *pnameTd,TDCOM_INFO *pinfo);
int    tdComQExit(TDCOM_INFO *pinfo);
int    tdComQTakingData(TDCOM_INFO *pinfo);
int    tdComQWaitig(TDCOM_INFO *pinfo);
STATUS tdComStartDt(TDCOM_INFO *pinfo,int timeout);
STATUS tdComStopDt(TDCOM_INFO *pinfo,int timeout);
/*
 * routines called by tdProg
*/
void   tdComTdExit(TDCOM_INFO *pinfo);
STATUS tdComTdGetCmd(TDCOM_INFO *pinfo,int *pcmd);
void   tdComTdSetStatus(TDCOM_INFO *pinfo,int status);
	
#endif  /* tdComLibh */
