#ifndef 	INCterProgh 
#define 	INCterProgh
#include	"terProgState.h"
/*
 * include file for terProg.h.
*/
/*  state of tertiary device */


/* mask to check the crc,mIndE,zIndE at one shot given TER_ENC_STAT*/

#define TER_ENC_ST_ERRS 0xfffe0000 

/*-----------7 status words ----------------------*/

/* statwords read from device. map bits to bitfields for easier access*/

typedef struct {
	unsigned int        fill1:16;
	unsigned int        local:1;
	unsigned int   safetyEna :1;	/* safety is closed*/
	unsigned int emgStpCtrlRm:1;/* control room emergency stop is enabled*/
	unsigned int   emgStpDoor:1;/* door emergency stop is active*/
	unsigned int       drvFlt:5;/* LV,RV,LH,RH,titlt drive fault*/
	unsigned int        peCmd:1;/* parity error on command word*/
	unsigned int mcc15VSupFlt:1;/* mcc 15 volt supply fault*/
	unsigned int   drvSpurFlt:5;/* spurious drive fault*/
	} TER_DEV_STATUS_FAULTS;

/* 	general status.. pwr,preset,ready status from dev	*/

typedef struct {
	unsigned int	   fill1:16;/* unused*/
	unsigned int    reqEnaAc:1 ;/* ac enable requested*/
	unsigned int  reqEnaDrvs:5 ;/* LeftV,RV,LH,RH,tilt*/
	unsigned int       acEna:1 ;/* ac is enabled*/
	unsigned int     drvsEna:5 ;/* enable drives lv,rv,lh,rh,tilt*/
	unsigned int	   fill :4;/* unused*/
	} TER_DEV_STATUS_POWER;

/*  presets */
	
typedef struct {
	unsigned int	      fill1:16;/* unused*/
	unsigned int        zIndEna:5; /* z index preset is ena,lv,rv,lh,rh,tilt*/
	unsigned int        mIndEna:5; /* m index preset is enabled*/
	unsigned int          fill2:6; /* free*/
	} TER_DEV_STATUS_PRESET;

/*  limits */
	
typedef struct {
	unsigned int	      fill1:16;/* unused*/
	unsigned int            neg:5; /* negative limit*/
	unsigned int            pos:5; /* positive limit*/
	unsigned int       wrackVpos:1; /* positive veritical wracking*/
	unsigned int       wrackVneg:1; /* negative veritical wracking*/
	unsigned int       wrackHpos:1; /* positive hor wracking*/
	unsigned int       wrackHneg:1; /* negative hor wracking*/
	unsigned int          fill2:2; /* free*/
	} TER_DEV_STATUS_LIMITS;

/* status ready */
 
typedef struct {
	unsigned int	        fill1:12;   /* unused*/
	unsigned int               pe:3;/* 1 -wds 0,1,2=words 2,3,4:words 4,5*/
	unsigned int          updated:1;/* true when status has updated*/
	} TER_DEV_STATUS_REQ;

typedef struct	{
	TER_DEV_STATUS_FAULTS	  flts;
	TER_DEV_STATUS_POWER 	  pwr; 
	TER_DEV_STATUS_PRESET 	  preset; 
	TER_DEV_STATUS_LIMITS limits;
	int				 loopBkCmd;		/* command word looped back*/
	int			    loopBkMask;		/* mask    word looped back*/
	TER_DEV_STATUS_REQ         req;		/* updated or pe*/
	} TER_DEV_STATUS_WORDS;

/*-----------7 status words ----------------------*/

#endif
