/*
 *	include file for generic time routines ... these are macros
 *	that call device specific routines. to switch devices, just
 *	edit the macros
 * 06mar00.. fixed bug tm_not_leap year.. wasn't checking for 
 *           years divisible by 400. most code was using isLeapYear function
 *		     that was correct .. only used by the rfi crate 147..
*/
#ifndef INCtimeLibh
#define INCtimeLibh
/*
 *	some handy macros
*/
/*
 *	return TRUE if not leap year
 *  not divisible by 4  or
 *   (divisible by 100 and not divisible by 400)
*/

#define	TM_NOT_LEAPYEAR(year) ( ((year)%4) ||  \
				( (((year)%100)==0) && ((year)%400) ) )
/*
 *	return day of year given d,m,y.
*/
#define TM_DAYNO_FROM_DMY(d,m,y) \
	(TM_NOT_LEAPYEAR(y)?(dayNoByMonth[(m)-1]+(d)):\
			    (dayNoByMonthLY[(m)-1]+(d)))
/*
 *	routines for accessing board dependant time
*/
int	tlGetSecs(void);
int	tlGetDay(void);
int	tlGetYear(void);
void	tlGetDateTime(int* psecMid,int* pdayNum,int* pyear);
STATUS  tlWait1SecTick(int *psecMid);
#endif  /* timeLibh */
