/*
 *	common sun/vw include file for timing (rtg/sps) code.
*/
#ifndef INCtmingLibh
#define INCtmingLibh
/*
 *	include file for tmingLib.c . this file contains routines that
 *	are callable from the sun and vxWorks. mainly for parsing.
 *	28feb94 - Started
*/

/*	defines	 	*/

#define  PARSE_PRE_TMING   "tming_"
/*	these are weird to match values that sps wants...talk to bill!*/
#define  TMING_TENSEC_TICK   1
#define  TMING_EXT_TICK      2
#define  TMING_ONESEC_TICK   3

/*	indices for tmingKeys table	*/

#define	TMING_IND_IPP  	   	0
#define	TMING_IND_GW	   	1
#define	TMING_IND_GD	   	2
#define	TMING_IND_CALW		3	
#define	TMING_IND_CALD          4
#define TMING_IND_NUMGW		5
#define TMING_IND_STARTTICK     6
#define TMING_IND_TICK          7
#define TMING_IND_FIXEDCLK      8
#define TMING_IND_BLANKING      9
#define TMING_IND_USESP0       10
/*
 *	typedefs
*/
typedef	struct	{
	double	ipp;		/* ipp in usecs. .1 usec res.(both)*/
	double	 gd;		/* gatedelay in usecs. .1 usec res.(both)*/
	double	 gw;		/* gatewidth in usecs. .1 usec res.(both)*/
	double	 cald;		/* caldelay in usecs. .1 usec res.(rtg)*/
	double	 calw;		/* calwidth in usecs. .1 usec res.(rtg)*/
	int	numGw;		/* number of gateWidth. (sps)*/
	int	startTick;	/* start on tick true/false (both)*/
	int	tick;		/* 1=1sec,2=10sec,3=ext tick(both)*/
	int	fixedClk;	/* use fixed clock true/false(both)*/
	int	blanking;	/* use cal blanking true/false (rtg)*/
	int	useSP0;		/* use sampling pulse 0 true/false (sps)*/
	} TMING_INFO;
/*
 *	function prototypes
*/
#ifdef VXWORKS
#include	<aoParse.h>
void tmingParse(char* pbuf,KEY_DEF *ptmingKeys,TMING_INFO* ptmI,int* pbadData);
#endif

#endif  /* riProgComh*/
