/*
 *	Common include file for tpProg.c it is include in vxWorks and
 *	sun code. tpProg.h has this and the vxworks code
*/
#ifndef INCtpProgLibh
#define INCtpProgLibh
/*
 *	constants for tape program
*/
/*	max tapes if striping */
#define	TPMAXTAPES	7	
#define TPNUM_MIN        0
#define TPNUM_MAX        7

/*
 *      indices for keywords in the key table if you modify the key table
 *      in swProgKeys.h then update these pointers.
*/
#define  TP_IND_NUMTAPES    0
#define  TP_IND_STRIPE      1
#define  TP_IND_TAPELIST    2
#define  TP_IND_CURTAPE     3

/*	typedefs	*/

typedef  struct {
	int	fileCnt;	/* current file we're on.cnt from 0 */
	int	blkCnt;		/* current record in file. cnt from */
	int	blksLeftTape;	/* number 1k blocks till leot*/
	int	numTapes;	/* in use*/
	int	curTape;	/* tape number*/
	int	tapeList[TPMAXTAPES];/*list of tapes in use*/
	int	stripeOn;	/* true/false*/
	int	bufsPerStripe;	/* if striping on*/
	int	bufsThisStripe; /* if striping on*/
	int	lastRecLen;	/* record length last record written*/
	} TP_STAT;
/*
 * 	message formats:
 *	 cmd         arg1		arg2 		arg3  
 *	CMDGLSETUP   tapenum 		use sync...
 *	CMDGLEXIT    none
 *	TPOUTREC     bytecnt         nodeoffset	  pbufnodedata   
 *      TPWEOF      numeofs
*/
/*
 *	function prototypes
*/
#endif  /* tpProgLibh */
