#ifndef INCtt560h
#define INCtt560h

/* tt560.h	- include file for true time 560 irig board */
/*
modification history:
28sep97, changed status_ok to be 0x2, bit 2 on is needed since that implies
		 phase locked. i had 0x2 as phase lock error...
*/

#define TT560DEVNAME	"/tt560"
/*
 * ioctl codes 
*/
#define TT560IOCDEBUG              0xa
#define TT560IOCWAITTIC		   0x20
#define TT560IOCRDTIME 	     	   0x21


#define TT560_STATUS_INP_REF_ERR     0x01
#define TT560_STATUS_INP_PHLOCK_ERR      0x02

/* 	typedefs	*/

typedef	struct {
	int	status;	        /* 0==ok, 1input ref err,2- not phase locked*/
	int	usecs;		/* this second*/
	int	secMidNite;	/* seconds from midnite*/
	int	dayNumber;	/* from start of year*/
	int	year;		/* 4 digits*/
	} TT560_TIME;

/* 	prototypes for tt560 lib	*/

int tt560Open(void);
/* this is in tt560Drv...*/
STATUS tt560TickTime(int  nextTick,TT560_TIME *ptime);

#endif
