#ifndef INCtttMsgh
#define INCtttMsgh
/*
* include file for common message info sent from pntProg to ttProg and tieProg.
*history..
*xx.x,04may96,pjp  copied from ttMsg.h
*xx.x,05aug97,pjp  PNT_TIE_POSREQ added feedback expected.;
*xx.x,14aug97,pjp001 PNT_TT_POSREQ  removed ter coordinates. affects:
*				   pntXform, ttTst,ttProg.c,aoMsgLib.c
*/
/*
 *	common turret/tertiary defines
 * bits to specify command for tur,ter1, etc...
*/

/*	when determing which device to use, here are the bits 	
	Note the TERX values are not used*/

#define	PNT_TTT_DEVBIT_TUR 			 1 
#define	PNT_TTT_DEVBIT_TER1			 2
#define	PNT_TTT_DEVBIT_TER2			 4
#define	PNT_TTT_DEVBIT_TER3			 8

#define	PNT_TTT_DEVBIT_TIE1			 1
#define	PNT_TTT_DEVBIT_TIE2			 2
#define	PNT_TTT_DEVBIT_TIE3			 4

/* specify location . tie,tur,ter... in device word pnt_cmd to pntMProg.c*/

#define PNT_TTT_LOC_MASK			0x70
#define PNT_TTT_LOC_TUR  		    0x10
#define PNT_TTT_LOC_TER  		    0x20
#define PNT_TTT_LOC_TIE  		    0x40

/* when returning data from multiple devices here are the 
   indices for the returned data. 
   note the TERX values are not used...*/

#define	PNT_TTT_DATAIND_TUR 		 0
#define	PNT_TTT_DATAIND_TER1 	     1
#define	PNT_TTT_DATAIND_TER2 	     2
#define	PNT_TTT_DATAIND_TER3 	     3

#define	PNT_TTT_DATAIND_TIE1 	     0
#define	PNT_TTT_DATAIND_TIE2 	     1
#define	PNT_TTT_DATAIND_TIE3 	     2
/*
 *	generic modes
*/
#define PNT_TTT_MODE_STOP	  1
#define PNT_TTT_MODE_PT       2
#define PNT_TTT_MODE_SLEW     3
/*
 * turret specific modes
*/
#define PNT_TUR_MODE_AUTOSCAN 4
/*
 *	tiedown  specific modes
*/
#define PNT_TIE_MODE_MAINTENANCE 4 
#define PNT_TIE_MODE_EXIT_MAINTENANCE 5
/*
 *	tertiary specific modes set in terProgState.h
*/

#define PNT_TTT_MODE_LAST        5 
/*
 *  monitor requests from pnt program
*/
#define	PNT_TTT_MONREQ_POS		 1
/*
 *	tiedown  defines
*/
#define PNT_TIE_FEEDBACK_LDCELLAVG 	0
#define PNT_TIE_FEEDBACK_LDCELL1	1
#define PNT_TIE_FEEDBACK_LDCELL2	2
#define PNT_TIE_FEEDBACK_ENCODER   	3

/*	parameter numbers for turret/ter and  tiedowns */
 	/* turret only */

#define PNT_TTT_PNUM_SBAND_TXMINPOS 0
#define PNT_TTT_PNUM_SBAND_TXMAXPOS 1
#define PNT_TTT_PNUM_430WG_TXMINPOS 2
#define PNT_TTT_PNUM_430WG_TXMAXPOS 3
#define PNT_TTT_PNUM_INDEX1		   4
#define PNT_TTT_PNUM_INDEX2		   5
#define PNT_TTT_PNUM_INDEX3		   6
#define PNT_TTT_PNUM_INDEX4		   7
#define PNT_TTT_PNUM_INDEX5		   8
#define PNT_TTT_PNUM_INDEX6		   0
#define PNT_TTT_PNUM_INDEX7		  10
#define PNT_TTT_PNUM_INDEX8		  11
#define PNT_TTT_PNUM_INDEX9		  12
#define PNT_TTT_PNUM_INDEXERR_MAX  13

	/* turret, tiedown, tertiary */

#define PNT_TTT_PNUM_BRAKE_MINVEL  14
#define PNT_TTT_PNUM_MAXVEL        15
#define PNT_TTT_PNUM_ALARM_DUR     16 
#define PNT_TTT_PNUM_MAXVEL_DIF    17
#define PNT_TTT_PNUM_MAXVEL_DIF_M1M2 18
#define PNT_TTT_PNUM_MAXACC		  19
#define PNT_TTT_PNUM_MAXPOS		  20
#define PNT_TTT_PNUM_MINPOS		  21
#define PNT_TTT_PNUM_FF_KA		  22
#define PNT_TTT_PNUM_FF_KI		  23
#define PNT_TTT_PNUM_FF_KP		  24
#define PNT_TTT_PNUM_FF_KD		  25
#define PNT_TTT_PNUM_FF_KF		  26
#define PNT_TTT_PNUM_L_KA		  27
#define PNT_TTT_PNUM_L_KI		  28
#define PNT_TTT_PNUM_L_KP		  29
#define PNT_TTT_PNUM_L_KD		  30
#define PNT_TTT_PNUM_L_KF		  31
#define PNT_TTT_PNUM_RATE_FACTOR   32
#define PNT_TTT_PNUM_MAXPOS_STEP_C 33
#define PNT_TTT_PNUM_0_VEL_OFFSET  34
#define PNT_TTT_PNUM_SCAN_VEL      35
#define PNT_TTT_PNUM_NET_ADR       36
#define PNT_TTT_PNUM_SW_VERSION    37
#define PNT_TTT_PNUM_RESET_PARAMS  38
#define PNT_TTT_PNUM_LAST 	       38
#if FALSE
#define PNT_TTT_PNUM_MAX_TENSION   38
#define PNT_TTT_PNUM_MIN_TENSION   39
#define PNT_TTT_PNUM_ENC_OFFSET    41
#endif
/*
 *	status bits from device
*/
#define PNT_TTT_DEVST_SAFETY_OPEN	  0x0001
#define PNT_TTT_DEVST_AXIS_FLT   	  0x0002
#define PNT_TTT_DEVST_DRV1_FLT   	  0x0004
#define PNT_TTT_DEVST_DRV2_FLT   	  0x0008

#define PNT_TTT_DEVST_WARNING    	  0x0010
#define PNT_TTT_DEVST_TRK_FLT    	  0x0020

#define PNT_TTT_DEVST_PWR_ON       	  0x0100           	  
#define PNT_TTT_DEVST_DRV_ENA    	  0x0200
#define PNT_TTT_DEVST_REM_CTRL   	  0x0400
#define PNT_TTT_DEVST_BRAKES_REL 	  0x0800
#define PNT_TTT_DEVST_REBOOTED   	  0x4000
/*
 * general status word for ttProg/tieProg  all drives
*/
#define PNT_TTT_PROGST_RUNNING		    0x00000001
#define PNT_TTT_PROGST_SYNCING_MST1     0x00000002
#define PNT_TTT_PROGST_SYNCING_MST2     0x00000004
#define PNT_TTT_PROGST_PT_SKIP_LAST     0x00000010
#define PNT_TTT_PROGST_PT_FUTURE_TIME   0x00000020
#define PNT_TTT_PROGST_PROC_TICK        0x00000040
/*
 * some bit for the fault status
*/
#define PNT_TTT_FLTST_SAFOPN            0x00000001
#define PNT_TTT_FLTST_CMDSPDERR         0x00000004 
#define PNT_TTT_FLTST_OVRSPD            0x00000008
#define PNT_TTT_FLTST_DRV1FAIL          0x00000010
#define PNT_TTT_FLTST_PWRSUPFAIL        0x00000040
#define PNT_TTT_FLTST_BRKFAIL           0x00000100
/*
 * some bit for the master drive status
*/
#define PNT_TTT_MDRVST_DRVENABLE         0x00000001
#define PNT_TTT_MDRVST_FLTCNTOPEN        0x00000004
#define PNT_TTT_MDRVST_OUTPUTFLT         0x00000008
#define PNT_TTT_MDRVST_DRVOTEMP          0x00000010 
#define PNT_TTT_MDRVST_MOTOTEMP          0x00000020
#define PNT_TTT_MDRVST_FOLDBACK          0x00000040

/*
 * typedefs
*/
typedef struct {
		int    num;		/* which parameter it is*/
		union {
			float   deg;
			float   secs; 
			float   degPersec; 
			float   degPersec2; 
		} u;
	} PNT_TTT_PARAM;

/***************************************************************************
 *      message structure passed between pointing and turret/tertiary
 *	program ..ttProg
 *	position request...
*/
/*
 *      structure for turret position velocity
*/
typedef struct {
        float   pos;
        float   vel;
        } PNT_TUR_PV;
/*
 *      structure for tiedowns position/velocity
*/
typedef struct {
        float   pos[3];   /* position coord 1,2,3*/
        float   vel[3];   /* vel coord 1,2,3*/
        } PNT_TIE_PV;
/*
 *      the msg request.. assume timeStamp for 1st position. 2nd position
 *      is 1 second in the future.
*/
typedef struct {
             int       timeStamp;      /* 1st pos/vel seconds from midnite*/
	      	  PNT_TUR_PV    tur1;           /* first coordinate*/
              PNT_TUR_PV    tur2; 
	} PNT_TT_POSREQ;
/*
 *      the msg request.. assume timeStamp for 1st position. 2nd position
 *      is 1 second in the future.
*/
typedef struct {
             int       timeStamp;      /* 1st pos/vel seconds from midnite*/
			 int	   fdBack;		   /* for these points. must match current fdback*/
	      	  PNT_TIE_PV    pnt1;      /* first coordinate*/
              PNT_TIE_PV    pnt2;	   /* 2nd point end of interval*/
	} PNT_TIE_POSREQ;
/*
 *      pnt Prog queries position/state. value returned are at tick
*/
typedef struct {
	int       timeMs;      /* ms from midnite from tur micro*/
	int		  devMask;	   /* b0-tur,b1-ter1,b2-ter2,b3-ter3*/
	float     pos[4];	      /* in device req units*/ 
	int		  devStat[4];
	} PNT_TT_MONPOS;
/*
 *      pnt Prog queries position/state. value returned are at tick
*/
typedef struct {
	int       timeMs;      /* ms from midnite from tur micro*/
	int		  devMask;	   /* td in use 1-td12,2-td4,4-td8*/
	int		  devStat[3];
	float     pos[3];	   /* encoder pos inches*/ 
	float     kips[6];     /*kips 6 load cells. td12 1,2 td4 1,2 td8 1,2*/ 
	} PNT_TIE_MON;

/*---------------------------------------------------------------------------
 *  tertiary messages pnt -> terProg
*/
#if FALSE
typedef struct {
	float	c[5];		/* hold up to 5 numbers for 1 position/velocity*/
	} PNT_TER_COORD;
#endif

typedef struct {
        float         pos[5];   /* position coord */
        float         vel[5];   /* velocity coord*/
        } PNT_TER_PV;
/*
 *      the msg request.. assume timeStamp for 1st position. 2nd position
 *      is 1 second in the future.
*/
typedef struct {
      int       timeStamp;      /* 1st pos/vel seconds from midnite*/
      int       coordSys;       /* for coord below*/
      PNT_TER_PV    ter1;
      PNT_TER_PV    ter2;
    } PNT_TER_POSREQ;

typedef struct {
	int       timeMs;      /* ms from midnite from terProg micro*/
	int		  mainSt;	   /* main status*/
	int		  genSt;	   /* general status*/
	int		 limSt;	   /* limit   status*/
	float     encPos[5];	   /* encoder pos inches*/ 
	float     potPos[5];	   /* pot  pos inches*/ 
	} PNT_TER_MON;

#endif
