/* Standard Includes */
#include <stdlib.h>

/* Local Includes */
#include "chealpix.h"
#include "fitsio.h"

/* ====================================================== */
long get_fits_size(char *filename, long *nside, char *ordering ){

  fitsfile *fptr;       /* pointer to the FITS file, defined in fitsio.h */
  int status, hdutype;
  char comment[80];
  long obs_npix;

  status = 0;

  if ( fits_open_file(&fptr, filename, READONLY, &status) ) 
    printerror( status );

  /* ---------------------------------------- */
  if ( fits_movabs_hdu(fptr, 2, &hdutype, &status) ) /* move to 2nd HDU  */
    printerror( status );

  if (fits_read_key(fptr, TSTRING, "ORDERING", ordering, comment, &status))
    printerror(status);

  if (fits_read_key(fptr, TLONG,"NSIDE"   , nside, comment, &status))  
    printerror(status); 

  if (fits_read_key(fptr, TLONG,"OBS_NPIX", &obs_npix, comment, &status)) {
    obs_npix = 12 * (*nside) * (*nside) ;
    status = 0;
  }


  if ( fits_close_file(fptr, &status) )
    printerror( status );
  
  return obs_npix;
}
