pro sixpack2vector, sixpack, vector
;+
; sixpack2vector, sixpack, vector
;
; turns a sixpack raster into a data vector ordered by pixel number
;
;
; uses : pix2xy from CGIS
;
; written by EH, oct-2001
;-


np = n_elements(sixpack)
nxf = sqrt(np/6)             ; side of each face
resq = alog(nxf)/alog(2.)+1  ; resolution parameter

pixel = lindgen(np)
pix2xy, pixel, ix, iy, res = resq, /sixpack
vector = sixpack(ix,iy)



return
end
