function today_fits
;+
; today_fits
;
; result = today_fits()
; return the current date in the FITS Y2K compliant format
;  ccyy-mm-dd
;
; mainly copied from today() from IDL 5.2
;
; updated to work with IDL 5.5 (str_sep is discontinued)
;
;-

if n_elements(ascii_time) eq 0 then $
   ascii_time = systime(0)      ;Current time
a_time=strcompress(ascii_time)  ; compress all those spaces to 1
idl_version = float(!version.release)
if (idl_version le 5.4) then begin
    s = str_sep(a_time, ' ')    ;Separate fields
    t = str_sep(s[3], ':')      ;Time fields separated by colon
endif else begin
    s = strsplit(a_time, ' ',/extract)    ;Separate fields
    t = strsplit(s[3], ':',/extract)      ;Time fields separated by colon
endelse
m = where(strupcase(s[1]) eq $  ; = month  - 1
 ['JAN','FEB','MAR','APR', 'MAY', 'JUN', 'JUL', 'AUG','SEP','OCT','NOV','DEC'])

fdate = STRING([s[4],m[0]+1,s[2]],form='(i4.4,''-'',i2.2,''-'',i2.2)')


return,fdate
end

