function ring_num, nside, z
;+
; gives the ring number corresponding to z for the resolution nside
;
;-
twothird = 2.d0 /3.d0

;     ----- equatorial regime ---------
iring = NINT( nside*(2.d0-1.500d0*z))

;     ----- north cap ------
if (z gt twothird) then begin
    iring = NINT( nside* SQRT(3.d0*(1.d0-z)))
    if (iring eq 0) then iring = 1
endif

;     ----- south cap -----
if (z lt -twothird) then begin
    iring = NINT( nside* SQRT(3.d0*(1.d0+z)))
    if (iring eq 0) then iring = 1
    iring = 4*nside - iring
endif

return, iring
end
