pro identify_projection, projtype, projection=projection, mollweide=mollweide, gnomic=gnomic, cartesian=cartesian, orthographic=orthographic
;+
; identify_projection, projtype, projection=, mollweide=, $
;                                gnomic=, cartesian=, orthographic=
;
;
;
;  OUTPUT : projtype
;    1 : mollweide
;    2 : gnomic
;    3 : cartesian
;    4 : orthographic
;
;-
proj = ' '
if keyword_set(projection) then proj = strupcase(strmid(projection,0,4))
do_moll = (keyword_set(mollweide)    or proj eq 'MOLL')
do_gnom = (keyword_set(gnomic)       or proj eq 'GNOM')
do_cart = (keyword_set(cartesian)    or proj eq 'CART')
do_orth = (keyword_set(orthographic) or proj eq 'ORTH')

if ((do_moll+do_gnom+do_cart+do_orth) ne 1) then begin
    message,'should be either Mollweide or Gnomic or Cartesian'
endif

molltype = 1
gnomtype = 2
carttype = 3
orthtype = 4

projtype = do_moll * molltype    $
         + do_gnom * gnomtype    $
         + do_cart * carttype    $
         + do_orth * orthtype

return
end
