#ifdef _WIN32
#include <windows.h>
#endif

#include <signal.h>
#include <stdio.h>

#include "sigill.h"

#ifdef _WIN32
/* WIN32 doesn't catch SIGILL by default so we trick it into doing so */

LONG SIGILLExceptionFilter(LPEXCEPTION_POINTERS except) {
  void (*oldsig)(int);
/* If we don't have an illegal instruction then execute the normal handler */
  switch (except->ExceptionRecord->ExceptionCode) {
    case EXCEPTION_ILLEGAL_INSTRUCTION:
    case EXCEPTION_PRIV_INSTRUCTION:
                                        oldsig=signal(SIGILL,SIG_DFL);
					if (oldsig==SIG_DFL) {
					  return EXCEPTION_CONTINUE_SEARCH;
                                        } if (oldsig==SIG_IGN) {
					  signal(SIGILL,SIG_IGN);
					  return EXCEPTION_CONTINUE_EXECUTION;
                                        } else {
					  oldsig(SIGILL);
                                          return EXCEPTION_CONTINUE_EXECUTION;
                                        }
					break;
    default:			        return EXCEPTION_CONTINUE_SEARCH;
  }
  /* never get here */
  return EXCEPTION_CONTINUE_SEARCH;
}
#endif

