#include <cstdio>
#include "healpix_base.h"
#include "setilib.h"


int main (int argc, char ** argv) {

    int i, nside, num_sky_pixels, num_freq_pixels, freq_res;
    double bandwidth;

    for (i=1; i<argc; i++) {
        if (!strcmp(argv[i], "-nside")) {
            nside = atoi(argv[++i]);
        } else if (!strcmp(argv[i], "-mhz")) {
            bandwidth = atof(argv[++i]) * 1e6;
        } else if (!strcmp(argv[i], "-fres")) {
            freq_res = atoi(argv[++i]);
        } else {
            fprintf(stderr, "bad cmdline arg: %s\n", argv[i]);
            exit(1);
        }
    }

    num_freq_pixels = bandwidth/freq_res;    
    num_sky_pixels = nside2npix(nside);
    printf("sky : %d (30%% would be %d) freq : %d\n", 
           num_sky_pixels, (int)(num_sky_pixels * .3), num_freq_pixels);
}
