//________________________________________________________ 
// Source Code Name  : s4cfg.cc
// Programmer        : Donnelly/Cobb et al
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
//________________________________________________________ 

// TIDs Telescope ID numbers listed, each number is one byte

#define AO_430       0x00
#define AO_1420      0x01
#define AOGREG_1420  0x02
#define UNKNOWN_TEL  0xff

// TIDs as given on various command lines

#define AO430      "ao430"
#define AO1420     "ao1420"
#define AOGREG1420 "aogreg1420"

// telescope definitions for database  (this is archaic)

#define NRAO    0x0001       /* bit 1 */
#define NRAO140 0x0002       /* bit 2 */
#define ARECIBO 0x0004       /* bit 3 */

typedef struct {
        long    ReceiverID;		
        char    ReceiverName[256];
        double  Latitude;		// degrees
        double  WLongitude;		// degrees
        double  Longitude;		// degrees
        double  Elevation;		// meters
        double  Diameter;		// meters
        double  BeamWidth;		// degrees
        double  CenterFreq;		// degrees
        double  AzOrientation;		// degrees
	double  ZenCorrCoeff[13];	// AO zenith angle corrections, arcmin.
	double  AzCorrCoeff[13];	// AO azimuth corrections, arcmin.
} ReceiverConfig_t;

void s4cfg_GetReceiverConfig(int ReceiverID, ReceiverConfig_t * ReceiverConfig);
