//__________________________________________________________________________
// Source Code Name  : s4coord.h
// Programmer        : Donnelly/Cobb et al
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
// Purpose           : header file for s3coord.cc
//__________________________________________________________________________
    



void co_EqToHorz(double ra, 
                 double dec, 
                 double lst, 
                 double *za, 
                 double *azm,
                 double CosLat, 
                 double SinLat);

double co_SkyAngle(double first_ra,
                 double first_dec,
                 double second_ra,
                 double second_dec);

void co_GetBeamRes(double * db_DecRes,
                   double * db_RaRes,
                   long     ld_Freq,
                   unsigned us_TelDiameter,
                   double   db_NumBeams);

void co_ZenAzToRaDec(double zenith_ang,
                     double azimuth,
                     double lsthour,
                     double *ra,
                     double *dec);

void co_ZenAzCorrectionPreliminary(double *zen, 
                                   double *az);

void co_ZenAzCorrection(unsigned char TiD,
                        double *zen,
                        double *az);

double co_GetSlewRate(double Ra1, double Dec1, double Jd1,
                      double Ra2, double Dec2, double Jd2); 

double wrap(double Val, long LowBound, long HighBound, BOOLEAN LowInclusive);

void            co_EqToXyz(double ra, double dec, double * xyz);

void            co_XyzToEq(double xyz[], double *ra, double *dec);

void            co_Precess(double e1, double * pos1, double e2, double * pos2);
