/* ------------------------------------------------------------------
 Author : Jeff Cobb
 source name: s4doppler.h
 Contains prototypes for functions in s4doppler.cc

 Note: Epoch here is the epoch of the coordinates passed to the
       routines.
---------------------------------------------------------------------
*/

double 		s4dop_FreqOffsetAtBaryCenter(double DetectionFreq, double JulDay, double Ra, double Dec,
                                             double Epoch, long ReceiverID);
double          s4dop_FreqAtBaryCenter(double DetectionFreq, double JulDay, double Ra, double Dec,
                                       double Epoch, long ReceiverID);
double          s4dop_jdtoje(double jd);
void            s4dop_earthv(double jd, double *  v);
void            s4dop_earthxyz(double dj, double * xyz);
void            s4dop_baryv(double jd, double * vb);
void            s4dop_topov(double lst, double nlat, double elev, double * v);
double          s4dop_lmst(double j, double ut, double wlong);
double          s4dop_gmst(double j);
// these two now in s4coord:
// void            s4dop_eqxyz(double ra, double dec, double * xyz);
// void            s4dop_precess(double e1, double * pos1, double e2, double * pos2);
// this one now in s4time:
// double          s4dop_jetojd(double je);
double          s4dop_modreal(double x, double m);
double          s4dop_dot(double * x1, double * x2);
