//______________________________________________________________
// Source Code Name  : s4io.cc
// Programmer        : Donnelly/Cobb et al
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
// Date Opened       : opened 8/1994
// Purpose           : header file for s4io.cc
//______________________________________________________________

#include "SIREN.h"
#include <sys/types.h>
#include <unistd.h>

long          io_GetNextRecord(FILE *ThisFile, void *ThisEvent,unsigned char RecordType);
long          io_GetNextMinEvent(FILE *ThisFile,MinEventRec *ThisMinEvent);
void          io_WriteStdEvent(FILE *ThisFile,StdEventRec *ThisEvent);
void          io_WriteS3StdEvent(FILE *ThisFile,s3_StdEventRec *ThisEvent);
void          io_WriteCandidate(FILE *ThisFile, CandidateRec * Candidate);
void          io_WriteBeamfitRec(FILE *ThisFile, BeamfitRec * BeamfitResult);
void          io_WriteSahGaussianRec(FILE *ThisFile,  sah_Gaussian_t * ThisGaussianRec);
long          io_WriteComment(FILE *ThisFile, char * ThisComment);
long          io_WriteRecFromFile(FILE *OutFile, FILE *InFile, long lLineNo, unsigned char cRecordType);
unsigned char io_PeekNextRecord(FILE *ThisFile);
long          io_SkipNextRecord(FILE *ThisFile);
long          io_s3GetNextEvent(FILE *ThisFile, s3_StdEventRec *ThisEvent);
long          io_CountRecords(FILE * ThisFile, char RecordType);
long          io_GetLastRecord(FILE *ThisFile, void *ThisRecord,unsigned char RecordType);
off_t         io_GetFilePosition(FILE *ThisFile);
off_t         io_SetFilePosition(FILE *ThisFile, off_t FilePosition);
BOOLEAN io_GetEngMonRecord(FILE *ThisFile, EngMonRec *ThisRecord);
void io_WriteEngMonRecord(FILE *ThisFile, EngMonRec *ThisRecord);
long          io_GetFileSize(FILE *ThisFile);
