typedef struct {
  char            sDbaseName[11];    		// inserted at rcd creation

  unsigned long   ulFlags;           		// 32 bitwise flags

  // s4pcdbase fields
  unsigned short  usSigmaThreshold;
  unsigned short  usDupScopeStrings;
  unsigned long   ulNumSpectra;
  unsigned long   ulTotalHits;
  unsigned long   ulNoStringHits;
  unsigned long   ulErrSynth;
  unsigned long   ulErrVectWarn;
  unsigned long   ulErrOverRun;
  unsigned long   ulErrArithOvfl;
  unsigned long   ulErrBdNotReady;
  unsigned long   ulErrOther;
  unsigned long   ulSetiAtHomeBoardCount;
  unsigned char   ucBoardKiloCount[NUMBOARDS];
  double	  dbFirstLo;
  double	  dbSecondLo;
  double          dbMeanScopeStringInterval;  	// seconds
  double          dbMeanSlew;
  double          dbTrackingTime;         	// decimal hours
  double          dbStartRa;
  double          dbEndRa;
  double          dbStartDec;
  double          dbEndDec;
  double          dbStartTime;            	// julian day
  double          dbFileDuration;         	// decimal hours

  // s4dbascheck fields
  long            lDbaseErrors;		  	// total count
  unsigned short  lDbaseErrorStatus;
  unsigned long   ulDbaseErrorType;		// bit field
  double          dbDbaseBadLimit;              // percentage acceptable of bad lines

  // s4engmonrecreader fields
  long            lMinAcceptedADC;
  long            lMaxAcceptedADC;
  long            lMinADC;
  long            lMaxADC;
  long            lADC0BadCount;
  long            lADC1BadCount;
  long            lADC2BadCount;
  long            lADC3BadCount;
  long            lADC4BadCount;
  long            lDisabledCount;

  // Statistics fields before RFI rejection....
  long		  lMaxPowerHistogrammedBefore;
  long		  lNumEventsOverMaxPowerBefore;
  long		  lPoissonNumEventsBefore;	
  long		  lPoissonBinWidthBefore;	// in FFT bins
  long		  lPoissonNumBinsBefore;	// at above bin width
  long            lPoissonMaxEventsBefore;
  double          dbPoissonChiSqrBefore;
  // ....and after RFI rejection
  long		  lMaxPowerHistogrammedAfter;
  long		  lNumEventsOverMaxPowerAfter;
  long		  lPoissonNumEventsAfter;	
  long		  lPoissonBinWidthAfter;	
  long		  lPoissonNumBinsAfter;	
  long            lPoissonMaxEventsAfter;
  double          dbPoissonChiSqrAfter;
  
  // s4rfifilter fields
  unsigned long   ulRfiFilterEventsIn;
  unsigned long   ulRfiFilterEventsOut;
  unsigned long   ulRfiFilterExpectedOut; 
  unsigned long   ulGoodTime;            
  double          dbPassBand_FreqRes;       
  double          dbPassBand_NumBeams;      
  unsigned long	  ulPassBand_Limit;         
  unsigned long   ulPassBand_NumRej;        
  unsigned long   ulPassBand_NumNewRej;        
  double          dbPassBand_DeadFreqBand;  
  double          dbSpreadSpectrum_EntropyLimit;  
  unsigned long   ulSpreadSpectrum_EventLimit;    
  double          dbSpreadSpectrum_SigmaLimit;  
  unsigned long   ulSpreadSpectrum_NumRej;        
  unsigned long   ulSpreadSpectrum_NumNewRej;       
  unsigned long   ulSlowSlew_DeltaSecs;         
  unsigned long   ulSlowSlew_BaSecs;           
  double          dbSlowSlew_Limit;           
  unsigned long   ulSlowSlew_NumRej;             
  unsigned long   ulSlowSlew_NumNewRej;         
  unsigned long   ulSlowSlew_SpectraLost;      
  double          dbFastSlew_Dps;           
  unsigned long   ulFastSlew_NumRej;      
  unsigned long   ulFastSlew_NumNewRej;        
  unsigned long   ulFastSlew_SpectraLost;     

  // s4drfi fields

  unsigned long ulDrfiNumSectors;
  unsigned long ulDrfiRadiusInSeconds;
  unsigned long ulDrfiBeamsForBeamres;
  unsigned long ulDrfiTimeExpansionFactor;
  double        dbDrfiTimeResolution;
  unsigned long ulDrfiGapFactor;
  unsigned long ulDrfiRejectionThreshold;
  unsigned long ulDrfiNumEvents;
  double        dbDrfiSpectraDensity;
  double        dbDrfiTimeTicks;
  unsigned long ulDrfiNumSemicircles;
  double        dbDrfiRaRes;
  double        dbDrfiDecRes;
  unsigned long ulDrfiNumRfiEvents;
  unsigned long ulDrfiNumCleanEvents;

  // s4countbirdie fields
  // unsigned long   ulNumBirdies;
  // unsigned long   ulNumBirdiesExpected;
  // unsigned long   ulNumFalseBirdies;
  unsigned char ucBirdieSeenPercentages[48];  // 0 - 100 expected birdies seen 
                                              // 255 if the board is inactive
  unsigned long long ullMirrorSeen; // 64-bit map - probably not portable type

  // Multhit fields
  unsigned long   ulNumGroups;

  // Beamfit fields
  

  // program version numbers
  float           fPcdbaseVers,
                  fDbasCheckVers,
                  fEngmonrecreaderVers,
                  fPwrHstBeforeVers,
                  fPwrHstAfterVers,
		  fBinHstBeforeVers,
		  fBinHstAfterVers,
		  fPoissonBeforeVers,
		  fPoissonAfterVers,
                  fRfiFilterVers,
                  fS4drfiVers,
                  fCountBirdieVers,
                  fMulthitVers,
                  fBeamfitVers;
  


  unsigned char   ucTid;
  } OldDbaseSumRcd_t;
