#define	RFI_SLOWSLEW_RUN	0x00000001
#define	RFI_FASTSLEW_RUN	0x00000002
#define	RFI_PASSBAND_RUN	0x00000004
#define	RFI_SSPECTRUM_RUN	0x00000008
#define	RFI_RES1_RUN		0x00000010
#define	RFI_RES2_RUN		0x00000020
#define	RFI_RES3_RUN		0x00000040
#define	RFI_RES4_RUN		0x00000080
#define	MISC_RES1		0x00000100
#define	MISC_RES2		0x00000200
#define	MISC_RES3		0x00000400
#define	MISC_RES4		0x00000800
#define	MISC_RES5		0x00001000
#define	MISC_RES6		0x00002000
#define	MISC_RES7		0x00004000
#define	MISC_RES8		0x00008000
#define	MISC_RES9		0x00010000
#define	MISC_RES10		0x00020000
#define	MISC_RES11		0x00040000
#define	MISC_RES12		0x00080000
#define	MISC_RES13		0x00100000
#define	MISC_RES14		0x00200000
#define	MISC_RES15		0x00400000
#define	MISC_RES16		0x00800000
#define	MISC_RES17		0x01000000
#define	MISC_RES18		0x02000000
#define	MISC_RES19		0x04000000
#define	MISC_RES20		0x08000000
#define	MISC_RES21		0x10000000
#define	MISC_RES22		0x20000000
#define	MISC_RES23		0x40000000
#define	MISC_RES24		0x80000000

typedef struct {
  char            sDbaseName[11];    		// inserted at rcd creation

  unsigned long   ulFlags;           		// 32 bitwise flags

  // s4pcdbase fields
  unsigned short  usSigmaThreshold;
  unsigned short  usDupScopeStrings;
  unsigned long   ulNumSpectra;
  unsigned long   ulTotalHits;
  unsigned long   ulNoStringHits;
  unsigned long   ulErrSynth;
  unsigned long   ulErrVectWarn;
  unsigned long   ulErrOverRun;
  unsigned long   ulErrArithOvfl;
  unsigned long   ulErrBdNotReady;
  unsigned long   ulErrOther;
  unsigned long   ulSetiAtHomeBoardCount;
  unsigned char   ucBoardKiloCount[NUMBOARDS];
  double	  dbFirstLo;
  double	  dbSecondLo;
  double          dbMeanScopeStringInterval;  	// seconds
  double          dbMeanSlew;
  double          dbTrackingTime;         	// decimal hours
  double          dbStartRa;
  double          dbEndRa;
  double          dbStartDec;
  double          dbEndDec;
  double          dbStartTime;            	// julian day
  double          dbFileDuration;         	// decimal hours

  // s4dbascheck fields
  long            lDbaseErrors;		  	// total count
  unsigned short  lDbaseErrorStatus;
  unsigned long   ulDbaseErrorType;		// bit field
  double          dbDbaseBadLimit;              // percentage acceptable of bad lines

  // s4engmonrecreader fields
  long            lMinAcceptedADC;
  long            lMaxAcceptedADC;
  long            lMinADC;
  long            lMaxADC;
  long            lADC0BadCount;
  long            lADC1BadCount;
  long            lADC2BadCount;
  long            lADC3BadCount;
  long            lADC4BadCount;
  long            lDisabledCount;

  // Statistics fields before RFI rejection....
  long		  lMaxPowerHistogrammedBefore;
  long		  lNumEventsOverMaxPowerBefore;
  long		  lPoissonNumEventsBefore;	
  long		  lPoissonBinWidthBefore;	// in FFT bins
  long		  lPoissonNumBinsBefore;	// at above bin width
  long            lPoissonMaxEventsBefore;
  double          dbPoissonChiSqrBefore;
  // ....and after RFI rejection
  long		  lMaxPowerHistogrammedAfter;
  long		  lNumEventsOverMaxPowerAfter;
  long		  lPoissonNumEventsAfter;	
  long		  lPoissonBinWidthAfter;	
  long		  lPoissonNumBinsAfter;	
  long            lPoissonMaxEventsAfter;
  double          dbPoissonChiSqrAfter;
  
  // s4rfifilter fields
  unsigned long   ulRfiFilterEventsIn;
  unsigned long   ulRfiFilterEventsOut;
  unsigned long   ulRfiFilterExpectedOut; 
  unsigned long   ulGoodTime;            
  double          dbPassBand_FreqRes;       
  double          dbPassBand_NumBeams;      
  unsigned long	  ulPassBand_Limit;         
  unsigned long   ulPassBand_NumRej;        
  unsigned long   ulPassBand_NumNewRej;        
  double          dbPassBand_DeadFreqBand;  
  double          dbSpreadSpectrum_EntropyLimit;  
  unsigned long   ulSpreadSpectrum_EventLimit;    
  double          dbSpreadSpectrum_SigmaLimit;  
  unsigned long   ulSpreadSpectrum_NumRej;        
  unsigned long   ulSpreadSpectrum_NumNewRej;       
  unsigned long   ulSlowSlew_DeltaSecs;         
  unsigned long   ulSlowSlew_BaSecs;           
  double          dbSlowSlew_Limit;           
  unsigned long   ulSlowSlew_NumRej;             
  unsigned long   ulSlowSlew_NumNewRej;         
  unsigned long   ulSlowSlew_SpectraLost;      
  double          dbFastSlew_Dps;           
  unsigned long   ulFastSlew_NumRej;      
  unsigned long   ulFastSlew_NumNewRej;        
  unsigned long   ulFastSlew_SpectraLost;     

  // s4drfi fields

  unsigned long ulDrfiNumSectors;
  unsigned long ulDrfiRadiusInSeconds;
  unsigned long ulDrfiBeamsForBeamres;
  unsigned long ulDrfiTimeExpansionFactor;
  double        dbDrfiTimeResolution;
  unsigned long ulDrfiGapFactor;
  unsigned long ulDrfiRejectionThreshold;
  unsigned long ulDrfiNumEvents;
  double        dbDrfiSpectraDensity;
  double        dbDrfiTimeTicks;
  unsigned long ulDrfiNumSemicircles;
  double        dbDrfiRaRes;
  double        dbDrfiDecRes;
  unsigned long ulDrfiNumRfiEvents;
  unsigned long ulDrfiNumCleanEvents;

  // s4countbirdie fields
  // unsigned long   ulNumBirdies;
  // unsigned long   ulNumBirdiesExpected;
  // unsigned long   ulNumFalseBirdies;
  unsigned char ucBirdieSeenPercentages[48];  // 0 - 100 expected birdies seen 
                                              // 255 if the board is inactive
  unsigned long long ullMirrorSeen; // 64-bit map - probably not portable type

  // Multhit fields
  unsigned long   ulNumGroups;

  // Beamfit fields
  
  // AcquireRateCheck fields
  double     dbARCLowThreshold;
  double     dbARCHighThreshold;
  BOOLEAN    bAllBoardsPassed;
  BOOLEAN    bBoard19Passed;

  // program version numbers
  float           fPcdbaseVers,
                  fDbasCheckVers,
                  fEngmonrecreaderVers,
                  fPwrHstBeforeVers,
                  fPwrHstAfterVers,
		  fBinHstBeforeVers,
		  fBinHstAfterVers,
		  fPoissonBeforeVers,
		  fPoissonAfterVers,
                  fRfiFilterVers,
                  fS4drfiVers,
                  fCountBirdieVers,
                  fMulthitVers,
                  fBeamfitVers,
                  fAcquireRateCheckVers;


  unsigned char   ucTid;
  } DbaseSumRcd_t;

 typedef struct
   {
   unsigned long Key;
   unsigned long Index;
   } SumIndexRcd;


int               sum_GetDataBase           (int Mode);
void              sum_ReleaseDataBase       (int SumIndexFile);
unsigned long     sum_GetRcd                (char * sDbaseFileName,
                                             DbaseSumRcd_t * ThisSumRcd,
                                             int SumIndexFile,
                                             int Mode);
void              sum_PutRcd                (long SumIndex,
                                             DbaseSumRcd_t * ThisSumRcd,
                                             int SumIndexFile);
long              sum_GetIndex              (unsigned long Key, 
                                             int SumIndexFile);
void              sum_AddIndex              (long SumIndex,
                                             unsigned long Key,
                                             int SumIndexFile);
long              sum_GetNumRcds            (int SumIndexFile);
long              sum_GetNumInDateRange     (char * Date1, 
                                             char * Date2, 
                                             int SumIndexFile);
BOOLEAN           sum_GetNextRcd            (char * sDbaseFileName,
                                             DbaseSumRcd_t * ThisSumRcd,
                                             BOOLEAN LastCall,
                                             int SumIndexFile,
                                             int Mode);
void              sum_ReadIndices           (SumIndexRcd * SumIndex,
                                             long NumSumRcds,
                                             int SumIndexFile);
void              sum_WriteIndices          (SumIndexRcd * SumIndices,
                                             long NumSumRcds,
                                             int SumIndexFile);
void              sum_ReadRcd               (int SumFile,
                                             DbaseSumRcd_t * ThisSumRcd, 
                                             long Index);
void              sum_WriteRcd              (int SumFile, 
                                             DbaseSumRcd_t * ThisSumRcd, 
                                             long Index); 
//int               sum_IndexCmp              (SumIndexRcd * Index1, 
//                                             SumIndexRcd * Index2);
int               sum_IndexCmp              (const void * Index1, 
                                             const void * Index2);

extern char * sSummaryFileName;
extern char * sSummaryIndexFileName;
