//____________________________________________________________________
// Source Code Name    : s4tid.h
// Programmer          : Jeff Cobb
//                     : Project SERENDIP, University of California, Berkeley CA
// Compiler            : GNU gcc
// Date Opened         : 2/99
// Purpose             : telescope IDs and routines to deal with them
// History             : 
//____________________________________________________________________


// TIDs Telescope ID numbers listed, each number is one byte

#define AO_430       0x00
#define AO_1420      0x01
#define AOGREG_1420  0x02
#define UNKNOWN_TEL  0xff     

// TIDs as given on various command lines

#define AO430      "ao430"
#define AO1420     "ao1420"
#define AOGREG1420 "aogreg1420"

// telescope definitions for database  (this is archaic) 

#define NRAO    0x0001       /* bit 1 */
#define NRAO140 0x0002       /* bit 2 */
#define ARECIBO 0x0004       /* bit 3 */

unsigned char tel_GetTid(char * sReceiverID);
long tel_GetTelTab(unsigned char TiD);
