//____________________________________________________________ 
// Source Code Name  : s4time.cc
// Programmer        : Donnelly/Cobb et al
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
// Date Opened       : 10/94
// Purpose           : header file for s4time.cc
//____________________________________________________________

// replacing the old SunOS function....
#define dysize(x) (x%4==0)&&((x%100!=0)||(x%400==0)) ? 366 : 365

struct DateStruct
       { 
       long month;
       long day;
       long year;
       };

// stMonths[] is defined with data in s4time.cc
#ifndef S4TIME
extern char * stMonths[]; 
#endif

void tm_HmsToDec(char *time_str,double *dec_time);
void tm_s3HmsToDec(char *time_str,double *dec_time);
long tm_MonToI(char *fdate);
void tm_DayToMon(long day, long year, struct DateStruct *sdate);
long tm_DayMonToYrDay(long day, long mon, long year);
void tm_AstToUt(long *year, long *day, long *hour);
void tm_AstToUt(long *year, long *day, double *hour);
double tm_DbasToLst(char *aststr, char *dbasdate);
double tm_UtToLst(double ddtime, double longitude,
                  long mon, long day, long year);
double tm_ToJul(long month, long day, long year, double hour);
void tm_FromJul(double jday, long *month, long *day, long *year, double *hour);
void tm_DateToI(char *date, long *day, long *month, long *year);
long tm_CompareDate( long *date1mon, long *date1day, long *date1year,
                     long *date2mon, long *date2day, long *date2year);
long tm_CentYear(long TwoDigitYear);
long tm_TwoDigitYear(long CentYear);
void tm_Converts4Time(long u32Time, long *DOY, long *Hour, long *Min, long *Sec,
                      long *Ten);
double tm_JulianEpochToJulianDate(double je);
double tm_JulianDateToJulianEpoch(double jd);

