// This program tests the function cfg_GetTelConfig.

#include <stdio.h>
#include <string.h>
#include "s4cfg.h"

void  ExitError(char errorMessage[], char progname[]);


int  main(int argc, char *argv[])
  {
  tel_struct     telStruct;
  unsigned short TID;

  if (argc != 2)
    ExitError("", argv[0]);

  /* get telescope ID */
  if (sscanf(argv[1],"%hx", &TID) != 1)
    ExitError("Telescope ID required (2 hex digits)", argv[0]);

  TID &= 0x00ff;

  /* display program parameters */
  fprintf(stdout, "\nInput parameters:\n");
  fprintf(stdout, "  Telescope ID:  %02x\n", TID);

  cfg_GetTelConfig((unsigned char) TID, &telStruct);

  printf("%.9f %.9f %.9f %.4f %ld %s\n",
        telStruct.dbLatitude, telStruct.dbLongitude, telStruct.dbEwLongitude, 
        telStruct.dbElevation, telStruct.lDiameter, telStruct.stTidName);
  }

void  ExitError(char errorMessage[], char progname[])
  {
  char  *usage = " telescope_id";

  if (strcmp(errorMessage, ""))
    fprintf(stderr, "\n%s\n", errorMessage);
  fprintf(stderr, "\nUsage:\n%s%s\n\n", progname, usage);
  exit(1);
  }
