//______________________________________________________________________
// Source Code Name  : s4conv.cc
// Programmer        : Donnelly/Cobb et al
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
// Date Opened       : 1/95
// This file includes the set of functions necessary used to cross
// populate the various SERENDIP event data structures.
//______________________________________________________________________
// modification history:
//______________________________________________________________________

#include <stdio.h>
#include "SIREN.h"
#include "s4power.h"

//____________________________________________________________________
// cv_StdRecToMinRec()
//____________________________________________________________________
 
void cv_StdRecToMinRec(void * StdRecord, MinEventRec * MinEvent , char RecordType)
  {
  
  if (RecordType == STDEVENT_REC)
    {
    StdEventRec * StdEvent;

    StdEvent = (StdEventRec *)StdRecord;

    MinEvent->dbFrequency  = StdEvent->dbFrequency;
    MinEvent->dbRa         = StdEvent->dbRa;
    MinEvent->dbDec        = StdEvent->dbDec;
    MinEvent->dbPower      = pw_PwrCalc(StdRecord, RecordType);
    MinEvent->dbJulDate    = StdEvent->dbJulDate;
    }

  else if (RecordType == S3_STDEVENT_REC)
    {
    s3_StdEventRec * StdEvent;

    StdEvent = (s3_StdEventRec *)StdRecord;

    MinEvent->dbFrequency  = StdEvent->dbFreq;
    MinEvent->dbRa         = StdEvent->dbRa;
    MinEvent->dbDec        = StdEvent->dbDec;
    MinEvent->dbPower      = pw_PwrCalc(StdRecord, RecordType);
    MinEvent->dbJulDate    = StdEvent->dbJulDate;
    }
  }
