// NOTE: any changes here must be kept in sync with s4error.h

#define S4ERROR

#include "SIREN.h"
#include "s4error.h"

DbaseError_t DbaseError[NUM_ERROR_TYPES]= 
                             {{"Month",            0, 0x00000001, DBASE_FATAL},
                              {"Day",              0, 0x00000002, DBASE_FATAL},
                              {"Year",             0, 0x00000004, DBASE_FATAL},
                              {"Hour",             0, 0x00000008, DBASE_FATAL},
                              {"TimeOrder",        0, 0x00000010, DBASE_FATAL},
                              {"RA",               0, 0x00000020, DBASE_FATAL},
                              {"Dec",              0, 0x00000040, DBASE_FATAL},
                              {"FirstLo",          0, 0x00000080, DBASE_FATAL},
                              {"SecondLo",         0, 0x00000100, DBASE_FATAL},
                              {"Bin",              0, 0x00000200, DBASE_NONFATAL},
                              {"Bid",              0, 0x00000400, DBASE_FATAL},
                              {"BdFrq",            0, 0x00000800, DBASE_FATAL},
                              {"BirdieSynth",      0, 0x00001000, DBASE_FATAL},
                              {"Power",            0, 0x00002000, DBASE_NONFATAL},
                              {"SigmaThresh",      0, 0x00004000, DBASE_FATAL},
                              {"ActualThresh",     0, 0x00008000, DBASE_NONFATAL},
                              {"ADC",              0, 0x00010000, DBASE_NONFATAL},
                              {"Polarization",     0, 0x00020000, DBASE_FATAL},
                              {"SpectralRes",      0, 0x00040000, DBASE_NONFATAL},
                              {"TelescopeID",      0, 0x00080000, DBASE_FATAL}
                             };

char *DbaseErrorStatusString[5] = {"No Error", "Filtered", "NonFatal", "Fatal", "Over Limit"};
