//______________________________________________________________________
// Source Code Name  : s4power.cc
// Programmer        : Donnelly/Cobb et al
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
// Date Opened       : 10/96
// This file includes the set of functions to do power computations
//______________________________________________________________________
// modification history:
//______________________________________________________________________

#include <stdio.h>
#include "SIREN.h"

//____________________________________________________________________
// pw_PwrCalc()
// Returns power in units of mean power, given a standard event record.
// The power is the same, only field names differ twixt s3 and s4.
//____________________________________________________________________
 
double pw_PwrCalc(void * StdRecord, char RecordType)
  {
  
  if (RecordType == STDEVENT_REC)
    {
    StdEventRec * StdEvent;

    StdEvent = (StdEventRec *)StdRecord;

    return(StdEvent->usPower * (double)StdEvent->usSigmaThreshold /
           (double)StdEvent->usActualThreshold);
    }

  else if (RecordType == S3_STDEVENT_REC)
    {
    s3_StdEventRec * StdEvent;

    StdEvent = (s3_StdEventRec *)StdRecord;

    return(StdEvent->usPwr * (double)StdEvent->usSigmaThreshold /
           (double)StdEvent->usActualThreshold); 
    }

  else
    {
    return(0.0);
    }
  }
