//______________________________________________________________________
// Source Code Name  : s4utils.cc
// Programmer        : mattl, jeffc, et al.
//                   : Project SERENDIP, University of California, Berkeley CA
// Compiler          : GNU gcc
// Date Opened       : 7/98
// This file includes the set of random C functions which are useful but
// don't really fit in with the other libraries.
//______________________________________________________________________

#include <stdio.h>
#include <string.h>
#include "SIREN.h"

//______________________________________________________________
// ut_GetLastField()
// Will get the last field of a string, given a user-specified delimiter.
// Useful in removing long pathnames to files. It acts just like:
// echo $wholestring | awk -F[delimiter] '{print $NF}'
//______________________________________________________________

void ut_GetLastField(char cDelimiter, char *cWholeString, char *cLastField)
{
  char *cTempPointer;

  if ((cTempPointer = strrchr(cWholeString,cDelimiter)) == NULL)
    strcpy(cLastField,cWholeString);
  else
    strcpy(cLastField,cTempPointer+1);
}

//______________________________________________________________
// ut_GetFirstField()
// Will get the first field of a string, given a user-specified delimiter.
// Useful in removing file extensions.
//______________________________________________________________

void ut_GetFirstField(char cDelimiter, char *cWholeString, char *cFirstField)
{
  char *cTempPointer;
  char *ptr;
  long i;

  if ((cTempPointer = strchr(cWholeString,cDelimiter)) == NULL)
    strcpy(cFirstField,cWholeString);
  else {
    for(ptr = cWholeString, i = 0; ptr < cTempPointer; ptr++, i++) { 
       cFirstField[i] = *ptr;
    }
    cFirstField[i] = '\0';
  }
}

//______________________________________________________________
void ut_GetRootFilename(char *InString, char *Filename)
//______________________________________________________________
{
	char TempStr[512];

        ut_GetLastField('/', InString, TempStr);
        ut_GetFirstField('.', TempStr, Filename);
}
