PRO plot_scoredist, CandidateScoreFile, Title, max=max, BinSize=BinSize, FuncRes=FuncRes

COMMON DistCom, DistModel

; The CandidateScoreFile is a single column file of scores - you'll
; have to awk these out of a candidate file.  "max" is a bad score
; high value, eg, barycentric candidates with scores over 9999 are all 
; assigned a score of 9999.9999.  You don't want to include this 
; bad score catch all bin.

rdcol, CandidateScoreFile, Score

if(NOT keyword_set(max)) then max = max(Score)+1
if(NOT keyword_set(BinSize)) then BinSize = 1

hist = histogram(Score[where(Score LT MAX)], binsize = BinSize)
ScoreAxis = lindgen((size(hist))(1)) + 1

print,hist

DistModel = poly_fit(ScoreAxis, hist, 3)
PerfectDist = dblarr((size(hist))(1) * FuncRes) 
PerfectDistScoreAxis = lindgen((size(PerfectDist))(1)) + 1
for i = 0L, (size(PerfectDist))(1) - 1 do begin
  PerfectDist[i] = DistModel[0]                             +  $ 
                   DistModel[1] * PerfectDistScoreAxis[i]   +  $
                   DistModel[2] * PerfectDistScoreAxis[i]^2 +  $
                   DistModel[3] * PerfectDistScoreAxis[i]^3    
end
print,DistModel

plot, hist, yrange=[0,max(hist)],                             $ 
            psym=10,                                          $
            title=Title+", BinSize = "+string(BinSize) 
oplot,PerfectDist

TotalArea = qromb("ModelFunc", 0 ,99)
print,""
print, TotalArea
NumPercentileBins = 10
X_GivingEqualAreas = dblarr(NumPercentileBins)
A = 0.0d
B = 0.0d
BLow = 0.0d
BHigh = double(max(PerfectDistScoreAxis))
for i = 1L, NumPercentileBins do begin
  ;A = X_GivingEqualAreas[i]
  B = max(PerfectDistScoreAxis)/2
BLow = 0.0d
BHigh = double(max(PerfectDistScoreAxis))
  print,""
  print,""
  AreaTry = qromb("ModelFunc", 0 , B)
  print, "=============> ", AreaTry
  TryResult = AreaTry/TotalArea - double(i)/double(NumPercentileBins)
  print, "== try result ==> ", TryResult
  while abs(TryResult) GT  0.0001d do begin
    if(TryResult LT 0) then begin
      print, "going up.... B = ", B, "  i = ", i
      BLow = B
      B = B + (BHigh - B)/2
    endif else begin
      print, "going down...."
      BHigh = B
      B = B - (B - Blow)/2
    endelse
    AreaTry = qromb("ModelFunc", 0 , B) 
    print, "----------> ", AreaTry
    TryResult = AreaTry/TotalArea - double(i)/double(NumPercentileBins)
  print, "== try result ==> ", TryResult
  endwhile
  X_GivingEqualAreas[i-1] = B
  print, "the answer is ", B
endfor
        
print,"" 
print, X_GivingEqualAreas

for i = 1L, NumPercentileBins do begin
  oplot, [X_GivingEqualAreas[i-1], X_GivingEqualAreas[i-1]], $
         [0, ModelFunc(X_GivingEqualAreas[i-1])]
endfor

print,""
print,""
print,""
print,""
for i = 0, NumPercentileBins-2 do begin
  print,qromb("ModelFunc", 0 , X_GivingEqualAreas[i+1]) - $
        qromb("ModelFunc", 0 , X_GivingEqualAreas[i])
endfor 

end

FUNCTION ModelFunc, x
  COMMON DistCom
  return, DistModel[0]       +  $ 
          DistModel[1] * x   +  $    
          DistModel[2] * x^2 +  $    
          DistModel[3] * x^3  
end

