function nlong,x             ;Nearest Integer Function
;+
; NAME:
;   NINT
; PURPOSE:
;   Nearest integer function
; CALLING SEQUENCE:
;   result = nint(x)
; INPUT:
;   X - An IDL variable, scalar or vector, usually floating or double
;       Must be between -32767.5 and 32767.5 to avoid integer overflow
; OUTPUT
;   RESULT - Nearest integer to X
; EXAMPLE:
;   If X = [-0.9,-0.1,0.1,0.9] then NINT(X) = [-1,0,0,1]
; REVISION HISTORY:
;   Written W. Landsman        January 1989
;-
return,long( x+0.5 - (x lt 0) )
end
