PRO plot_scoredist, CandidateScoreFile, Title, max=max, BinSize=BinSize

; The CandidateScoreFile is a single column file of scores - you'll
; have to awk these out of a candidate file.  "max" is a bad score
; high value, eg, barycentric candidates with scores over 9999 are all 
; assigned a score of 9999.9999.  You don't want to include this 
; bad score catch all bin.

rdcol, CandidateScoreFile, Score

if(NOT keyword_set(max)) then max = max(Score)+1
if(NOT keyword_set(BinSize)) then BinSize = 1

hist = histogram(Score[where(Score LT MAX)], binsize = BinSize)

plot, hist, yrange=[0,max(hist)],                             $ 
            psym=10,                                          $
            title=Title+", BinSize = "+string(BinSize) 

end
