PRO plot_waterfall, filename, Xzoom=Xzoom, Yzoom=Yzoom, $
                    oplot=oplot, user_color=user_color,user_psym=user_psym, user_title=user_title 

COMMON exptime_com               
 
COMMON tickcom_WF, Xdiv 

Xdiv=1e6

if keyword_set(user_title) then title=user_title else title="Waterfall "+filename 

if keyword_set(user_psym) then psym=user_psym else psym=3
if keyword_set(user_color) then color=user_color else color=!p.color

$ rdcol,filename,exptime_freq,exptime_time,d1,d2,d3

if not keyword_set(Xzoom) then Xzoom = double([min(exptime_freq), max(exptime_freq)])
if not keyword_set(Yzoom) then Yzoom = double([min(exptime_time), max(exptime_time)])
 
Xrange = Xzoom[1]-Xzoom[0]
if(Xrange GE 1e6) then begin
  Xrange = Xrange/1e6
  Xunits = "MHz"
endif else begin 
  if (Xrange GE 1e3) then begin
    Xrange = Xrange/1e3 
    Xunits = "KHz" 
  endif else Xunits = "Hz"
endelse

Xtickrange = Xrange/5.0

if keyword_set(oplot) then begin
  oplot,exptime_freq,exptime_time,psym=psym,color=color
endif else begin
  plot,exptime_freq,exptime_time,psym=psym,color=color,             $   
       xrange=Xzoom,yrange=Yzoom,                   $   
       title=title,                                 $
       xtitle="Frequency (MHz)",                    $
       xticks=5,                                    $
       xstyle=3,                                    $
       xtickformat="xticks_WF",                     $ 
       subtitle="Range : "                          $
              +string(Xrange,format='(F8.3)')       $
              +Xunits+"  Ticks : (approx) "         $
              +string(Xtickrange,format='(F8.3)')   $
              +Xunits,                              $
       ytitle="Seconds from begining of file"
endelse

end

;========================================
; This function is particular to the 
; plotting of waterfalls (_WF)
FUNCTION xticks_WF, axis, index, value

COMMON tickcom_WF

return, string(double(value)/double(Xdiv), format='(F8.3)')

end


