pro rdcol,fn,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,	$
x10,x11,x12,x13,x14,x15,x16,x17,x18,x19,	$
x20,x21,x22,x23,x24,x25,x26,x27,x28,x29,	$
x30,x31,x32

;reads up to 16 columns of an ascii file into idl variables
;Uses double precision

;INPUTS:             fn -- filename (string)
;OUTPUTS:            x0 -- data array for 1st column
;OPTIONAL OUTPUTS:   x1,x2,x3,...x16 --  optional output arrays for other
;                    columns in file.
;
; Jonathan Wheatley, ssl, 6-89. 6may91 je from 9 to 16 cols
; 12/30/97 jeffc - for serendip, maxsize to 100000 and i to double
; 9/18/98 jeffc - for serendip, maxsize to 300000

maxsize=300000

nc=n_params()-1
;print,nc
xtemp=dblarr(nc)        
x=dblarr(nc,maxsize)
;
get_lun,l
openr,l,fn
;help,xtemp,x
i=0.0d
while not eof(l) do begin
     readf,l,xtemp
     x(0,i)=xtemp
     i=i+1.0
endwhile
x=x(*,0:i-1)
;help,x
;
for j=0,nc-1 do begin
    s=strtrim(j,2)   
    comm='x'+s+'=transpose(x('+s+',*))'
;    print,comm
    flag=execute(comm)
endfor
print,strtrim(nc,2),' columns with ',strtrim(i,2),' data points were read.'
;
free_lun,l
return
end
