#! /usr/local/bin/perl 

# usage: dbbadadc.pl filename
# takes the flat file <filename> which was output from s4adccheck and places
# bad time ranges into the sah database by generating a SQL script and
# running it.

# What this doesn't do is check for duplicates being added to the database.
# However, what this DOES do is check that we are only times associated with
#  the single engineering value (#2, which contains board #19).

# What's the name of the database?
$dbname = "sah";

# Which engineering value are we worried about?
$whichnum = 2;

# What's the type_flag associated with bad ADC values?
$type_flag = 1;

# Temp SQL filename
$tmpsql = "/tmp/dbbadadc.sql";

if ($ARGV[0] eq "") {
  die ("usage: dbbadadc.pl filename\n")
  }

open (TMPSQL,">$tmpsql");

print TMPSQL "database $dbname;\n";

open (FLATFILE,"$ARGV[0]");

while (<FLATFILE>) {
  chop;
  ($engnum,$start_time,$junk1,$junk2,$end_time,$remainder) = split(/\s/);
  if ($engnum == $whichnum) {
    print TMPSQL "insert into badtime (start_time,end_time,type_flag)\n";
    print TMPSQL "values ($start_time,$end_time,$type_flag);\n";
    }
  }

close (TMPSQL);
exec 'dbaccess -e - '.$tmpsql;
