#! /usr/local/bin/perl 

# usage: dbbirdie.pl filename
# takes the flat file <filename> which was output from s4countbirdie using the
# -br flag, and places the birdies into the sah database by generating a SQL
# script and running it.
#
# What this doesn't do is check for duplicates being added to the database.
# However, what this DOES do is check that we are only injecting the right
#   birdies, that is, those at 1418.999998 and 1420.999998 Hz

# What's the name of the database?
$dbname = "sah";

# What birdies are we looing for?
$birdie1 = 1418999998;
$birdie2 = 1420999998;

# Temp SQL filename
$tmpsql = "/tmp/dbbirdie.sql";

if ($ARGV[0] eq "") {
  die ("usage: dbbirdie.pl filename\n")
  }

open (TMPSQL,">$tmpsql");

print TMPSQL "database $dbname;\n";

open (FLATFILE,"$ARGV[0]");

while (<FLATFILE>) {
  chop;
  ($juldate,$junk1,$junk2,$boardnum,$freq,$power,$ra,$dec) = split(/\s/);
  if (abs($freq - $birdie1) < 1 || abs($freq - $birdie2) < 1) {
    print TMPSQL "insert into birdie (time,freq,power,ra,dec)\n";
    print TMPSQL "values ($juldate,$freq,$power,$ra,$dec);\n";
    }
  }

close (TMPSQL);
exec 'dbaccess -e - '.$tmpsql;
