#! /bin/csh
# Insert all paths/environmental variables for s4pipeline scripts below:

# Pipeline root directory

setenv PIPEROOT $SIRENHOME/scripts/s4pipeline

# What machine must run the s4pipeline 

setenv PIPEHOST kang

# Paths for original raw data and where to place compressed data/dbase files

setenv RAWDATAFROM /disks/cyclops/c/users/seti/data_pipeline
setenv RAWDATATO /disks/cyclops/d/users/seti/post_pipeline_raw_data
setenv DBASEFILESTO /disks/cyclops/d/users/seti/post_pipeline_files

# Where is the log?

setenv PIPELINELOG /disks/cyclops/d/users/seti/pipeline.log

# Where is the pipeline god?

setenv GODPATH $PIPEROOT/lib/s4pipeline_god

# Where is the engine?

setenv ENGINEPATH $PIPEROOT/lib/s4pipeline_engine

# Where is the commander?

setenv COMMANDERPATH $PIPEROOT/lib/s4pipeline_commander

# Where is the table of commands to run during pipeline?

setenv COMMANDTABLE $PIPEROOT/lib/command_table
setenv COMMANDPATH $PIPEROOT/lib/commands

# Where is the table of machines on which to run this pipeline?

setenv MACHINETABLE $PIPEROOT/lib/machine_table

# Where is the table of drives on which to save the post-pipeline remnants? 

setenv DRIVETABLE $PIPEROOT/lib/drive_table

# Where is the compressor?

setenv COMPRESSORPATH $PIPEROOT/lib/s4pipeline_compressor

# Paths for executables

setenv EXEBIN $SIRENHOME/bin
setenv SCRIPTBIN $SIRENHOME/scripts

# Where is the tmp log where error logs are stowed

setenv SHOWLOG /tmp/s4pipeline_showlog.tmp

# Who gets pipeline log e-mail?

setenv PIPEADMIN "`cat $PIPEROOT/lib/pipeline_administrator`"

# How many files should get chewed on before sending the log to PIPEADMIN?

setenv MAXLOGSIZE 50

# Just for now.. should be in .cshrc.local

# setenv S4_SKYPLOT_FILE /disks/cyclops/c/users/seti/s4/siren/db/Skyplot_File 
# setenv S4_SUMM_INDEX /disks/cyclops/c/users/seti/s4/siren/db/Summ_Index_File
# setenv S4_SUMM_FILE /disks/cyclops/c/users/seti/s4/siren/db/Summ_File
# setenv S4_SUMM_ARCHIVES /disks/cyclops/c/users/seti/s4/siren/db/bak
# setenv S4_RECEIVER_CONFIG /disks/cyclops/c/users/seti/s4/siren/db/ReceiverConfig.tab

# Various commands that differ between sunos/solaris

setenv PS_SUN /usr/bin/ps
setenv PS_SOL /usr/ucb/ps

# Lock dir for moving/copying files
setenv LOCKDIR $PIPEROOT/lib

# Due to tightened security
alias rsh /opt/misc/bin/ssh2
