/*
#define DEBUG
#define DEBUG_SLEEP
*/
#define DEBUG_NEWFILE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include "s4Net.h"

#define WORKING_FILE_NAME_DIR "/mydisks/e/users/seti/files/"
#define DATA_DIR "/mydisks/e/users/seti/ao_data"

#define SLEEP_COUNT_1 0.2
#define SLEEP_COUNT_2 0.5
#define CHECK_WAIT (1 / SLEEP_COUNT_1) * 10    // always 10 seconds   

#define NEW_FILE 1
#define NO_NEW_FILE 2
#define NEW_FILE_ERROR 3
#define FILE_NAME_READ_ERROR 4
#define FILE_NAME_WRITE_ERROR 5

unsigned char syncword [8] = {SYNC_WORD_BYTE_0,
                              SYNC_WORD_BYTE_1,
                              SYNC_WORD_BYTE_2,
                              SYNC_WORD_BYTE_3,
                              SYNC_WORD_BYTE_4,
                              SYNC_WORD_BYTE_5,
                              SYNC_WORD_BYTE_6,
                              SYNC_WORD_BYTE_7};

BOOLEAN gbFirstFile = TRUE;

BOOLEAN IsNewFile(time_t when, char* namep, time_t* tp);
BOOLEAN GetLatestFile(char* namep);
time_t mtime(char* name);
void SendNewFileName(FILE *fp, char *sFileName);
void myperror(char * str);

main(int argc, char **argv)
{

FILE * fp;
time_t tFileTime;
FILE * fpWorkingName;

long savep, 
     lWaitCount = 0, 
     lWaitCheck = (long)CHECK_WAIT;

off_t save_size, 
      new_data, 
      readn;

BOOLEAN RealTime = FALSE;

char buff[NET_BUFSIZE];
struct stat statbuf;

char sWorkingName[256];
char sFileName[32];
char ErrMsg[256]; 

setbuf(stdout, NULL);   

if(argc == 1)
  RealTime = TRUE;

if(RealTime)
  while(!GetLatestFile(sFileName))
    sleep(5);
else  
  {
  strcpy(sWorkingName, WORKING_FILE_NAME_DIR);
  strcat(sWorkingName, argv[1]);

  if((fpWorkingName = fopen(sWorkingName, "r")) == NULL)
  {
  sprintf(ErrMsg, "%s%s", "Cannot open for reading: ", sWorkingName);
  myperror(ErrMsg);
  }
  else
  {
  fscanf(fpWorkingName, "%s", sFileName);
  fclose(fpWorkingName);
  }

// Catch no-first-file situation.  Wait for first file
// and write file name to WorkingName file.  Note that
// if there are files in the data dir, the earliest one
// will be chosen.  "NOFLIE" is inserted by the network
// magr script when no file is given on command line.
if(strcmp(sFileName, "NOFILE") == 0)
  {
  tFileTime = 0;    // Find the first file
  while(!IsNewFile(tFileTime, sFileName, &tFileTime))
    sleep(5);
  if((fpWorkingName = fopen(sWorkingName, "w")) == NULL)
    {
    sprintf(ErrMsg, "%s%s", "Cannot open for writing: ", sWorkingName);
    myperror(ErrMsg);
    }
  else
    { 
//  fprintf(stderr, " New FIle : %s\n", sFileName);
    fprintf(fpWorkingName, "%s\n", sFileName);
    fclose(fpWorkingName);
    } 
  }
  }

// Open first file
if((fp = fopen(sFileName, "r")) == NULL)
  {
  sprintf(ErrMsg, "%s : %s : ", "Could not open first file", sFileName);
  myperror(ErrMsg);
  }
else
  {
  fstat(fileno(fp), &statbuf);
  tFileTime = (statbuf.st_mtime);
/*
  if(RealTime)
    {
    save_size = statbuf.st_size;
    fseek(fp, 0, 2);    // go to end 
    }
  else
*/
    {
    save_size = 0;
    }
  savep = ftell(fp);
  SendNewFileName(stdout, sFileName);     /* ... let the other end know   */
  }

/* The read/write loop contains 2 usleep statements.
   They are there to keep the the machine quiet while
   the serendip PC is writting to it's disk via NFS.
   The 2 usleeps should add up roughly to 1 integration
   period (1.7 seconds).  This should be tuned.
*/
while(1)
  {
  /* Wait for new data.  There will be
     no wait 1st time through unless 
     input file is empty. */ 
  lWaitCount = 0;                      /* init wait count here so that we always
                                          wait for the maximum time before checking
                                          for a new file.  This will make it very
                                          unlikely that we will miss data in the 
                                          'old' file when we detect a 'new' file.
                                          This could only be a problem if we figure
                                          out a way to make the PCNFS writes non-
                                          blocking on the PC.
                                       */
  while(statbuf.st_size == save_size)   
    {
    if(lWaitCount == lWaitCheck)       /* every so often, check for file change */
      {
      lWaitCount = 0;
      if(IsNewFile(tFileTime, sFileName, &tFileTime))
        {
        fclose(fp);                              // close old file
        if((fp = fopen(sFileName, "r")) == NULL)
          {
          sprintf(ErrMsg, "%s : %s : ", "Could not open new file", sFileName);
          myperror(ErrMsg);
          }
        else 
          {
          if(!RealTime)
            {                                       /* there IS a file change so... */
                                                    /* ... checkpoint               */
fprintf(stderr, "Checkpointing\n");

            if((fpWorkingName = fopen(sWorkingName, "w")) == NULL)
              {
              sprintf(ErrMsg, "%s%s", "Cannot open for writing: ", sWorkingName);
              myperror(ErrMsg);
              }
            else
              {
fprintf(stderr, "sWorkingName is %s; sFileName is %s\n", sWorkingName, sFileName);
              fprintf(fpWorkingName, "%s\n", sFileName);
              fclose(fpWorkingName);
              } 
            }
          save_size = 0;                          /* ... reinit                   */
          savep = ftell(fp);
          SendNewFileName(stdout, sFileName);     /* ... let the other end know   */
          }                                       /* ... then just carry on       */
        }
      }                                           /* end check for file change    */
    usleep((unsigned)(SLEEP_COUNT_1 * 1000000));                           
    fstat(fileno(fp), &statbuf);      /* get new file size */
    lWaitCount++;
    }
 
  /* Prep to read as much data as we can */
  usleep((unsigned)(SLEEP_COUNT_2 * 1000000));    /* let data accumulate for .5 sec */
  fstat(fileno(fp), &statbuf);              /* get new file size */
  new_data = statbuf.st_size - save_size;   /* get amount of new data */
  save_size = statbuf.st_size;              /* save new file size */
  fseek(fp, savep, 0);                      /* go to new data */

  /* read/write new data - this will get into endless loop if new file
     does not exist - statbuf will be for previous file and fread rtn will = 0 */
  while(new_data > 0)
    {
    if(new_data > NET_BUFSIZE)
      readn = NET_BUFSIZE;
    else
      readn = new_data; 
    new_data -= fread(buff, 1, readn, fp);
    fwrite(buff, 1, readn, stdout);
    }

  /* save where we are.  Do fstat's destroy the pointer? */
  savep = ftell(fp);

  } /* end main while loop */

} /* end main() */


/* ------------------------------------------------------------- */
BOOLEAN IsNewFile(time_t when, char* namep, time_t* tp)
// Function by Dave Anderson
/* ------------------------------------------------------------- */
{
    DIR* dirp;
    struct dirent* dep;
    struct stat buf;
    struct dirent de;
    time_t best=0;

    dirp = opendir(DATA_DIR);
    while (1) {
	dep = readdir(dirp);
	if (!dep) break;
	if (dep->d_name[0] == '.') continue;
	stat(dep->d_name, &buf);
	if (buf.st_mtime <= when) continue;
	if (best == 0 || buf.st_mtime < best) {
	    de = *dep;
	    best = buf.st_mtime;
	}
    }
    closedir(dirp);
    if (best) {
       *tp = best;
       if(strcmp(namep, de.d_name) != 0) {
	  strcpy(namep, de.d_name);
	  return TRUE;
       } else {
          return FALSE;
       }
    } else {
	return FALSE;
    }
}

/* ------------------------------------------------------------- */
BOOLEAN GetLatestFile(char* namep)
/* ------------------------------------------------------------- */
{
    DIR* dirp;
    struct dirent* dep;
    struct stat buf;
    struct dirent de;
    time_t best=0;

    dirp = opendir(DATA_DIR);
    while (1) {
        dep = readdir(dirp);
        if (!dep) break;
        if (dep->d_name[0] == '.') continue;
        stat(dep->d_name, &buf);
        if (best == 0 || buf.st_mtime > best) {
            de = *dep;
            best = buf.st_mtime;
        }
    }    
    closedir(dirp);
    if (best) {
      strcpy(namep, de.d_name);
      return TRUE;
    } else {
        return FALSE;
    }
}


/* ------------------------------------------------------------- */
time_t mtime(char* name)
/* ------------------------------------------------------------- */
{
    struct stat buf;
    stat(name, &buf);
    return buf.st_mtime;
}

/* ------------------------------------------------------------- */
void SendNewFileName(FILE *fp, char *sFileName)
/* ------------------------------------------------------------- */
  {
  fwrite((char *)syncword, sizeof(syncword), 1, fp);
  fwrite((char *)sFileName, FILENAME_LEN, 1, fp);
  }

/* ------------------------------------------------------------- */
void myperror(char * str)
/* ------------------------------------------------------------- */
  {
  perror(str);
  exit(1);
  }

