//____________________________________________________________________
// Source File Name   : s3converts4.cc
// Programmre         : Jeff Cobb
// Date opened        : July 1996
// Purpose            : Converts from s4 dbase data format to
//                      s3 dbase data format.  This is needed
//                      in the early stages of SERENDIP IV in
//                      to use some s3 data analysis programs
//                      before they are ported to s4.			
//____________________________________________________________________

#include <stdio.h>
#include <string.h>
#include "SIREN.h"
#include "s4io.h"

#define linefrmt "%s %7.4f %7.3f %12.7f %6ld %10ld %5u %5u %2u %.6s %2hx %1hx\n"

main(int argc, char ** argv)
  {

  StdEventRec s4event;
  s3_StdEventRec s3event;

  long BoardNbr;

  BoardNbr = atol(argv[1]);

  while(io_GetNextRecord(stdin,(void *)&s4event,STDEVENT_REC))
    {
    if(s4event.ucBid == BoardNbr)
      {
    s4event.stUTime[6]            = '\0';
    strcpy(s3event.stDate,          s4event.stDate);
    strcpy(s3event.stStrTime,       s4event.stUTime);
    s3event.dbRa                  = s4event.dbRa;
    s3event.dbDec                 = s4event.dbDec;
    s3event.usSigmaThreshold      = s4event.usSigmaThreshold;
    s3event.usActualThreshold     = s4event.usActualThreshold;
    s3event.usAdc                 = s4event.usAdc;
    s3event.usPwr                 = s4event.usPower;
    s3event.usSpectralRes         = s4event.usSpctResLog;
    s3event.lBinNo                = s4event.lBinNumber;
    s3event.lSynth                = s4event.ulFftBdFreq;
    s3event.dbLocos               = s4event.dbFirstLo + s4event.dbSecondLo;
    
    printf(linefrmt
            ,s3event.stStrTime,s3event.dbRa,s3event.dbDec,s3event.dbLocos,s3event.lSynth
            ,s3event.lBinNo,s3event.usPwr,s3event.usActualThreshold,s3event.usAdc,s3event.stDate
            ,s3event.usSigmaThreshold, s3event.usSpectralRes); 
      }
    }
  }
