//____________________________________________________________________
// Source File Name   : s4converts3B.cc
// Programmer         : Brendan Doyle
// Date opened        : Jan 1995
// Purpose            : Reads a file in the old s3 dbase format (from 
//                      stdin) one line at a time, determines whether
//                      each record is a data record or a comment or
//                      blank line, and writes them out as s4 type 'B'
//                      or type '#' (comment) records to stdout.
//____________________________________________________________________

#include <stdio.h>
#include "SIREN.h"
#include "s4io.h"

#define InLineOldS3Format "%s %lf %lf %lf %ld %ld %hu %hu %hu %s %hx %hx"

main()
  {
  s3_StdEventRec ThisEvent;
  char thisRecord[MAX_LINE_LENGTH];

  while (gets(thisRecord))
    // determine if data record or comment/blank line
    if (sscanf(thisRecord,InLineOldS3Format,
               ThisEvent.stStrTime,&ThisEvent.dbRa,&ThisEvent.dbDec,
               &ThisEvent.dbLocos,&ThisEvent.lSynth,&ThisEvent.lBinNo,
               &ThisEvent.usPwr,&ThisEvent.usActualThreshold,
               &ThisEvent.usAdc,ThisEvent.stDate,
               &ThisEvent.usSigmaThreshold,&ThisEvent.usSpectralRes) == 12)
      //if data record, write type 'B' record
      io_WriteS3StdEvent(stdout,&ThisEvent);
    else
      //if comment or blank line, write type '#' record
      printf("# %s\n",thisRecord);
  }
