/* ________________________________________________________________________
 programmer : Jeff Cobb
 source name: s4contigbin.cc
 compiler   : gcc
___________________________________________________________________________
 modification history:
   version 1.0 finished 11/12/00
___________________________________________________________________________
 description: This program reads a dbase file and outputs (in ASCII) the
 bin number for each event in contiguous FFT bin space.  With the -r 
 operand, it will output the possible range of such bin numbers.
___________________________________________________________________________
*/

#include <stdio.h>
#include <string.h>
#include "SIREN.h"
#include "s4io.h"

StdEventRec Event;

main(int argc, char ** argv) {

  if(argc == 2 && strcmp(argv[1], "-r") == 0) {
	fprintf(stdout, "%ld %lu\n", LOW_CONTIGBIN, HIGH_CONTIGBIN);
  } else {
  	while(io_GetNextRecord(stdin,(void *)&Event,STDEVENT_REC)) {
		fprintf(stdout,"%ld\n", CONTIGBIN(Event.lBinNumber, Event.ucBid));
	}
  }
}
