/*
 * Source Code Name  : s4copydb.cc
 * Programmer        : Matt Lebofsky
 *                   : Project SERENDIP, University of California, Berkeley CA
 * Compiler          : GNU gcc
 *
 * Makes a copy of the current s4 summary database using the
 * filenames supplied by the user, employing the use of the s4 summary
 * database file locking mechanisms.
 *
 */

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "SIREN.h"
#include "s4database.h"
#include "s4summary.h"

#define VERSION 1.0

const char * usage = "usage : s4copydb to_filename to_indexname";

int main(int argc, char ** argv)
  {
  // long i, Num;
  int DB;
  char CopyFile[100];
  char CopyIndex[100];
  char TmpCommand[130];

  // DbaseSumRcd_t ThisRcd;

  if(argc < 3)
    {
    fprintf(stderr,"%s\n", usage);
    exit(1);
    }

  strcpy(CopyFile, argv[1]);
  strcpy(CopyIndex, argv[2]);

  DB = sum_GetDataBase(O_RDWR);

  sprintf(TmpCommand,"/bin/cp %s %s",getenv("S4_SUMM_FILE"),CopyFile);
  system(TmpCommand);
  sprintf(TmpCommand,"/bin/cp %s %s",getenv("S4_SUMM_INDEX"),CopyIndex);
  system(TmpCommand);

  sum_ReleaseDataBase(DB);

}
