/* 
 * s4jul2file - mattl 10/22/02
 * quick utility that takes julian date and then
 * does its best to match this to a file name via
 * looking at dates in the summary database
*/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "SIREN.h"
#include "s4database.h"
#include "s4summary.h"

#define VERSION 1.0

const char * usage = "usage : s4jul2file julian_data\n";

int main(int argc, char ** argv)
  {
  // long i;
  long Num;
  int DB;
  // long lBoardNum;
  char Date1[DBASE_FILENAME_LEN] = "01ja90aa";
  char Date2[DBASE_FILENAME_LEN] = "01ja10aa";
  char TestDate[DBASE_FILENAME_LEN];
  double dbJulDate;

  DbaseSumRcd_t ThisRcd;

  if(argc < 1)
    {
    fprintf(stderr,"%s\n", usage);
    exit(1);
    }

  sscanf(argv[1],"%lf",&dbJulDate);

  DB = sum_GetDataBase(O_RDONLY);
  Num = sum_GetNumInDateRange(Date1, Date2, DB);
  strcpy(TestDate, Date1);
  while(sum_GetNextRcd(TestDate, &ThisRcd, FALSE, DB, O_RDONLY) && 
        strcmp(TestDate, Date2) != 0)
    {
    if ((dbJulDate + 0.000001) >= ThisRcd.dbStartTime && (dbJulDate - 0.0000001) <= (ThisRcd.dbStartTime + (ThisRcd.dbFileDuration/24)))
      fprintf(stdout,"%lf: %s\n", dbJulDate, ThisRcd.sDbaseName);
    }
  // catch the last one
  if(strcmp(TestDate, Date2) == 0)
    if (dbJulDate >= ThisRcd.dbStartTime && dbJulDate <= (ThisRcd.dbStartTime + (ThisRcd.dbFileDuration/24)))
      fprintf(stdout,"%lf: %s\n", dbJulDate, ThisRcd.sDbaseName);
  sum_GetNextRcd(TestDate, &ThisRcd, TRUE, DB, O_RDONLY);

}
