/*
 * Source Code Name  : s4listsummdb.cc
 * Programmer        : Jeff Cobb
 *                   : Project SERENDIP, University of California, Berkeley CA
 * Compiler          : GNU gcc
 *
 * Given a date range in "dbase form" (eg 01ap98 05ma99), this program
 * simply lists the dbase filenames that exist in the s4 summary database,
 * within this date range, inclusive.
 *
 * This program also serves as a simple template for crafting more 
 * complex summary database inquiries.
 */
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "SIREN.h"
#include "s4database.h"
#include "s4summary.h"

#define VERSION 1.0

const char * usage = "usage : s4listsummdb startdate enddate";

main(int argc, char ** argv)
  {
  long Num;
  int DB;
  char Date1[DBASE_FILENAME_LEN];
  char Date2[DBASE_FILENAME_LEN];
  char TestDate[DBASE_FILENAME_LEN];

  DbaseSumRcd_t ThisRcd;

  if(argc < 3)
    {
    fprintf(stderr,"%s\n", usage);
    exit(1);
    }

  strcpy(Date1, argv[1]);
  strcpy(Date2, argv[2]);

  DB = sum_GetDataBase(O_RDONLY);
  Num = sum_GetNumInDateRange(Date1, Date2, DB);
  strcpy(TestDate, Date1);
  while(sum_GetNextRcd(TestDate, &ThisRcd, FALSE, DB, O_RDONLY) && 
        strcmp(TestDate, Date2) != 0)
    {
    fprintf(stdout, "%s\n", ThisRcd.sDbaseName);
    }
  if(strcmp(TestDate, Date2) == 0)
    fprintf(stdout, "%s\n", ThisRcd.sDbaseName);   // catch the last one
  sum_GetNextRcd(TestDate, &ThisRcd, TRUE, DB, O_RDONLY);

fprintf(stdout, "First : %s   Last : %s   Num in range : %ld\n", Date1, Date2, Num);

}
