/* ________________________________________________________________________
 programmer : Matt Lebofsky
 source name: s4addsky.cc
 compiler   : gcc
___________________________________________________________________________
 modification history:
   version 1.0 finished 8/10/98
___________________________________________________________________________
 usage: s4removeskyplot dbase_file
 scans skyplot dbase and removes observation data matching dbase_file
___________________________________________________________________________
notes/bugs:
___________________________________________________________________________
*/

#include <stdio.h>
#include "SIREN.h"
#include "s4database.h"
#include "s4io.h"
#include "s4utils.h"
#include "s4skyplot.h"

// ------------------------------------------------------------------------
int main (int argc, char *argv[])
// ------------------------------------------------------------------------
{

SkyplotElement *stSkyArray;
int iSkyplotFileNo;
long lArraySize;
long lCurrentIndex;
char cDbaseFileName[20];

if (argc != 2) {
  fprintf(stderr, "Usage: s4removeskyplot dbase_file\n");
  exit(1);
  }

if ((lArraySize = sp_ReadSkyplotFile(&stSkyArray,&iSkyplotFileNo)) == -1)
  exit(1);

ut_GetLastField('/',argv[1],cDbaseFileName); /* strip off path to dbase file */

for (lCurrentIndex = 0; lCurrentIndex < 360000; lCurrentIndex++)
  sp_RemoveObs(lCurrentIndex,cDbaseFileName,&stSkyArray,iSkyplotFileNo);

sp_CloseSkyplotFile(iSkyplotFileNo);
}
