/* ________________________________________________________________________
 programmer : Matt Lebofsky
 source name: s4tos3skyplot.cc
 compiler   : gcc
___________________________________________________________________________
 modification history:
   version 1.0 finished 6/29/98
___________________________________________________________________________
 usage: s4tos3skyplot s3skyplot_dbase
 converts s4skyplot linked-list style dbase to the simpler
 s3skyplot "2-D array of unsigned chars" dbase.
___________________________________________________________________________
notes/bugs:
___________________________________________________________________________
*/


#include <stdio.h>
#include "SIREN.h"
#include "s4database.h"
#include "s4io.h"
#include "s4skyplot.h"

// ------------------------------------------------------------------------
int main (int argc, char *argv[])
// ------------------------------------------------------------------------
{

SkyplotElement *stSkyArray;
int iSkyplotFileNo;
long lArraySize;
FILE *fS3SkyplotFile;
long lRaIndex,lDecIndex;
unsigned char ucS3SkyplotArray[SKYPLOT_HEIGHT][SKYPLOT_WIDTH];

if (argc != 2) {
  fprintf(stderr, "Usage: s4tos3skyplot s3skyplot_dbase\n");
  exit(1);
  }

if ((fS3SkyplotFile = fopen(argv[1],"w")) == NULL) {
  fprintf(stderr,"Can't write s3skyplot file: %s\n",argv[2]);
  exit(1);
  }

if ((lArraySize = sp_ReadSkyplotFile(&stSkyArray,&iSkyplotFileNo)) == -1) {
  exit(1);
  }

for (lRaIndex = 0; lRaIndex < 1800; lRaIndex++) 
  for (lDecIndex = 0; lDecIndex < 200; lDecIndex++)
    ucS3SkyplotArray[lDecIndex][lRaIndex] = 
    (unsigned char) sp_CountObs(SKYPLOT_R_CONVERT_RA(lRaIndex),
                SKYPLOT_R_CONVERT_DEC(lDecIndex),stSkyArray); 

fwrite((char *)ucS3SkyplotArray,sizeof(char),(SKYPLOT_WIDTH*SKYPLOT_HEIGHT),
       fS3SkyplotFile);
fclose(fS3SkyplotFile);
sp_CloseSkyplotFile(iSkyplotFileNo);
}
