//____________________________________________________________________
// Source File Name   : s4slew.cc
// Programmre         : jeffc
// Date opened        : 8/17/99
// Purpose            : Given a dbase file as stdin, this 
//                      program outputs a spectra by spectra
//                      slewrate.  With the -m option, it will
//                      output the mean slewrate only.  Slewrate  
//                      is given in degrees per second.
//____________________________________________________________________

#include <stdio.h>
#include <string.h>
#include "SIREN.h"
#include "s4io.h"
#include "s4coord.h"

StdEventRec PriorEvent, Event;

int main(int argc, char ** argv)
  {
  double angle, time, Slew, TotalSlew;
  BOOLEAN OutputMean = FALSE;
  long NumSlews = 0;

  if(argc == 2 && strcmp(argv[1], "-m") == 0)
	OutputMean = TRUE;

  io_GetNextRecord(stdin,(void *)&PriorEvent,STDEVENT_REC);
  while(io_GetNextRecord(stdin,(void *)&Event,STDEVENT_REC)) {
	angle = co_SkyAngle(PriorEvent.dbRa, PriorEvent.dbDec, Event.dbRa, Event.dbDec);
	if(Event.dbJulDate != PriorEvent.dbJulDate) {
		time  = (Event.dbJulDate - PriorEvent.dbJulDate) * 86400;
		Slew = angle/time;
		if(!OutputMean)
			fprintf(stdout, "%lf %lf\n", Slew, angle);
		else {
			TotalSlew += Slew;
			NumSlews++;
			}
		}
	PriorEvent = Event;
	}
  if(OutputMean)
	fprintf(stdout, "%lf\n", TotalSlew/NumSlews);

  return 0;
  }
