#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
#include "SIREN.h"
#include "s4database.h"
#include "s4summary.h"
#include "s4oldsummstruct.h"
#include "s4error.h"

// get old summary database, read in the structs one by one
// via the s4oldsummstruct format, then write to new database located at the
// stardard location (via the environmental variables).


main(int argc, char ** argv) {

  int i = 0;

  int DB;
  unsigned long SummDbIndex;

  char * DbaseName;

  int InputFile;

  if (argc != 2) {
    fprintf(stderr,"usage: s4makenewdb old_dbase_filename\n");
    exit(1);
    }

  if ( (InputFile = open(argv[1], O_RDONLY)) == -1) {
    fprintf(stderr,"cannot open old db file: %s\n",argv[1]);
    exit(1);
    }

  DbaseSumRcd_t DbaseSumRcd;
  OldDbaseSumRcd_t OldDbaseSumRcd;

  DB = sum_GetDataBase(O_RDWR);     // get new summary database ready

  while (read(InputFile,&OldDbaseSumRcd,sizeof(OldDbaseSumRcd_t))) {
    SummDbIndex  = sum_GetRcd(OldDbaseSumRcd.sDbaseName, &DbaseSumRcd, DB, O_RDWR);
    fprintf(stdout, "Index: %ld Name: %s\n", SummDbIndex,OldDbaseSumRcd.sDbaseName);

    // merging goes on here.
for (i=0;i<11;i++) DbaseSumRcd.sDbaseName[i] = OldDbaseSumRcd.sDbaseName[i];
DbaseSumRcd.ulFlags = OldDbaseSumRcd.ulFlags;
DbaseSumRcd.usSigmaThreshold = OldDbaseSumRcd.usSigmaThreshold;
DbaseSumRcd.usDupScopeStrings = OldDbaseSumRcd.usDupScopeStrings;
DbaseSumRcd.ulNumSpectra = OldDbaseSumRcd.ulNumSpectra;
DbaseSumRcd.ulTotalHits = OldDbaseSumRcd.ulTotalHits;
DbaseSumRcd.ulNoStringHits = OldDbaseSumRcd.ulNoStringHits;
DbaseSumRcd.ulErrSynth = OldDbaseSumRcd.ulErrSynth;
DbaseSumRcd.ulErrVectWarn = OldDbaseSumRcd.ulErrVectWarn;
DbaseSumRcd.ulErrOverRun = OldDbaseSumRcd.ulErrOverRun;
DbaseSumRcd.ulErrArithOvfl = OldDbaseSumRcd.ulErrArithOvfl;
DbaseSumRcd.ulErrBdNotReady = OldDbaseSumRcd.ulErrBdNotReady;
DbaseSumRcd.ulErrOther = OldDbaseSumRcd.ulErrOther;
DbaseSumRcd.ulSetiAtHomeBoardCount = OldDbaseSumRcd.ulSetiAtHomeBoardCount;
for (i=0;i<NUMBOARDS;i++) DbaseSumRcd.ucBoardKiloCount[i] = OldDbaseSumRcd.ucBoardKiloCount[i];
DbaseSumRcd.dbFirstLo = OldDbaseSumRcd.dbFirstLo;
DbaseSumRcd.dbSecondLo = OldDbaseSumRcd.dbSecondLo;
DbaseSumRcd.dbMeanScopeStringInterval = OldDbaseSumRcd.dbMeanScopeStringInterval;
DbaseSumRcd.dbMeanSlew = OldDbaseSumRcd.dbMeanSlew;
DbaseSumRcd.dbTrackingTime = OldDbaseSumRcd.dbTrackingTime;
DbaseSumRcd.dbStartRa = OldDbaseSumRcd.dbStartRa;
DbaseSumRcd.dbEndRa = OldDbaseSumRcd.dbEndRa;
DbaseSumRcd.dbStartDec = OldDbaseSumRcd.dbStartDec;
DbaseSumRcd.dbEndDec = OldDbaseSumRcd.dbEndDec;
DbaseSumRcd.dbStartTime = OldDbaseSumRcd.dbStartTime;
DbaseSumRcd.dbFileDuration = OldDbaseSumRcd.dbFileDuration;
DbaseSumRcd.lDbaseErrors = OldDbaseSumRcd.lDbaseErrors;
DbaseSumRcd.lDbaseErrorStatus = OldDbaseSumRcd.lDbaseErrorStatus;
DbaseSumRcd.ulDbaseErrorType = OldDbaseSumRcd.ulDbaseErrorType;
DbaseSumRcd.dbDbaseBadLimit = OldDbaseSumRcd.dbDbaseBadLimit;
DbaseSumRcd.lMinAcceptedADC = OldDbaseSumRcd.lMinAcceptedADC;
DbaseSumRcd.lMaxAcceptedADC = OldDbaseSumRcd.lMaxAcceptedADC;
DbaseSumRcd.lMinADC = OldDbaseSumRcd.lMinADC;
DbaseSumRcd.lMaxADC = OldDbaseSumRcd.lMaxADC;
DbaseSumRcd.lADC0BadCount = OldDbaseSumRcd.lADC0BadCount;
DbaseSumRcd.lADC1BadCount = OldDbaseSumRcd.lADC1BadCount;
DbaseSumRcd.lADC2BadCount = OldDbaseSumRcd.lADC2BadCount;
DbaseSumRcd.lADC3BadCount = OldDbaseSumRcd.lADC3BadCount;
DbaseSumRcd.lADC4BadCount = OldDbaseSumRcd.lADC4BadCount;
DbaseSumRcd.lDisabledCount = OldDbaseSumRcd.lDisabledCount;
DbaseSumRcd.lMaxPowerHistogrammedBefore = OldDbaseSumRcd.lMaxPowerHistogrammedBefore;
DbaseSumRcd.lNumEventsOverMaxPowerBefore = OldDbaseSumRcd.lNumEventsOverMaxPowerBefore;
DbaseSumRcd.lPoissonNumEventsBefore = OldDbaseSumRcd.lPoissonNumEventsBefore;
DbaseSumRcd.lPoissonBinWidthBefore = OldDbaseSumRcd.lPoissonBinWidthBefore;
DbaseSumRcd.lPoissonNumBinsBefore = OldDbaseSumRcd.lPoissonNumBinsBefore;
DbaseSumRcd.lPoissonMaxEventsBefore = OldDbaseSumRcd.lPoissonMaxEventsBefore;
DbaseSumRcd.dbPoissonChiSqrBefore = OldDbaseSumRcd.dbPoissonChiSqrBefore;
DbaseSumRcd.lMaxPowerHistogrammedAfter = OldDbaseSumRcd.lMaxPowerHistogrammedAfter;
DbaseSumRcd.lNumEventsOverMaxPowerAfter = OldDbaseSumRcd.lNumEventsOverMaxPowerAfter;
DbaseSumRcd.lPoissonNumEventsAfter = OldDbaseSumRcd.lPoissonNumEventsAfter;
DbaseSumRcd.lPoissonBinWidthAfter = OldDbaseSumRcd.lPoissonBinWidthAfter;
DbaseSumRcd.lPoissonNumBinsAfter = OldDbaseSumRcd.lPoissonNumBinsAfter;
DbaseSumRcd.lPoissonMaxEventsAfter = OldDbaseSumRcd.lPoissonMaxEventsAfter;
DbaseSumRcd.dbPoissonChiSqrAfter = OldDbaseSumRcd.dbPoissonChiSqrAfter;
DbaseSumRcd.ulRfiFilterEventsIn = OldDbaseSumRcd.ulRfiFilterEventsIn;
DbaseSumRcd.ulRfiFilterEventsOut = OldDbaseSumRcd.ulRfiFilterEventsOut;
DbaseSumRcd.ulRfiFilterExpectedOut = OldDbaseSumRcd.ulRfiFilterExpectedOut;
DbaseSumRcd.ulGoodTime = OldDbaseSumRcd.ulGoodTime;
DbaseSumRcd.dbPassBand_FreqRes = OldDbaseSumRcd.dbPassBand_FreqRes;
DbaseSumRcd.dbPassBand_NumBeams = OldDbaseSumRcd.dbPassBand_NumBeams;
DbaseSumRcd.ulPassBand_Limit = OldDbaseSumRcd.ulPassBand_Limit;
DbaseSumRcd.ulPassBand_NumRej = OldDbaseSumRcd.ulPassBand_NumRej;
DbaseSumRcd.ulPassBand_NumNewRej = OldDbaseSumRcd.ulPassBand_NumNewRej;
DbaseSumRcd.dbPassBand_DeadFreqBand = OldDbaseSumRcd.dbPassBand_DeadFreqBand;
DbaseSumRcd.dbSpreadSpectrum_EntropyLimit = OldDbaseSumRcd.dbSpreadSpectrum_EntropyLimit;
DbaseSumRcd.ulSpreadSpectrum_EventLimit = OldDbaseSumRcd.ulSpreadSpectrum_EventLimit;
DbaseSumRcd.dbSpreadSpectrum_SigmaLimit = OldDbaseSumRcd.dbSpreadSpectrum_SigmaLimit;
DbaseSumRcd.ulSpreadSpectrum_NumRej = OldDbaseSumRcd.ulSpreadSpectrum_NumRej;
DbaseSumRcd.ulSpreadSpectrum_NumNewRej = OldDbaseSumRcd.ulSpreadSpectrum_NumNewRej;
DbaseSumRcd.ulSlowSlew_DeltaSecs = OldDbaseSumRcd.ulSlowSlew_DeltaSecs;
DbaseSumRcd.ulSlowSlew_BaSecs = OldDbaseSumRcd.ulSlowSlew_BaSecs;
DbaseSumRcd.dbSlowSlew_Limit = OldDbaseSumRcd.dbSlowSlew_Limit;
DbaseSumRcd.ulSlowSlew_NumRej = OldDbaseSumRcd.ulSlowSlew_NumRej;
DbaseSumRcd.ulSlowSlew_NumNewRej = OldDbaseSumRcd.ulSlowSlew_NumNewRej;
DbaseSumRcd.ulSlowSlew_SpectraLost = OldDbaseSumRcd.ulSlowSlew_SpectraLost;
DbaseSumRcd.dbFastSlew_Dps = OldDbaseSumRcd.dbFastSlew_Dps;
DbaseSumRcd.ulFastSlew_NumRej = OldDbaseSumRcd.ulFastSlew_NumRej;
DbaseSumRcd.ulFastSlew_NumNewRej = OldDbaseSumRcd.ulFastSlew_NumNewRej;
DbaseSumRcd.ulFastSlew_SpectraLost = OldDbaseSumRcd.ulFastSlew_SpectraLost;
DbaseSumRcd.ulDrfiNumSectors = OldDbaseSumRcd.ulDrfiNumSectors;
DbaseSumRcd.ulDrfiRadiusInSeconds = OldDbaseSumRcd.ulDrfiRadiusInSeconds;
DbaseSumRcd.ulDrfiBeamsForBeamres = OldDbaseSumRcd.ulDrfiBeamsForBeamres;
DbaseSumRcd.ulDrfiTimeExpansionFactor = OldDbaseSumRcd.ulDrfiTimeExpansionFactor;
DbaseSumRcd.dbDrfiTimeResolution = OldDbaseSumRcd.dbDrfiTimeResolution;
DbaseSumRcd.ulDrfiGapFactor = OldDbaseSumRcd.ulDrfiGapFactor;
DbaseSumRcd.ulDrfiRejectionThreshold = OldDbaseSumRcd.ulDrfiRejectionThreshold;
DbaseSumRcd.ulDrfiNumEvents = OldDbaseSumRcd.ulDrfiNumEvents;
DbaseSumRcd.dbDrfiSpectraDensity = OldDbaseSumRcd.dbDrfiSpectraDensity;
DbaseSumRcd.dbDrfiTimeTicks = OldDbaseSumRcd.dbDrfiTimeTicks;
DbaseSumRcd.ulDrfiNumSemicircles = OldDbaseSumRcd.ulDrfiNumSemicircles;
DbaseSumRcd.dbDrfiRaRes = OldDbaseSumRcd.dbDrfiRaRes;
DbaseSumRcd.dbDrfiDecRes = OldDbaseSumRcd.dbDrfiDecRes;
DbaseSumRcd.ulDrfiNumRfiEvents = OldDbaseSumRcd.ulDrfiNumRfiEvents;
DbaseSumRcd.ulDrfiNumCleanEvents = OldDbaseSumRcd.ulDrfiNumCleanEvents;
for (i=0;i<48;i++) DbaseSumRcd.ucBirdieSeenPercentages[i] = OldDbaseSumRcd.ucBirdieSeenPercentages[i];
DbaseSumRcd.ullMirrorSeen = OldDbaseSumRcd.ullMirrorSeen;
DbaseSumRcd.ulNumGroups = OldDbaseSumRcd.ulNumGroups;
DbaseSumRcd.fPcdbaseVers = OldDbaseSumRcd.fPcdbaseVers;
DbaseSumRcd.fDbasCheckVers = OldDbaseSumRcd.fDbasCheckVers;
DbaseSumRcd.fEngmonrecreaderVers = OldDbaseSumRcd.fEngmonrecreaderVers;
DbaseSumRcd.fPwrHstBeforeVers = OldDbaseSumRcd.fPwrHstBeforeVers;
DbaseSumRcd.fPwrHstAfterVers = OldDbaseSumRcd.fPwrHstAfterVers;
DbaseSumRcd.fBinHstBeforeVers = OldDbaseSumRcd.fBinHstBeforeVers;
DbaseSumRcd.fBinHstAfterVers = OldDbaseSumRcd.fBinHstAfterVers;
DbaseSumRcd.fPoissonBeforeVers = OldDbaseSumRcd.fPoissonBeforeVers;
DbaseSumRcd.fPoissonAfterVers = OldDbaseSumRcd.fPoissonAfterVers;
DbaseSumRcd.fRfiFilterVers = OldDbaseSumRcd.fRfiFilterVers;
DbaseSumRcd.fS4drfiVers = OldDbaseSumRcd.fS4drfiVers;
DbaseSumRcd.fCountBirdieVers = OldDbaseSumRcd.fCountBirdieVers;
DbaseSumRcd.fMulthitVers = OldDbaseSumRcd.fMulthitVers;
DbaseSumRcd.fBeamfitVers = OldDbaseSumRcd.fBeamfitVers;
DbaseSumRcd.ucTid = OldDbaseSumRcd.ucTid;

    sum_PutRcd(SummDbIndex, &DbaseSumRcd, DB);

    }

  sum_ReleaseDataBase(DB);


  }
